# Russell [![Build Status](https://travis-ci.org/anlutro/russell.png?branch=master)](https://travis-ci.org/anlutro/russell)

A static HTML site generator written in Python 3.

## Installation

The recommended way to install Russell is to first create a virtualenv and install russell:

	$ mkdir /home/myuser/blog
	$ cd /home/myuser/blog
	$ python3 -m venv .venv
	$ source ./.venv/bin/activate
	$ pip install russell

Once that's done, you can either manually create the required files, or let Russell set up an example project for you:

	$ russell setup .

Alternatively, you can install russell globally and let it create the virtualenv for you. Outside of any virtualenv:

	$ pip install --user russell
	$ ~/.local/bin/russell setup /home/myuser/blog

## Usage

`russell setup` will set up an example configuration file and directory
structure in the current working directory to get you started.

### Creating pages/posts

`russell new page "My Test Page"` will create the file 'pages/my-test-page.md',
which you can then open in your favourite text editor. The process is the same
for `russell new post`. You can change the filename yourself to modify what the
resulting .html file will be named.

### Generating the blog

`russell generate` will create a file `run.py` which you can invoke to generate
your static site.

To test your newly generated site, run `russell serve`.

### Templating

Jinja2 is used as a templating engine, and all its features are present.

Read the Jinja2 documentation here: http://jinja.pocoo.org/

`root_url` has been added as a global variable, which you can use for generating
URLs in your template.

The "index" and "archive" templates have the `posts` variable available. The
"post" template has the `post` variable and "page" has the `page` variable.
`posts` is an array of `Post` objects, the others are a single instance of
either `Post` or `Page`.

## License

The contents of this repository are released under the [GPL v3 license](https://opensource.org/licenses/GPL-3.0). See the [LICENSE](LICENSE) file included for more information.

Copyright 1986-1989 Hans-Juergen Boehm, Alan J. Demers, Kumar Srikantan,
Vernon Lee, and Lucy Hederman.
Copyright Digital Equipment Corporation & INRIA 1988, 1989.
Copyright (c) 1990-1993 by Xerox Corporation.  All rights reserved.

This material is provided as is, with no warranty expressed or implied.
Any use is at your own risk.

Permission is hereby granted to copy this compiler for any non-commercial
purpose, provided the above notices are retained on all copies.  Further
restrictions apply to the DEC/INRIA BigNum package.  These are stated in
the file runtime/BigNum/doc/bnbody.tex.

This work uses the BigNum package developed jointly by INRIA and
Digital PRL.  It has been modified by Hans-J. Boehm in August 1990
and February 1993 at Xerox PARC.  When you receive this software,
please send mail to librarian@prl.dec.com to inform them that you
have a copy of the package.

----------------------------------

This is V3.3 of the Russell compiler.  It has been recently used on
SPARCstations and Sun 3 workstations under Sun OS 3.2,
3.5, 4.0, and 4.1.  The resulting code has been run on
a variety of other machines as well.  Unlike previous versions,
this version is configured to generate (totally unreadable) C code
from the intermediate code used by the compiler.  A direct to
VAX assembly code generator is included, but the supporting
run-time system is not.  A Motorola 68020 code generator and
run-time system are available, but not included here.

The distribution consists primarily of source code for the compiler,
for the runtime environment, a collection of files comprising an
on-line manual, and a collection of sample Russell programs, including
a constructive real arithmetic package and desk calculator utility.

Installation instructions are provided in a file called "INSTALLATION"
in this directory.

The authors would like to maintain a list of sites running the compiler.
Please send notification of any new sites to boehm@xerox.com.

An early version of the compiler was developed at Cornell University
under NSF grant MCS 01048 and amendment MCS 8104010, with the help of
Philip Matthews and Jim Hook.  It was then further developed by the
first author at the University of Washington, and at Rice University,
with partial funding under NSF grant number DCR 8607200 and DARPA/NSF
grant CCR 87-20277.  The 68020 code generator was built by Kumar Srikantan.
The static garbage collector in lh_opt was written by Lucy Hederman.
The desk calculator and the underlying constructive real arithmetic package
were written by Hans-J. Boehm and Vernon Lee.

The Russell language was designed primarily by Alan Demers and
J. Donahue.  The implementation is loosely based on "An Informal
Description of Russell" (Boehm, Demers, and Donahue, Cornell Technical
Report 80-430).  A more accurate description of the implemented
language can be obtained through the supplied online manual, or
from the "Programmer's Introduction to Russell" (Rice TR85-16).
(A troff -me version of this report is included here as doc/intro.me.)
A discussion of the design philosophy can be found "Data Types are
Values", by Donahue and Demers, in the July 1985 issue of TOPLAS.

Disclaimers:

The Russell compiler has neither been verified, nor even thoroughly
tested.  Bugs are not unheard of.  If you find any, please report
them to Boehm@Rice.  Any use of the compiler is at your own risk.

Some of the code in the compiler is not beautiful.  The underlying
syntax tree structure violates various C type checking rules.  (Hence the
-w flags on many of the compilations.)  Reasons for this are largely
historical.  (Parts of the compiler date back to 1979.)

The various ".mh" source files where automatically generated from
"streedefs.h" and the corresponding ".m" file.  The generation was done
with a modified version of cpp that we cannot easily redistribute.

The type inference algorithm used by the compiler is workable, but not
entirely satisfactory.  In particular, it is enough of a heuristic
that some experimentation is likely to be needed to discover what
type information can be inferred automatically.  "rhelp inference"
gives a very rough description of the algorithm.  For some ideas
on how to do this right, see the Proceedings of the SIGPLAN '89
Conference on Programming Language Design and Implementation.

The compiler itself is slow.  Fortunately machines have gotten fast
enough that this is no longer very painful.  On a VAX 11/750, be
prepared to wait and wait and ...

Try "rhelp hints" for further known peculiarities.

UNIX is a trademark of AT&T Bell Labs.

VAX is a trademark of Digital Equipment Corporation.

Sun 3 is a trademark of Sun Microsystems.

SPARCstation is a trademark of SPARC International.

This directory consists of runtime support routines for Russell on
a Motorola 68K series processor.  Hopefully these routines are a little
more portable than the VAX version.  Nonetheless, they currently
only run on a 68020.

Remarks:

1.  Everything in this directory assumes we are using an approximate
  marking algorithm in the garbage collector.  Every attempt is made
  to reduce the probability of a non-pointer getting misidentified as
  a pointer, but we do not make any guarantees to this effect.  The
  garbage collector must be able to accomodate such misinterpretations,
  though they can clearly result in wasted space.

2.  Unlike the VAX, the 68000 does not easily allow Russell procedure
  calls to be compatible with C.  Thus we generate interface routines.

3.  The following register assignments are used:
	    a7  -  stack pointer
	    a6  -  frame pointer
	    a5  -  a.r. pointer (left unchanged in NO_SL calls)
	    a4  -  pointer to global activation record

    Occasionally bits and pieces of VAX specific code were left
  around (inside appropriate ifdefs).  These assume that ap
  takes the place of a5.

4.  The first register allocated by the SUN C compiler to a pointer
  register variable is a5.  The first one allocated to a non-pointer
  register variable is d7.  Subsequent register variables are
  assigned to decreasing register numbers.

This pass builds builds the symbol table as part of the syntax tree.
Identifiers are set up to point to a list of possible declarations for
them.  The exact declaration is usually not determined until the signature
checking pass (pass4) when overloading can be resolved.


                   Symbol Table Organization

    The symbol table is kept as a set of back pointers in the syntax tree.

    1) An identifier node is one of:
        a) operator identifier
        b) letter identifier

    2) From an identifier node, last_definition points at a definition
       for that identifier in smallest enclosing scope.

    3) A definition for an identifier is one of:
        a) declaration definition
        b) parameter definition
        c) type signature definition
        d) A modified type primary. This contains a pointer to
           one of the following kinds of modifiers:
            i)   with list definition
            ii)  export list definition
            iii) hide list definition
           The fields described here are actually present in these
	   modifiers.
	e) The identifier itself.  This happens whenever the identifier
	   is the defining instance for a type component.

    4) From a definition node, previous_definition points at a definition
       for that identifier in the same scope or in the smallest enclosing
       scope.

    5) From a declaration node, decl_scope points at the block in which
       the declaration appeared.

    6) From a parameter node, par_scope points at the function signature
       in which the parameter appeared.

    7) Since certain identifier nodes are both shared
       and sometimes do not refer to the immediately surrounding definition
       of that name (e.g. Boolean), id nodes with non-NIL last definition
       fields are not touched. This is only true for usage, not a
       definition.
      
    8) From an identifier or string node use_list points to the next 
       enclosing use list (NIL if there is none).

    9) From a use list node previous_list points to the next surrounding
       use list.

This is the source for several passes over the syntax tree which follow the
initial symbol table generation.  They performs the following tasks:

	1.  Assign pre- and post-order numbers to each node in the tree.

	2.  Set the def_found field of each identifier declared within
		a function or type signature.  Clear the last_definition 
		field and set the def_found field of all
		identifiers explicitly selected from a type.

	3.  Rearrange type signatures into a canonical order.
		This canonical order consists of a single
		DEFCHARSIGS node followed by a list of TSCOMPONENTs.

	4. Standardize xlause ordering in conditionals.

	5. Other minor manipulations.

This is Lucy Hederman's static garbage collector.  It inserts deallocation
hints into the intermediate code, and it may annotate lazy cons cells
with reference count and size information for the closure.
This is invoked only with -OO or -OOO.

A description of the techniques used can be found in ``Compile Time
Garbage Collection Using Reference Count Analysis'', Lucy Hederman,
Rice Computer Science Technical Report 88-75.

This was written in a hurry.  Some of the
data structures and coding style could be improved.  I do not
know of any bugs, other than some assumptions about the kind of intermediate
code sequences that are generated by the compiler itself.  (This appears
to assume that integer can always be ignored in the analysis.  I don't
believe this holds in general, but it probably holds for all code
generated by the compiler.  But then I may have misinterpreted the code.)

				Hans-J. Boehm (2/5/91)

These routines perform RUSSELL signature deduction and checking.


Invariants and general observations:

1.   Signatures never contain implied selections,
   applications, V calls, or unresolved id references.
   This invariant is established (by fiat) in the previous pass.
     One consequence of this is that subst should never be asked
   to substitute an incompletely specified expression inside
   an arbitrary signature. (See 3 below however.)
     Checksigs makes sure that selections in signatures are unambiguous,
   independent of signature information.

2.   If findsig is called on a local anonymous type identifier
   it sets the signature field to an appropriate value, but
   not the sig_done field.  This is necessary since such identifier
   nodes are shared eventhough they may have different signatures
   in different contexts.  Thus the signature is recomputed the
   next time the same node is encountered.  Note that the signature
   of all such nodes is constant during a single top level call
   to findsig.  Thus resetting the signature field of such a node
   is guaranteed not to clobber an old value which is still needed.

3.  Findsig always determines the signatures of all subexpressions,
   whether they are needed immediately or not.  Findsig also inserts
   all omited selections, V calls, and constant applications.  Thus
   it is generally safe to ask subst to substitute an expression into a
   signature, provided findsig has been called on the subexpression,
   as evidenced by the sig_done field.
    The only problem with this is that some signatures can, and in order
   to avoid unnecessary circularities should be, determined before
   the signatures of all the subexpressions are known.  In this case
   such an expression is put on the dontsubst list, and only an
   attempt to actually substitute it will cause a circularity
   to be detected.
    Note that the dontsubst list can be cleared after a top level call
   of findsig is complete since checksigs works bottom up.  Thus 
   a top level call of findsig will only be made if the signatures
   of all subexpressions are already known.
    Missing constant applications, if they cannot be filled in the first
   time, are filled in by the appropriate top level call to findsig.

4.  The id_last_definition fields of identifiers may occasionally point
   to the original declaration node of the identifier, and not to
   subsequently made copies.  
    For local type identifiers and parameters, it must be possible to
   check easily whether an identifier is the one declared in a given
   parameter node or type signature node.  Preorder numbers are copied
   with the rest of a node, so they can be used to determine this.
    (This whole scheme is probably no longer needed, but it would take
   some time to get rid of its remaining uses.)

This is the Russell Intermediate Code (RIC) generator.  It produces
an intermediate code file (.G) suffix.  This consists of binary encoded
3 address code.  It must subsequently be translated to machine specific
assembly language.  A very rudimentary disassembler (called "display") for
.G files can be obtained by typing make_display in this directory (after
the compiler has been built).  The semantics of the intermediate code
instructions is partially given in "op_codes.h".

   In order to build a parser from grammar type:
	yacc -d grammar

   Then recompile all programs which include y.tab.h, namely:
        scan.c
        restab.c
        y.tab.c

    Then put the compiler together in the usual manner
    (documented elsewhere).

        

# define impure var Void
# define delay(l) func[] val ll {l}

let
    ll == LList[Short]
in use ll in
    let
        Ints == func[n: val Short] {
                       cons[n,delay(Ints[n+1])]
                };
        ints == Ints[1];
        ith == func[x: val ll; i: val Short] val Short {
                    let
                        y == ll$New[];
                        current == Short$New[];
                    in
                        current := 1;
                        y := x;
                        do current < i ==>
                            y := tail[y]; current += 1;
                        od;
                        head[y];
                    ni
                };
        n == Short$New[]
    in
        (* Grab .5 Meg *)
        Expand_Hp[128];
        do (n := Short$get[]) > 0 ==>
            put [ith[ints, n]];
            put "\n";
        od
    ni
ni ni

(* Binary trees parametrized with respect to type of data stored in leaves *)
(* Other variants are in sexpr.r, tree.r                                   *)
func[atype : type {}] {
     union U { atom : val atype;
               cn: val prod { hd: val U; tl : val U };
               empty_list: val Void }
     with SE {
        car == func[x: val SE] val SE {
                  hd[to_cn[x]]
               };
        cdr == func[x: val SE] val SE {
                  tl[to_cn[x]]
               };
        cons == func[x,y: val SE] val SE {
                  SE$from_cn[
                    prod { hd: val SE; tl: val SE } $ Mk [x, y]
                  ]
               };
        In == SE$from_atom;
        Out == SE$to_atom;
        atom == SE$is_atom;
        null == SE$is_empty_list;
        nil == func[] { SE$from_empty_list[Null] }  }
        export { New; := ; V; car; cdr; cons; In; Out; atom; null; nil }
}

func [
    argc: val Short;
    trace: var Boolean;
    argv: func[val Short] val ChStr;
    eof: func[var Void] val Boolean;
    abort: func [] val Void;
    Void: type (simple) {};
    Null: func (inline "LDN 0,RS") [] val Void;
    FS: var Void;

    Boolean: type (simple) B {
      (* constants *)
	False:  func (inline "LDN 0,RS") [] val B;
	True:   func (inline "LDN 1,RS") [] val B;
      (* operations *)
	:= :    func (standard := 1)
		     (inline "STI $1,0,$2; MOV $2,RS")
		     [var B; val B] val B;
	<> :    func (inline "NEI $1,$2,RS")
		     [x,y: val B] val B;
	= :     func (inline "EQI $1,$2,RS")
		     [x,y: val B] val B;
	New:    func (standard New 1)
		     (inline "ALA C1,RS; STI RS,0,C0")
		     [] var B;
	New:    func (standard init_New 1)
		     (inline "ALA C1,RS; STI RS,0,$1")
		     [val B] var B;
	V:      func (standard V 1)
		     (inline "LDI $1,0,RS")
		     [var B] val B;
	and:    func (inline "AND $1,$2,RS")
		     [x,y:val B] val B;
	not:    func (inline "NOT $1,RS")
		     [val B] val B;
	or:     func (inline "OR $1,$2,RS")
		     [x,y:val B] val B;
	put :   func (standard put 0)
		     (inline "ARG 1,$1; EXT \"_Bool_Put\"; LBA \"_Bool_Put\"; CLC 1; MOV RL,RS")
		     [val B] val B;
	puts :  func (inline "ARG 1,$1; EXT \"_Bool_Puts\"; LBA \"_Bool_Puts\"; CLC 1; MOV RL,RS")
		     [val B] val ChStr;
    };
    
    Short: type (simple
		 constants "LDN %c,RS"
			   "LDN %s,RS"
			   "%c") S {
      (* constants *)
	'0' :   func [] val S;
	'1' :   func [] val S;
	'2' :   func [] val S;
	'3' :   func [] val S;
	'4' :   func [] val S;
	'5' :   func [] val S;
	'6' :   func [] val S;
	'7' :   func [] val S;
	'8' :   func [] val S;
	'9' :   func [] val S;
      (* operations *)
	% :     func (inline "DVI $1,$2,RS; MLI RS,$2,RS; SBI $1,RS,RS")
		     [x,y:val S] val S;
	* :     func (inline "MLI $1,$2,RS")
                     [x,y:val S] val S;
	** :    func (inline "ARG 2,$2; ARG 1,$1; EXT \"_Short_Exp\"; LBA \"_Short_Exp\"; CLC 2; MOV RL,RS")
		     [x,y:val S] val S;
	+ :     func (inline "ADI $1,$2,RS")
                     [x,y:val S] val S;
	+= :    func (standard += 1)
		     (inline "LDI $1,0,T1; ADI T1,$2,T1; STI $1,0,T1; MOV T1,RS; UDC T1")
		     [var S; val S] val S;
	- :     func (inline "NGI $1,RS")
                     [val S] val S;
	- :     func (inline "SBI $1,$2,RS")
                     [x,y:val S] val S;
	-= :    func (standard -= 1)
		     (inline "LDI $1,0,T1; SBI T1,$2,T1; STI $1,0,T1; MOV T1,RS; UDC T1")
		     [var S; val S] val S;
	/ :     func (inline "DVI $1,$2,RS")
		     [x,y:val S] val S;
	:= :    func (standard := 1)
		     (inline "STI $1,0,$2; MOV $2,RS")
		     [var S; val S] val S;
	< :     func (inline "LTI $1,$2,RS")
		     [x,y:val S] val Boolean;
	<= :    func (inline "LEI $1,$2,RS")
		     [x,y:val S] val Boolean;
	<> :    func (inline "NEI $1,$2,RS")
		     [x,y:val S] val Boolean;
	= :     func (inline "EQI $1,$2,RS")
		     [x,y:val S] val Boolean;
	> :     func (inline "GTI $1,$2,RS")
		     [x,y:val S] val Boolean;
	>= :    func (inline "GEI $1,$2,RS")
		     [x,y:val S] val Boolean;
	New:    func (standard New 1)
		     (inline "ALA C1,RS; STI RS,0,C0")
		     [] var S;
	New:    func (standard init_New 1)
		     (inline "ALA C1,RS; STI RS,0,$1")
		     [val S] var S;
	V:      func (standard V 1)
		     (inline "LDI $1,0,RS")
		     [var S] val S;
	^+ :    func (inline "LDN 10,RS; MLI RS,$1,RS; ADI RS,$2,RS")
		     [x,y: val S] val S;
	get :   func (inline "EXT \"_Short_Get\"; LBA \"_Short_Get\"; CLC 0; MOV RL,RS")
		     [var Void] val S;
	put :   func (standard put 0)
		     (inline "ARG 1,$1; EXT \"_Short_Put\"; LBA \"_Short_Put\"; CLC 1; MOV RL,RS")
		     [val S] val S;
	puts:   func (inline "ARG 1,$1; EXT \"_Short_Puts\"; LBA \"_Short_Puts\"; CLC 1; MOV RL,RS;")
		     [val S] val ChStr;
	shift : func (inline "ARG 2,$2; ARG 1,$1; EXT \"_Short_Shift\"; LBA \"_Short_Shift\"; CLC 2; MOV RL,RS")
		     [x,y: val S] val S;
    };

    SFloat: type (simple) F {
      (* operations *)
	* :     func (inline "ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Mult\"; LBA \"_SFloat_Mult\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val F;
	+ :     func (inline "ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Add\"; LBA \"_SFloat_Add\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val F;
	- :     func (inline "ARG 1,$1; EXT \"_SFloat_Neg\"; LBA \"_SFloat_Neg\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	- :     func (inline "ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Sub\"; LBA \"_SFloat_Sub\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val F;
	. :     func (inline "ARG 3,$3; ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Dot\"; HINT AL,2,1; LBA \"_SFloat_Dot\"; CLC 3; MOV RL,RS")
		     [whole, fraction, fraction_length: val Short] val F;
	/ :     func (inline "ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Div\"; LBA \"_SFloat_Div\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val F;
	:= :    func (standard := 1)
		     (inline "STI $1,0,$2; MOV $2,RS")
		     [var F; val F] val F;
	< :     func (inline "ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Lt\"; LBA \"_SFloat_Lt\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	<= :    func (inline "ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Le\"; LBA \"_SFloat_Le\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	<> :    func (inline "ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Ne\"; LBA \"_SFloat_Ne\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	= :     func (inline "ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Eq\"; LBA \"_SFloat_Eq\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	> :     func (inline "ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Gt\"; LBA \"_SFloat_Gt\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	>= :    func (inline "ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Ge\"; LBA \"_SFloat_Ge\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	In:     func (inline "ARG 1,$1; EXT \"_SFloat_In\"; LBA \"_SFloat_In\"; CLC 1; MOV RL,RS")
		     [val Short] val F;
	New:    func (standard New 1)
		     (inline "ALA C1,RS; STI RS,0,C0")
		     [] var F;
	New:    func (standard init_New 1)
		     (inline "ALA C1,RS; STI RS,0,$1")
		     [val F] var F;
	Out:    func (inline "ARG 1,$1; EXT \"_SFloat_Out\"; LBA \"_SFloat_Out\"; CLC 1; MOV RL,RS")
		     [val F] val Short;
	V:      func (standard V 1)
		     (inline "LDI $1,0,RS")
		     [var F] val F;
	atan:   func (inline "ARG 1,$1; EXT \"_SFloat_Atan\"; LBA \"_SFloat_Atan\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	cos:    func (inline "ARG 1,$1; EXT \"_SFloat_Cos\"; LBA \"_SFloat_Cos\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	exp:    func (inline "ARG 1,$1; EXT \"_SFloat_Exp\"; LBA \"_SFloat_Exp\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	exponent:  func (inline "ARG 1,$1; EXT \"_SFloat_Exponent\"; LBA \"_SFloat_Exponent\"; CLC 1; MOV RL,RS")
			[val F] val Short;
	get :   func (inline "EXT \"_SFloat_Get\"; LBA \"_SFloat_Get\"; CLC 0; MOV RL,RS")
		     [var Void] val F;
	ln:     func (inline "ARG 1,$1; EXT \"_SFloat_Ln\"; LBA \"_SFloat_Ln\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	put :   func (standard put 0)
		     (inline "ARG 1,$1; EXT \"_SFloat_Put\"; LBA \"_SFloat_Put\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	puts:   func (inline "ARG 1,$1; EXT \"_SFloat_Puts\"; HINT AL,0,1; LBA \"_SFloat_Puts\"; CLC 1; MOV RL,RS")
		     [val F] val ChStr;
	shift:  func (inline "ARG 2,$2; ARG 1,$1; EXT \"_SFloat_Shift\"; LBA \"_SFloat_Shift\"; CLC 2; MOV RL,RS")
		     [val F; val Short] val F;
	sin:    func (inline "ARG 1,$1; EXT \"_SFloat_Sin\"; LBA \"_SFloat_Sin\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	sqrt:   func (inline "ARG 1,$1; EXT \"_SFloat_Sqrt\"; LBA \"_SFloat_Sqrt\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	to_Float: func (inline "ARG 1,$1; EXT \"_SFloat_to_Float\"; HINT AL,2,1; LBA \"_SFloat_to_Float\"; CLC 1; MOV RL,RS")
		      [val F] val Float;
	to_Long: func (inline "ARG 1,$1; EXT \"_SFloat_to_Long\"; HINT AL,0,1; LBA \"_SFloat_to_Long\"; CLC 1; MOV RL,RS")
		      [val F] val Long;
    };

    Float: type (simple) F {
      (* operations *)
	* :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Float_Mult\"; HINT AL,2,1; LBA \"_Float_Mult\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val F;
	+ :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Float_Add\"; HINT AL,2,1; LBA \"_Float_Add\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val F;
	- :     func (inline "HINT NP; ARG 1,$1; EXT \"_Float_Neg\"; HINT AL,2,1; LBA \"_Float_Neg\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	- :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Float_Sub\"; HINT AL,2,1; LBA \"_Float_Sub\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val F;
	. :     func (inline "ARG 3,$3; ARG 2,$2; ARG 1,$1; EXT \"_Float_Dot\"; HINT AL,2,1; LBA \"_Float_Dot\"; CLC 3; MOV RL,RS")
		     [whole, fraction, fraction_length: val Short] val F;
	/ :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Float_Div\"; HINT AL,2,1; LBA \"_Float_Div\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val F;
	:= :    func (inline "LDI $2,0,T1; STI $1,0,T1; LDI $2,1,T1; STI $1,1,T1; UDC T1; MOV $2,RS")
		     [var F; val F] val F;
	< :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Float_Lt\"; LBA \"_Float_Lt\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	<= :    func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Float_Le\"; LBA \"_Float_Le\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	<> :    func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Float_Ne\"; LBA \"_Float_Ne\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	= :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Float_Eq\"; LBA \"_Float_Eq\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	> :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Float_Gt\"; LBA \"_Float_Gt\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	>= :    func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Float_Ge\"; LBA \"_Float_Ge\"; CLC 2; MOV RL,RS")
		     [x,y:val F] val Boolean;
	In:     func (inline "ARG 1,$1; EXT \"_Float_In\"; HINT AL,2,1; LBA \"_Float_In\"; CLC 1; MOV RL,RS")
		     [val Short] val F;
	New:    func (inline "ALA C2,RS; STI RS,0,C0; STI RS,1,C0")
		     [] var F;
	New:    func (inline "DCL T2,ADDR; ALA C2,T2; LDI $1,0,T1; STI T2,0,T1; LDI $1,1,T1; STI T2,1,T1; UDC T1; MOV T2,RS; UDC T2")
		     [val F] var F;
	Out:    func (inline "HINT NP; ARG 1,$1; EXT \"_Float_Out\"; LBA \"_Float_Out\"; CLC 1; MOV RL,RS")
		     [val F] val Short;
	V:      func (inline "DCL T2,ADDR; ALA C2,T2; LDI $1,0,T1; STI T2,0,T1; LDI $1,1,T1; STI T2,1,T1; UDC T1; MOV T2,RS; UDC T2")
		     [var F] val F;
	atan:   func (inline "HINT NP; ARG 1,$1; EXT \"_Float_Atan\"; HINT AL,2,1; LBA \"_Float_Atan\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	cos:    func (inline "HINT NP; ARG 1,$1; EXT \"_Float_Cos\"; HINT AL,2,1; LBA \"_Float_Cos\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	exp:    func (inline "HINT NP; ARG 1,$1; EXT \"_Float_Exp\"; HINT AL,2,1; LBA \"_Float_Exp\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	exponent:  func (inline "HINT NP; ARG 1,$1; EXT \"_Float_Exponent\"; LBA \"_Float_Exponent\"; CLC 1; MOV RL,RS")
			[val F] val Short;
	get :   func (inline "EXT \"_Float_Get\"; HINT AL,2,1; LBA \"_Float_Get\"; CLC 0; MOV RL,RS")
		     [var Void] val F;
	ln:     func (inline "HINT NP; ARG 1,$1; EXT \"_Float_Ln\"; HINT AL,2,1; LBA \"_Float_Ln\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	put :   func (standard put 0)
		     (inline "HINT PT; ARG 1,$1; EXT \"_Float_Put\"; LBA \"_Float_Put\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	puts:   func (inline "HINT NP; ARG 1,$1; EXT \"_Float_Puts\"; HINT AL,0,1; LBA \"_Float_Puts\"; CLC 1; MOV RL,RS")
		     [val F] val ChStr;
	shift:  func (inline "ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Float_Shift\"; HINT AL,2,1; LBA \"_Float_Shift\"; CLC 2; MOV RL,RS")
		     [val F; val Short] val F;
	sin:    func (inline "HINT NP; ARG 1,$1; EXT \"_Float_Sin\"; HINT AL,2,1; LBA \"_Float_Sin\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	sqrt:   func (inline "HINT NP; ARG 1,$1; EXT \"_Float_Sqrt\"; HINT AL,2,1; LBA \"_Float_Sqrt\"; CLC 1; MOV RL,RS")
		     [val F] val F;
	to_Long: func (inline "HINT NP; ARG 1,$1; EXT \"_Float_to_Long\"; HINT AL,0,1; LBA \"_Float_to_Long\"; CLC 1; MOV RL,RS")
		      [val F] val Long;
	to_SFloat: func (inline "HINT NP; ARG 1,$1; EXT \"_Float_to_SFloat\"; LBA \"_Float_to_SFloat\"; CLC 1; MOV RL,RS")
		      [val F] val SFloat;
    };

    ChStr: type (simple
		 constants "LBA \"\\%03o\"; LDS RS"
			   "LBA \"%s\"; LDS RS"
			   "\\%03o")
		CS {
	characters;
	'' :     func (inline "EXT \"_empty_ChStr\"; LBA \"_empty_ChStr\"; LDL RS")
		      [] val CS;
	. :      func (inline "HINT OPT,5; ARG 2,$2; ARG 1,$1; EXT \"_ChStr_check_Dot\"; LBA \"_ChStr_check_Dot\"; CLC 2; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_ChStr_unchecked_Dot\"; LBA \"_ChStr_unchecked_Dot\"; CLC 2; MOV RL,RS")
		      [val CS; val Short] val Short;
	:= :     func (standard := 1)
		      (inline "STI $1,0,$2; MOV $2,RS")
		      [var CS; val CS] val CS;
	< :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_strcmp\"; LBA \"_strcmp\"; CLC 2; LTI RL,C0,RS")
		     [x,y:val CS] val Boolean;
	<= :    func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_strcmp\"; LBA \"_strcmp\"; CLC 2; LEI RL,C0,RS")
		     [x,y:val CS] val Boolean;
	<> :    func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_strcmp\"; LBA \"_strcmp\"; CLC 2; NEI RL,C0,RS")
		     [x,y:val CS] val Boolean;
	= :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_strcmp\"; LBA \"_strcmp\"; CLC 2; EQI RL,C0,RS")
		     [x,y:val CS] val Boolean;
	> :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_strcmp\"; LBA \"_strcmp\"; CLC 2; GTI RL,C0,RS")
		     [x,y:val CS] val Boolean;
	>= :    func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_strcmp\"; LBA \"_strcmp\"; CLC 2; GEI RL,C0,RS")
		     [x,y:val CS] val Boolean;
	In:      func (inline "ARG 1,$1; EXT \"_Short_to_ChStr\"; HINT AL,1,1; LBA \"_Short_to_ChStr\"; CLC 1; MOV RL,RS")
		      [val Short] val CS;
	New:     func (standard ptr_New 1)
		      (inline "ALH C1,RS; STI RS,0,UN")
		      [] var CS;
	New:     func (standard init_New 1)
		      (inline "ALH C1,RS; STI RS,0,$1")
		      [val CS] var CS;
	Out:     func (inline "HINT NP; ARG 1,$1; EXT \"_ChStr_to_Short\"; LBA \"_ChStr_to_Short\"; CLC 1; MOV RL,RS")
		      [val CS] val Short;
	V:       func (standard V 1)
		      (inline "LDI $1,0,RS")
		      [var CS] val CS;
	^* :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_ChStr_Concat\"; HINT AL,0,1; LBA \"_ChStr_Concat\"; CLC 2; MOV RL,RS")
		      [x,y: val CS] val CS;
	getchar: func (inline "EXT \"_ChStr_Getchar\"; HINT AL,1,1; LBA \"_ChStr_Getchar\"; CLC 0; MOV RL,RS")
		      [var Void] val CS;
	len:     func (inline "HINT NP; ARG 1,$1; EXT \"_ChStr_Length\"; LBA \"_ChStr_Length\"; CLC 1; MOV RL,RS")
		      [val CS] val Short;
	put:     func (standard put 0)
		      (inline "HINT PT; ARG 1,$1; EXT \"_ChStr_Put\"; LBA \"_ChStr_Put\"; CLC 1; MOV RL,RS")
		      [val CS] val CS;
	substr:  func (inline "ARG 3,$3; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_ChStr_Sub\"; HINT AL,0,1; LBA \"_ChStr_Sub\"; CLC 3; MOV RL,RS")
		      [val CS; i,j: val Short] val CS;
    };

    Alias: func (inline "EQI $1,$2,RS")
		[x,y: var T; T: type {}] val Boolean;

    Array: func (standard Array 0)
		(inline "ARG 2,$2; ARG 1,$1; EXT \"_Array\"; HINT AL,0,0; LBA \"_Array\"; CLC 2; MOV RL,RS")
		[size: val Short; comptype: type {New; V}]
		type A {. : func (inline "HINT OPT,10; LTI $2,C0,TL; BRT \"1f\"; LDI $1,0,T1; LTI $2,T1,TL; BRT \"2f\"; LBL \"1\"; ARG 1,$2; EXT \"_Array_error\"; ERR \"_Array_error\"; LBL \"2\"; ADP $1,$2,T1; LDI T1,1,RS")
				 [var A; val Short] var comptype;
			. : func (inline "HINT OPT,10; LTI $2,C0,TL; BRT \"1f\"; LDI $1,0,T1; LTI $2,T1,TL; BRT \"2f\"; LBL \"1\"; ARG 1,$2; EXT \"_Array_error\"; ERR \"_Array_error\"; LBL \"2\"; ADP $1,$2,T1; LDI T1,1,RS")
				 [val A; val Short] val comptype;
			New;
			V;
			size: func [] val Short;
                       };

    Ref: func [T: type {}]
	      type t { = :  func (inline "EQI $1,$2,RS")
				 [val t; val t] val Boolean;
		       := : func (standard := 1)
				 (inline "STI $1,0,$2; MOV $2,RS")
				 [var t; val t] val t;
		       New: func (standard ptr_New 1)
				 (inline "ALH C1,RS; STI RS,0,UN")
				 [] var t;
		       Nil: func (inline "MOV UN,RS")
				 [] val t;
		       V:   func (standard V 1)
				 (inline "LDI $1,0,RS")
				 [var t] val t;
		       In:  func (inline "MOV $1,RS")
				 [var T] val t;
		       Out: func (inline "MOV $1,RS")
				 [val t; var Void] var T;
		       ^ : func (inline "MOV $1,RS")
				[val t; var Void] var T;
                     };

    File: type (simple) f {
		   := : func (standard := 1)
			     (inline "STI $1,0,$2; MOV $2,RS")
			     [var f; val f] val f;
		   = :  func (inline "EQI $1,$2,RS")
			     [val f; val f] val Boolean;
		   New: func (standard ptr_New 1)
			     (inline "ALH C1,RS; STI RS,0,UN")
			     [] var f;
		   Null: func (inline "LDN 0,RS")
			      [] val f;
		   V:   func (standard V 1)
			     (inline "LDI $1,0,RS")
			     [var f] val f;
		   close: func (inline "ARG 1,$1; EXT \"_File_Close\"; LBA \"_File_Close\"; CLC 1; MOV C0,RS")
			       [val f] val Void;
		   eof:   func (inline "ARG 1,$1; EXT \"_File_Eof\"; LBA \"_File_Eof\"; CLC 1; MOV RL,RS")
			       [val f; var Void] val Boolean;
		   flush: func (inline "ARG 1,$1; EXT \"_File_Flush\"; LBA \"_File_Flush\"; CLC 1; MOV C0,RS")
			       [val f] val Void;
		   open:  func (inline "ARG 2,$2; ARG 1,$1; EXT \"_File_Open\"; LBA \"_File_Open\"; CLC 2; MOV RL,RS")
			       [fname,mode: val ChStr] val f;
		   readb: func (inline "ARG 1,$1; EXT \"_File_Readb\"; LBA \"_File_Readb\"; CLC 1; MOV RL,RS")
			       [val f; var Void] val Short;
		   readc: func (inline "ARG 1,$1; EXT \"_File_Readc\"; LBA \"_File_Readc\"; CLC 1; MOV RL,RS")
			       [val f; var Void] val ChStr;
		   seek:  func (inline "ARG 2,$2; ARG 1,$1; EXT \"_File_Seek\"; LBA \"_File_Seek\"; CLC 2; MOV C0,RS")
			       [val f; val Long] val Void;
		   stderr: func (inline "EXT \"_File_Stderr\"; LBA \"_File_Stderr\"; CLC 0; MOV RL,RS")
				[] val f;
		   stdin:  func (inline "EXT \"_File_Stdin\"; LBA \"_File_Stdin\"; CLC 0; MOV RL,RS")
				[] val f;
		   stdout: func (inline "EXT \"_File_Stdout\"; LBA \"_File_Stdout\"; CLC 0; MOV RL,RS")
				[] val f;
		   write: func  (inline "ARG 2,$2; ARG 1,$1; EXT \"_File_Write\"; LBA \"_File_Write\"; CLC 2; MOV RL,RS")
				[val f; val ChStr] val ChStr;
		   writeb: func (inline "ARG 2,$2; ARG 1,$1; EXT \"_File_Writeb\"; LBA \"_File_Writeb\"; CLC 2; MOV RL,RS")
				[val f; val Short] val Short;
                 };

    List: func [t:type{}] type (simple) l {
		:= :     func (standard := 1)
			      (inline "STI $1,0,$2; MOV $2,RS")
			      [var l; val l] val l;
		New:     func (standard ptr_New 1)
			      (inline "ALH C1,RS; STI RS,0,UN")
			      [] var l;
		V:       func (standard V 1)
			      (inline "LDI $1,0,RS")
			      [var l] val l;
		'' :     func (inline "MOV UN,RS")
			      [] val l (*empty list*);
		is_nil:  func (inline "EQI UN,$1,RS")
			      [val l] val Boolean (* is empty *);
		cons:    func (inline "ALH C2,T1; STI T1,1,$1; STI T1,0,$2; MOV T1,RS")
			      [val t; val l] val l; (* add at left end *);
		^* :     func (inline "ALH C2,T1; STI T1,1,$2; STI T1,0,$1; MOV T1,RS")
			      [val l; val t] val l; (* cons, with args reversed *);
		head:    func (inline "HINT OPT,5; EQI $1,UN,TL; BRF \"1f\"; EXT \"_list_error\"; ERR \"_list_error\"; LBL \"1\"; LDI $1,1,RS")
			      [val l] val t (* first element, error if empty *);
		tail:    func (inline "HINT OPT,5; EQI $1,UN,TL; BRF \"1f\"; EXT \"_list_error\"; ERR \"_list_error\"; LBL \"1\"; LDI $1,0,RS")
			      [val l] val l (* all but first, error if empty *);
           };

    LList: func [t:type{}] type l {
		:= :     func (standard := 1)
			      (inline "STI $1,0,$2; MOV $2,RS")
			      [var l; val l] val l;
		New:     func (standard ptr_New 1)
			      (inline "ALH C1,RS; STI RS,0,UN")
			      [] var l;
		V:       func (standard V 1)
			      (inline "LDI $1,0,RS")
			      [var l] val l;
		'' :     func (inline "MOV UN,RS")
			      [] val l (*empty list*);
		is_nil:  func (inline "EQI UN,$1,RS")
			      [val l] val Boolean (* is empty *);
		cons:    func (inline "ALH C3,T1; DCL T2,INT; MOV C1,T2; NGI T2,T2; STI T1,2,T2; UDC T2; STI T1,1,$1; STI T1,0,$2; MOV T1,RS")
			      [val t; val l] val l; (* add at left end *);
		cons:    func (inline "ALH C3,T1; HINT STSZ,$2; STI T1,2,C0; STI T1,1,$1; STI T1,0,$2; MOV T1,RS")
			      [val t; func [] val l] val l;
		head:    func (inline "HINT OPT,5; EQI $1,UN,TL; BRF \"1f\"; EXT \"_list_error\"; ERR \"_list_error\"; LBL \"1\"; LDI $1,1,RS")
			      [val l] val t (* first element, error if empty *);
		tail:    func (inline "HINT OPT,5; EQI $1,UN,TL; BRF \"1f\"; EXT \"_list_error\"; ERR \"_list_error\"; LBL \"1\"; LDI $1,2,T1; LTI T1,C0,TL; BRT \"1f\"; HINT NP; ARG 1,$1; EXT \"_LList_Tail1\"; LBA \"_LList_Tail1\"; CLC 1; LBL \"1\"; LDI $1,0,RS")
			      [val l] val l (* all but first, error if empty *);
	   };

    Long: type (simple
		constants
		    "EXT \"_Long_%c\"; LBA \"_Long_%c\"; LDL RS"
		    "LBA \"1\"; IDT 1; IDT %s; LBA \"1b\"; LDL RS"
		    "%c"
		    9  (* Max number of digits understood by assembler *)
	       ) L {
      (* constants *)
	'0' :   func [] val L;
	'1' :   func [] val L;
	'2' :   func [] val L;
	'3' :   func [] val L;
	'4' :   func [] val L;
	'5' :   func [] val L;
	'6' :   func [] val L;
	'7' :   func [] val L;
	'8' :   func [] val L;
	'9' :   func [] val L;
      (* operations *)
	% :     func (inline "ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Long_Mod\"; HINT AL,0,1; LBA \"_Long_Mod\"; CLC 2; MOV RL,RS")
		     [val L; val Short] val Short;
	% :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Long_LMod\"; HINT AL,0,1; LBA \"_Long_LMod\"; CLC 2; MOV RL,RS")
		     [val L; val L] val L;
	* :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Long_Mult\"; HINT AL,0,1; LBA \"_Long_Mult\"; CLC 2; MOV RL,RS")
		     [x,y:val L] val L;
	+ :     func (inline "HINT NP; ARG 2,$2; UDC $2; HINT NP; ARG 1,$1; UDC $1; EXT \"_Long_Add\"; HINT AL,0,1; LBA \"_Long_Add\"; CLC 2; MOV RL,RS")
		     [x,y:val L] val L;
	- :     func (inline "HINT NP; ARG 1,$1; UDC $1; EXT \"_Long_Neg\"; HINT AL,0,1; LBA \"_Long_Neg\"; CLC 1; MOV RL,RS")
		     [x:val L] val L;
	- :     func (inline "HINT NP; ARG 2,$2; UDC $2; HINT NP; ARG 1,$1; UDC $1; EXT \"_Long_Sub\"; HINT AL,0,1; LBA \"_Long_Sub\"; CLC 2; MOV RL,RS")
		     [x,y:val L] val L;
	/ :     func (inline "ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Long_Div\"; HINT AL,0,1; LBA \"_Long_Div\"; CLC 2; MOV RL,RS")
		     [val L; val Short] val L;
	/ :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Long_LDiv\"; HINT AL,0,1; LBA \"_Long_LDiv\"; CLC 2; MOV RL,RS")
		     [val L; val L] val L;
	:= :    func (standard := 1)
		     (inline "STI $1,0,$2; MOV $2,RS")
		     [var L; val L] val L;
	< :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; UDC $1; UDC $2; EXT \"_Long_cmp\"; LBA \"_Long_cmp\"; CLC 2; LTI RL,C0,RS")
		     [x,y:val L] val Boolean;
	<= :    func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; UDC $1; UDC $2; EXT \"_Long_cmp\"; LBA \"_Long_cmp\"; CLC 2; LEI RL,C0,RS")
		     [x,y:val L] val Boolean;
	<> :    func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; UDC $1; UDC $2; EXT \"_Long_cmp\"; LBA \"_Long_cmp\"; CLC 2; NEI RL,C0,RS")
		     [x,y:val L] val Boolean;
	= :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; UDC $1; UDC $2; EXT \"_Long_cmp\"; LBA \"_Long_cmp\"; CLC 2; EQI RL,C0,RS")
		     [x,y:val L] val Boolean;
	> :     func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; UDC $1; UDC $2; EXT \"_Long_cmp\"; LBA \"_Long_cmp\"; CLC 2; GTI RL,C0,RS")
		     [x,y:val L] val Boolean;
	>= :    func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; UDC $1; UDC $2; EXT \"_Long_cmp\"; LBA \"_Long_cmp\"; CLC 2; GEI RL,C0,RS")
		     [x,y:val L] val Boolean;
	In :    func (inline "ALA C2,RS; STI RS,0,C1; STI RS,1,$1")
		     [val Short] val L;
	New:    func (standard ptr_New 1)
		     (inline "ALH C1,RS; STI RS,0,C0")
		     [] var L;
	New:    func (standard init_New 1)
		     (inline "ALH C1,RS; STI RS,0,$1")
		     [val L] var L;
	Out:    func (inline "HINT OPT,8; LDI $1,0,T1; EQI T1,C1,TL; BRT \"1f\"; ARG 1,$1; EXT \"_Long_Out\"; LBA \"_Long_Out\"; CLC 1; LBL \"1\"; LDI $1,1,RS")
		     [val L] val Short;
	V:      func (standard V 1)
		     (inline "LDI $1,0,RS")
		     [var L] val L;
	^+ :    func (inline "HINT NP; ARG 2,$2; HINT NP; ARG 1,$1; EXT \"_Long_Concat\"; HINT AL,0,1; LBA \"_Long_Concat\"; CLC 2; MOV RL,RS")
		     [x,y: val L] val L;
	nbits : func (inline "HINT NP; ARG 1,$1; EXT \"_Long_Nbits\"; HINT AL,2,1; LBA \"_Long_Nbits\"; CLC 1; MOV RL,RS")
		     [val L] val L;
	nwords: func (inline "DCL T2,INT; ALA C2,T2; LDI $1,0,T1; STI T2,0,C1; STI T2,1,T1; MOV T2,RS; UDC T2")
		     [val L] val L;
	odd:    func (inline "LDI $1,1,T1; AND T1,C1,RS")
		     [val L] val Boolean;
	put :   func (standard put 0)
		     (inline "HINT PT; ARG 1,$1; EXT \"_Long_Put\"; LBA \"_Long_Put\"; CLC 1; MOV RL,RS")
		     [val L] val L;
	puts:   func (inline "HINT NP; ARG 1,$1; EXT \"_Long_Puts\"; HINT AL,0,1; LBA \"_Long_Puts\"; CLC 1; MOV RL,RS")
		     [val L] val ChStr;
	shift : func (inline "HINT NP; ARG 2,$2; UDC $2; HINT NP; ARG 1,$1; UDC $1; EXT \"_Long_Shift\"; HINT AL,0,1; LBA \"_Long_Shift\"; CLC 2; MOV RL,RS")
		     [x,amount: val L] val L;
    };
    Callcc: func (standard Callcc 0)
		 [ body: func[ cc: func[ val T ] val Void; var Void ] val T;
		   T: type {};
		   var Void
		 ] val T;
    Signal: func (standard Callcc 0) (* Saves a continuation *)
		 [ sig_num: val Short; var Void] val Boolean;
    Unsignal: func[ sig_num: val Short; var Void] val Void;
    Expand_Hp: func[ val Short ] val Void;
] 
{
    let
	impure === var Void;
	^ == func[x: val T; y: val List[T]; T: type{}] {
		cons[x,y];
	     };
	^ == func[x: val T; y: val T; T: type{}] {
		cons[x, cons[y, (List[T])$'']];
	     };
    in
	use Float in use ChStr in use Boolean in use Short in
	    
	ni ni ni ni; Null[]
    ni
}

#define SHORT_PRECISION         /* Short is big enough for precision */
#define SHORT32                 /* 32 bit Short                      */

(* This should be compiled with "rc -pcL" *)

(* 
 * This claims to be an implementation of constructive real numbers.
 * Each number x is represented primarily as a function which given
 * a precision n produces a (Long) number m such that 
 *
 *       | m*4^n - x |  <  4^n
 *
 * For efficiency reasons, the current approximation to the result
 * is also passed to this function.  (It is esp. useful for sqrt.)
 * Additional fields in the representation are used to keep track
 * of the smallest argument (i.e. greatest precision demand)
 * on which the function has already been evaluated, and the
 * corresponding result.  This is used to avoid
 * duplicate evaluation.  Floating point upper and lower bounds
 * are also maintained.  These further reduce the amount of
 * duplicate evaluation.
 *
 * Functions currently available:  
 *
 *      + ==    func [x,y: val I] val I;
 *      - ==    func [x,y: val I] val I;
 *      - ==    func [val I] val I;
 *      max ==  func [x,y: val I] val I;
 *      abs ==  func [val I] val I;
 *	compare == func [x,y: val I; r,a: val Long; impure] val Short;
 *	to_Long == func [val I; val Long; impure] val Long;
 *	inv == 	func [val I; impure] val I;
 *      * ==    func [x,y: val I] val I;
 *      / ==    func [x,y: val I] val I;
 *      sqrt == func [x,y: val I] val I;
 *	exp ==	func [val I; impure] val I;
 *	ln ==	func [val I; impure] val I;
 *      sin ==  func [val I; impure] val I;
 *      cos ==  func [val I; impure] val I;
 *      atan == func [val I; impure] val I;
 *	atan ==	func [x: val I; pi2: val I; impure] val I;
 *      pi ==   func [] val I;
 *      eager == func [val I] val I;
 *	put ==	func [val I; val Long; impure] val Void;
 *	puts ==	func [val I; val Long; impure] val ChStr;
 *      hex_puts == func [val I; val Long; impure] val ChStr;
 *	In ==	func [val Long] val I;
 *      In ==   func [x: val Long; offset: val Long] val I;
 *      . ==    func [w,f,l: val Long] val I;
 *
 *      The algorithms for transcendentals are largely copied from
 *      Richard P. Brent's work.  Some of those that aren't should have
 *      been.
 *
 *      Authors:  Hans-J. Boehm & Vernon Lee
 *)

# define skip Null[]

func [] {
  let
    xLong == extern { "xlong" }[];  (* extended long integer type.  *)
	  			    (* includes full division, etc  *)
    Interval == extern { "cr/interval" }[];
					(* Type of intervals, with standard *)
					(* arithmetic operations.  Each     *)
					(* interval consists of a floating  *)
					(* point approximation and a        *)
					(* tolerance.                       *)

    interval_zero == Interval$from_Float_const[0.0];

    (* The type of the precision argument to a function representing *)
    (* a constructive real.  Note that on a Vax Short integers are   *)
    (* only 16 bits long.  Thus they may not suffice.  With 32 bit   *)
    (* Short integers, as in the Sun implementation,  they should    *)
    (* easily  suffice, since we expect to run out of memory before  *)
    (* we exhaust the range of the precision argument.               *)
#   ifdef SHORT_PRECISION
	PrecT == extend { Short }
        	     with pt {
        		from_Short == pt$In;
        		to_Short == pt$Out;
        		from_xLong == func [x: val xLong] {
        				pt$from_Short[
        				    to_Short[x]
        			        ]
        			      };
        		
        		to_xLong == func [x: val pt] {
        				xLong$from_Short[
        				    to_Short[x]
        				]
        			    };
        		/ == func [x: val pt; y: val Short] val pt {
        			pt$/[x,pt$from_Short[y]]
        		     };
        		% == func [x: val pt; y: val Short] val Short {
        			pt$to_Short[pt$%[x,pt$from_Short[y]]]
        		     };
        		min == func[x,y: val pt] {
        			 if x <= y ==> x # else ==> y fi
        		       };
        		max == func[x,y: val pt] {
        			 if x >= y ==> x # else ==> y fi
        		       };
        		abs == func[x: val pt] {
        			 if x >= pt$0 ==> x # else ==> -x fi
        		       };
        	     };
#       else
	    PrecT == extend { xLong }
		     with pt {
			from_xLong == pt$In<<func[val xLong]val pt>>;
			to_xLong == pt$Out<<func[val pt]val xLong>>;
			from_Short == func [x:val Short] {
					  pt$from_xLong[
					    xLong$from_Short[x]
					  ]
				      };
			to_Short == func [x: val pt] {
					to_Short[
					    to_xLong[x]
					]
				    };
		     };
#       endif
	
	half == 0.5;

    in use xLong in let

        base == Short$4;  (* Must be >= 4, power of 2.  Known to exp, ln *)
        base_exp == Short$2;     (* 2**base_exp = base *)
	Lbase == xLong$from_Short[base];
	Pbase == PrecT$from_Short[base];
	Lbase_exp == xLong$from_Short[base_exp];
	Pbase_exp == PrecT$from_Short[base_exp];
	half_base == Lbase/Short$2;
#       ifdef SHORT32
	   big == PrecT$10000; (* A big number s.t. base_exp*big is *)
			       (* representable as a Short          *)
	   MaxShort == Short$2147483647;
#       else
	   big == PrecT$100;
	   MaxShort == Short$32767;
#       endif
	max_Float == shift[2,125];

	(* Calculate x*base**n (rounded) efficiently *)
	scale == func[x: val xLong; n: val PrecT] val xLong {
                    let
			resultp1 == shift[x, to_xLong[Pbase_exp*(n+PrecT$1)]]
				    + half_base;
                    in
                        shift[resultp1, -Lbase_exp]
                    ni
                 };

	(* Return a reference to a new Long, Boolean, or PrecT variable *)
	create == func[] { (Ref[xLong])$In[xLong$New[]] };
	create == func[x: val Short] {
		      (Ref[Short])$In[
			let s == Short$New[];
			in s := x; s ni] };
	create == func[x: val xLong] { (Ref[xLong])$In[xLong$New[x]] };
	create == func[x: val Boolean] {
		      (Ref[Boolean])$In[
			  let
			    b == Boolean$New[]
			  in
			    b := x; b
			  ni
		      ]
		  };
	create == func[x: val PrecT] {
		      (Ref[PrecT])$In[
			  let
			    p == PrecT$New[]
			  in
			    p := x; p
			  ni
		      ]
		  };

        (* Compute the number of digits in a Long with respect to base *)
	ndigits == func[x: val xLong] {
		     use PrecT in let
			nb == from_xLong[nbits[abs[x]]];
				  (* includes sign bit *)
                     in
			(nb + Pbase_exp - 2)/base_exp
                            (* = ceiling[(nb - 1)/base_exp] *)
		     ni ni
		   };

	cr ==		(* each cr represents a constructive real number x *)
	  prod I {
	    fn: func [val PrecT; val I; impure] val xLong;
				(* function which returns x * base^(-prec)
				   truncated to an xLong integer *)
	    min_prec: val Ref[PrecT];
				(* smallest (finest) precision to which
				   x has been calculated (for efficiency) *)
	    max_val: val Ref[xLong];
				(* fn[x][min_prec[x]] = max_val[x] *)
	    value_valid: val Ref[Boolean];
				(* value_valid => the stored values for
				   min_prec and max_val are valid *)
	    value_exact: val Boolean;
				(* max_val is exact (for constants) *)
	    fp_appr: val Interval;
				(* approximation of the number *)
	  } with I {

	    (*
	     * Given only the function definining a real number, and
	     * an interval approximation to the real number,
	     * produce a representation of the real number.
	     *)
	    Mk2 ==
		func[f: func [val PrecT; val I; impure] val xLong;
		     fp_appr: val Interval] val I
		{
		    I$Mk[f, create[PrecT$0], create[],
			create[False], False,
			fp_appr]
		};

	    (*
	     * Return a number whose value is a good current
	     * approximation to y.
	     *)
	    current_approx ==
		func [y: val I; impure] val I {
		    let
			calculated_prec ==
			    if value_valid[y]^ ==>	min_prec[y]^
			    # else ==>			big
			    fi;

			fp_prec ==
			    if is_junk[fp_appr[y]] ==>	big
			    # else ==>
				PrecT$from_Short[
				    (exponent[tol[fp_appr[y]]] / base_exp)
					+ Short$1
				]
			    fi;

		        prec == min[calculated_prec, fp_prec]
		    in
			I$Mk[ fn[y],
			      create[prec],
			      create[val_I_to_Long[y, prec]],
			      create[True], True,
			      Interval$junk
			]
		    ni
		};

	   (*
	    * get a long approximation of a constructive real x.
	    *)
	    val_I_to_Long ==
		func[x: val I; prec: val PrecT; impure] {
		    if abs[prec] < big cand
		       accurate[fp_appr[x],to_Short[prec] * base_exp] ==>
			(*
			 * floating point appr is accurate enough,
			 * so round it off to right precision and return
			 *)
			from_Float[
			    shift[appr[fp_appr[x]],to_Short[-prec*Pbase_exp]]
			    + half
			]
		    # else ==>
			(*
			 * have to use old value or calculate new one
			 *)
			if (not value_valid[x]^) cor
                           ((not value_exact[x]) cand prec < min_prec[x]^) ==>
			  (*
			   * calculate new long approximation and
			   * save new value in x for later use
			   *)
			    let
				new_val == fn[x][prec, x];
			    in
			     (*
			      * "critical section" bounded by changing
			      * value_valid to False until done. We hope
			      * that assignment is atomic.
			      *)
				value_valid[x]^ := False; (* P *)
				max_val[x]^ := new_val;
				min_prec[x]^ := prec;
				value_valid[x]^ := True; (* V *)
				new_val
			    ni
			# else ==>
			  (*
			   * shift old value to proper precision
			   *)
			    scale[max_val[x]^, min_prec[x]^ - prec]
			fi
		    fi
		};


	   (*
	    * Given a Long, divide by base, rounding off least
	    * significant digit
	    *)
	    round ==
		func[x: val xLong; impure] val xLong {
		    if
		      x >= xLong$0 ==> (x + half_base)/base
		    # x <= xLong$0 ==> (x - half_base)/base
		    fi
		};

	    + ==
		func[x, y: val I] val I {
		    I$Mk2[
			func[prec: val PrecT; val I; impure] {
			    let
				sum == val_I_to_Long[x, prec - PrecT$1]
				     + val_I_to_Long[y, prec - PrecT$1]
			    in
				cr$round[sum]
			    ni
		    	},
			fp_appr[x] + fp_appr[y]
		    ]
                };

	    - == func[x, y: val I] val I {
		    I$Mk2[func[prec: val PrecT; val I; impure] {
			    let
			      diff == val_I_to_Long[x, prec - PrecT$1]
				      - val_I_to_Long[y, prec - PrecT$1]
			    in
				cr$round[diff]
			    ni
			  },
			  fp_appr[x] - fp_appr[y]
		    ]
                 };

	    - == func[x: val I] val I {
		    I$Mk2[func[prec: val PrecT; val I; impure] {
			    -val_I_to_Long[x, prec]
			  },
			  -fp_appr[x]
		    ]
                 };

	    max == func[x, y: val I] val I {
		    I$Mk2[func[prec: val PrecT; val I; impure] {
			    let
			      xappr == val_I_to_Long[x, prec];
			      yappr == val_I_to_Long[y, prec];
			    in
			      if
				xappr >= yappr ==> xappr
			      # else           ==> yappr
			      fi
			    ni
			  },
			  max[fp_appr[x], fp_appr[y]]
		    ]
		   };

	    abs == func[x: val I] val I {
		       I$max[I$-[x], x]
		   };

            (*
	     * Calculate x*base**n (rounded)
	     *)
	    scale == func[x: val I; how_much: val PrecT] val I {
			I$Mk2[func[prec: val PrecT; val I; impure] {
				val_I_to_Long[x, prec - how_much]
			      },
			      if how_much > big ==>
				  Interval$junk
			      # else ==>
				  shift[fp_appr[x],
					to_Short[how_much] * base_exp]
			      fi
			]
                     };
            
            (* Same thing, but by bits rather than digits *)
            shift == func[x: val I; how_much: val Short] val I {
            		use Short in let
            		    r == if how_much < 0 then
            		            base_exp - (-how_much-1) % base_exp - 1
            		         else
            		            how_much % base_exp
            		         fi;
            		    rest == if r = 0 then 0 else r - base_exp fi;
            		    scale_amount == PrecT$from_Short[
            		    			(how_much - rest)/base_exp
            		    		    ];
            		in
            		    I$Mk2[func[prec: val PrecT; val I; impure] {
				    shift[val_I_to_Long[x, prec - scale_amount],
				          xLong$In[rest]];
			          },
			          if how_much > to_Short[big] ==>
				      Interval$junk
			          # else ==>
				      shift[fp_appr[x], how_much]
			          fi
			    ]
            		ni ni
            	     };
            

            (* Find the position of the most significant digit of x *)
	    (* Not guaranteed to look further than the position     *)
	    (* specified by limit argument.                         *)
	    (* Returns a value less than limit if msd was not found *)
	    msd2 ==
		func[x: val I; limit: val PrecT; impure] val PrecT {
		    let
			overflow_prec == PrecT$50;
			default_guess == -PrecT$10;
			no_fp_appr == is_junk[fp_appr[x]];
			offset_guess1 ==
			    if no_fp_appr ==>
				overflow_prec (* Assume overflow *)
			    # else ==>
				PrecT$from_Short[exponent[appr[fp_appr[x]]]]
				      / Pbase_exp - PrecT$3;
			    fi;
		       (* prec value at which x is unlikely to evaluate *)
		       (* to 0                                          *)
			offset_decr == PrecT$16;
			has_prev_appr == value_valid[x]^;
			offset_guess2 ==
			    if has_prev_appr ==> min_prec[x]^
			    # else ==>
				if offset_guess1 = overflow_prec ==>
				    default_guess
				# else ==>
				    offset_guess1
				fi
			    fi;
			offset == PrecT$New[];
			value == xLong$New[];
		    in
			offset := if
				    no_fp_appr cand has_prev_appr ==>
				      offset_guess2
				  # else ==>
				      offset_guess1
				  fi;
			do abs [value := val_I_to_Long[x, offset]] <= 1
			   cand offset >= limit ==> 
			    if offset > offset_guess2 then
				offset := offset_guess2
			    else
				if offset < -offset_decr then
				    offset := offset * PrecT$2
				else
				    offset -= offset_decr
				fi
                            fi
			od;
			if
			  abs[value] > 1 ==>
			    (* x = value * base^offset and value <> 0 *)
			   offset + ndigits[value] - PrecT$1
			# else ==>
			    limit - PrecT$1
			fi
                      ni
		    };

	    (* Identical to the above, except no limit is specified *)
	    (* Diverges on 0 argument.                              *)
	    msd == func[x: val I; impure] val PrecT {
			let
			    limit == PrecT$New[];
			    result == PrecT$New[];
			in
			    limit := -big;
			    do (result := msd2[x,limit]) < limit ==>
				limit := limit * big;
			    od;
			    result
			ni
		   };

	    (* Return the approximate most significant bit position, 	*)
	    (* but not less than min.					*)
	    most_significant_bit_pos ==
	    	   func[x: val I; min: val Short; impure] {
	    	       let
	    	           limit == PrecT$In[(min - Short$2) / base_exp];
	    	           appr_prec == msd2[x, limit] - PrecT$2;
	    	           appr == val_I_to_Long[x, appr_prec]
	    	       in
	    	           PrecT$Out[appr_prec] * base_exp
	    	           + Out[nbits[appr]] - Short$1;
	    	       ni
	    	   };
	    		
	    (* Return 0 if x = y to within the indicated tolerance, *)
	    (* -1 if x < y, and +1 if x > y.  If x and y are indeed *)
	    (* equal, it is guaranteed that 0 will be returned.  If *)
	    (* they differ by less than the tolerance, anything     *)
	    (* may happen.  The tolerance is specified in terms     *)
	    (* of a relative tolerance r (in bits) and an absolute  *)
	    (* tolerance a (in bits).  The tolerance allowed is     *)
	    (* the maximum of (abs(x)+abs(y))*(2**r) and 2**a       *)
	    compare == func[x,y: val I; r,a: val Long; impure] val Short {
			 let
			    fp_result == compare[fp_appr[x], fp_appr[y]]
			 in
			   if
			     fp_result <> Short$0 ==>
			       fp_result
			   # else ==>
			       let
				 r_dig == PrecT$from_xLong[from_Long[r]]
					  /base_exp;
				 a_dig == PrecT$from_xLong[from_Long[a]]
					  /base_exp;
				 xpy == I$+[I$abs[x], I$abs[y]];
				 xpy_msd == I$msd2[xpy, a_dig];
				 prec == max[xpy_msd + r_dig - PrecT$1, a_dig];
				 xval == val_I_to_Long[x, prec];
				 yval == val_I_to_Long[y, prec];
			       in
				 if
				   xval > yval + 1 ==> Short$1
				 # yval > xval + 1 ==> -Short$1
				 # else            ==> Short$0
				 fi
			       ni
			   fi
			 ni
		       };

	    (* Truncate a constructive real number r to an integer *)
	    (* If r is less than an integer n, but within 2**tol   *)
	    (* of n, the answer may be either n or n-1.            *)
	    to_Long == func[x: val I; tol: val Long; impure] {
			 let
			   init_prec == -PrecT$4;
			   init_prec_bits == init_prec * Pbase_exp;
			   init_appr == val_I_to_Long[x, init_prec];
			   sgn == sign[init_appr];
			   abs_init_appr == abs[init_appr];
			   int_part == shift[abs_init_appr,
					     to_xLong[init_prec_bits]];
			   fraction == abs_init_appr
				       - shift[int_part,
					       to_xLong[-init_prec_bits]];
			 in
			   if
			     fraction > 1
			     cand fraction
				  < shift[1, to_xLong[-init_prec_bits]]-1 ==>
				(* Safe to use this approximation *)
				to_Long[int_part * sgn]
			   # else ==>
			       let
				 dig_tol == PrecT$from_xLong[
					       from_Long[tol]
					    ]/base_exp + PrecT$1;
				 xval == val_I_to_Long[x, dig_tol];
				 int_part == shift[abs[xval]+1,
						   to_xLong[dig_tol
							    *Pbase_exp]];
			       in
				 to_Long[sign[xval]*int_part]
			       ni
			   fi
			 ni
		       };

            (* Compute the multiplicative inverse directly *)
	    inv1 == func[prec: val PrecT; x: val I; msd: val PrecT; impure] {
                        let 
			    (* msd == I$msd[x]; *)
			    inv_msd == -PrecT$1 - msd;
			    digits_needed == inv_msd - prec + PrecT$2;
				(* See inv2 for cryptic explanation *)
                            prec_needed == msd - digits_needed;
                            scale_factor == -prec - prec_needed;
			    dividend == scale[1,scale_factor];
			    scaled_divisor == val_I_to_Long[x, prec_needed];
                        in
                            if
			      digits_needed <= PrecT$0 ==> 0
			    # else ==> 
				       (* (dividend + shift[scaled_divisor,-1])
					  / scaled_divisor *)
				       (* rounded division *)
				let
				    abs_dividend ==
					abs[dividend
					    + shift[scaled_divisor,-1]];
				    abs_divisor == abs[scaled_divisor];
				    quotient == xLong$New[];
				in
				    if digits_needed <= PrecT$500 then
					quotient := abs_dividend/abs_divisor
				    else
					quotient := q[fast_div[abs_dividend,
							       abs_divisor]];
				    fi;
				    if (dividend < 0)
					= (scaled_divisor < 0) then
					quotient
				    else
					- quotient
				    fi
				ni
                            fi
                        ni;
                    };
	(*
            (* This uses Newton's method.  It assumes that one iteration  *)
            (* is sufficient                                              *)
	    inv2 == func[prec: val PrecT; prev_appr, x: val I;
			 msdx:val PrecT; impure] {
                        let
			  current_appr == xLong$New[];  (* scaled by precm2 *)
			  last_appr == xLong$New[];     (* scaled by precm2 *)
                          last_ap_valid == Boolean$New[];
			  precm2 == prec - PrecT$2;
			  (* msdx == msd[x]; *)
			  inv_msd == -PrecT$1 - msdx;
						  (* Msd position in result *)
			  digits_needed == inv_msd - prec + PrecT$2;
				(* Number of SIGNIFICANT digits needed for *)
				(* argument, excl. msd position, which may *)
				(* be fictitious, since msd routine can be *)
				(* off by 1.  Roughly 1 extra digit is     *)
				(* needed since the relative error is the  *)
				(* same in the argument and result, but    *)
				(* this isn't quite the same as the number *)
				(* of significant digits.  Another digit   *)
				(* is needed to compensate for slop in the *)
				(* calculation.                            *)
			  prec_x == msdx - digits_needed;
                            (* precision to which argument must be evaluated *)
                          long_x == val_I_to_Long[x, prec_x];
                          (* constants needed for scaling *)
                            '2' == scale[2, -prec_x - precm2];
                            intermediate_prec == -digits_needed;
                            scale1 == prec_x + precm2 - intermediate_prec;
                        in
                          (* Use previous approximation as starting point *)
                               current_appr := val_I_to_Long[
						  current_approx[prev_appr],
                                                  precm2
                                              ];

                          let
                              old == V[current_appr]
                          in
                              (* set current_appr := old * (2 - x * old)   *)
                              (* appropriately scaled                      *)
                              current_appr := scale['2' - long_x*old, scale1];
                              current_appr := scale[old * current_appr,
                                                    intermediate_prec];
                          ni;
			  scale[current_appr, -PrecT$2]
                        ni
		    };
	*)

	    (* The real inverse function.  Uses inv1 to whenever        *)
	    (* the number of significant digits is < Newton_threshold.  *)
	    (* Otherwise it recursively approximates the inverse to     *)
	    (* sligtly more than half the number of significant digits  *)
	    (* and then uses one iteration of Newton's method (inv2) to *)
	    (* refine the approximation.                                *)
	    inv == func[x: val I] val I {
		      I$Mk2[
		       func[prec: val PrecT; prev_appr: val I; impure]
			    val xLong {
                        let
			  msdx == msd[x];
			(*
			  Newton_threshold == PrecT$30;
			  inv_msd == -PrecT$1 - msdx;
			  digits_needed == inv_msd - prec + PrecT$1;
			  prev_min_digits == shift[digits_needed+PrecT$5,
						   -PrecT$1];
			    (* Ceiling[digits_needed/2]                *)
			    (* + 1 since error is squared, number of   *)
			    (*   digits may not quite be doubled.      *)
			    (* + 1 for rounding errors                 *)

                          half_prec == inv_msd - prev_min_digits;
                          prev_digits == if
					    not value_valid[prev_appr]^ ==> PrecT$0
					 #  else ==> ndigits[max_val[prev_appr]^]
					 fi;
			*)
			in
			(*
			  if
			      digits_needed <= Newton_threshold ==>
			*)
                                (* Do it the obvious way *)
				  inv1[prec,x,msdx]
			(*
                          #   else ==>
                                if
                                  prev_digits < prev_min_digits ==>
                                      (* Force recursive evaluation to *)
                                      (* prev_min_digits               *)
                                         val_I_to_Long[prev_appr, half_prec];
                                # else ==> skip
                                fi;
                                (* Newton's method will converge in 1 *)
                                (* iteration                          *)
				inv2[prec, prev_appr, x, msdx]
			  fi;
			*)
			ni
		       },
		       inv[fp_appr[x]]
		      ]
                   };

	    (* Multiplication:                                   *)
	    (* Note that the absolute precision required from    *)
	    (* an argument depends on the value of the other     *)
	    (* argument.  This requires a trial evaluation of    *)
	    (* at least one argument.  Bishop first computes     *)
	    (* an integral approximation to one of the arguments.*)
	    (* This can lead to bad behaviour if the argument    *)
	    (* is much less than one.  Thus we try computing     *)
	    (* both arguments to about half the required         *)
	    (* precision.  As soon as we find one that's nonzero,*)
	    (* we're OK.  If both are 0, the result must be 0.   *)
	    * == func[x,y: val I] val I {
		    I$Mk2[
		     func[prec: val PrecT; val I; impure] {
                      let
			half_prec == shift[prec,-PrecT$1] - PrecT$1;
                        (* It is sometimes convenient to swap x and y ... *)
                        swap == Boolean$New[];
			both_0 == Boolean$New[];  (* Both arguments are close *)
                                                  (* enough to 0 to return 0  *)
                      in
			if 
			   value_valid[x]^ cand abs[max_val[x]^] > 1
			   cor compare[fp_appr[x], interval_zero] <> Short$0 ==>
                            (* easy to find leading digit of x *)
                            swap := False;
                            both_0 := False;
			#  value_valid[y]^ cand abs[max_val[y]^] > 1
			   cor compare[fp_appr[y], interval_zero] <> Short$0 ==>
                            (* easy to find leading digit of y *)
                            swap := True;
                            both_0 := False;
                        #  else ==>
                            if abs[val_I_to_Long[x, half_prec]] > 1 ==>
                                swap := False;
                                both_0 := False;
                            #  abs[val_I_to_Long[y, half_prec]] > 1 ==>
                                swap := True;
                                both_0 := False;
                            #  else ==>
                                both_0 := True;
                            fi
                        fi;
                        if both_0 ==> 0
                        # else ==>
                          let
			    first_arg == if swap ==> y # else ==> x fi;
			    second_arg == if swap ==> x # else ==> y fi;
			    msd1 == msd[first_arg];
			    prec2 == prec - msd1 - PrecT$2;
			    appr2 == val_I_to_Long[second_arg, prec2];
			    msd2 == prec2 + ndigits[appr2] - PrecT$1;
			    prec1 == prec - msd2 - PrecT$2;
			    appr1 == val_I_to_Long[first_arg, prec1];
                            scale_factor == prec1 + prec2 - prec;
                          in
                            scale[appr1 * appr2, scale_factor]
                          ni
                        fi
		      ni;
		     },
		     fp_appr[x]*fp_appr[y]
		    ]
                 };

	    / == func[x,y: val I] val I {
                    x I$* I$inv[y]
                 };

	    sqrt ==
		func[x: val I] val I {
		  I$Mk2[
		    func[prec: val PrecT; prev_appr: val I; impure] val xLong{
			let
			  rec_threshold == PrecT$6;
			  current_appr == xLong$New[];  (* scaled by precm2 *)
			  last_appr == xLong$New[];
			  precm2 == prec - PrecT$2;
			  prect2 == PrecT$2 * prec;

			(* precision for trial eval to find msd *)
			  trial_prec ==
			    max[prec,
				PrecT$from_Short[
				    exponent[appr[fp_appr[x]]]
				    / base_exp - Short$3
				]
			    ];
			  long_val == val_I_to_Long[x, trial_prec];

			(* not necessary for correctness, but could speed*)
			(* things up exponentially			 *)
                          msd == if long_val < Lbase ==>
                                    ndigits[val_I_to_Long[x,prect2]]
				    + prect2 - PrecT$1
                                 # else ==>
				    ndigits[long_val] + trial_prec - PrecT$1;
				 fi;
			  msd_res == shift[msd,-PrecT$1];
			  digits_needed == msd_res - prec + PrecT$2;
				(* incl. 1 for rounding etc. *)
                          prec_x == msd - digits_needed;
                          long_x == val_I_to_Long[x, prec_x];
			  ild == xLong$New[];  (* initial leading digit *)
                          last_ap_valid == Boolean$New[];
			  scale1 == prec_x - precm2*PrecT$2;
                          scaled_x == scale[long_x, scale1];
                                    (* x scaled by 2*precm2 *)
                        in
                          (* Find a reasonable starting point *)
                            if
                                msd_res - prec > rec_threshold ==>
                                  (* Force evaluation to lower precision *)
                                    val_I_to_Long[prev_appr,
						  msd_res
						  - (msd_res - prec)/PrecT$4];
                            #   else ==> skip;
                            fi;
			    if
			       exponent[appr[fp_appr[x]]]
			       > exponent[tol[fp_appr[x]]] + Short$10
			       cor value_valid[prev_appr]^
			       cand abs[max_val[prev_appr]^] > Lbase ==>
                               current_appr := val_I_to_Long[
						  current_approx[prev_appr],
                                                  precm2
                                              ]
                            # else ==>
                               if
                                  msd % Short$2 = Short$0 ==> ild := 1
                               #  else  ==>  ild := 3
                               fi;
                               current_appr := scale[ild, msd_res-precm2]
                            fi;

                          last_ap_valid := False;
                          
                          do not last_ap_valid cor
                             abs[last_appr - current_appr] >= Lbase ==>
                            (* Assertion: in the case of 0, the above will *)
                            (* be false before we divide by 0              *)
                            last_ap_valid := True;
                            last_appr := current_appr;
                            let
                              old == V[last_appr]
                            in
                              current_appr := (old * old + scaled_x)
					      / shift[old,1];
			    ni;
                          od;
			  scale[current_appr, -PrecT$2]
                        ni
		       },
		       sqrt[fp_appr[x]]
		      ]
                    };

            (* Compute an approximation of e^x to precision prec *)
            (* This assumes x < 1/base.                          *)
            (* It uses a Taylor series expansion.                *)
            (* Unfortunately there appears to be no way to take  *)
            (* advantage of old information.                     *)
            (* Note: this is known to be a bad algorithm for     *)
            (* floating point.  Unfortunately, other alternatives*)
	    (* appear to require precomputed information.        *)
	    exp1 == func[prec: val PrecT; x: val I; impure] val xLong {
                      let
                        (* Determine needed calculation accuracy *)
			iterations_needed == shift[-prec,-PrecT$1] + PrecT$1;
                                             (* conservative estimate *)
                          (* Claim: each intermediate term is accurate *)
                          (* to base^calc_precision.  Total error is   *)
                          (* 2*iterations_needed*base^calc_precision   *)
                          (* exclusive of error in x                   *)
                          calc_precision == prec
					    - ndigits[to_xLong[PrecT$2
						      *iterations_needed]]
					    - PrecT$1
					     (* for inaccuracy in x, trunc *);
#                       ifdef SHORT_PRECISION
			  n == Short$New[];    (* number of current iteration *)
#                       else
			  n == xLong$New[];    (* number of current iteration *)
#                       endif
			precm1 == prec - PrecT$1;
			x_apr == val_I_to_Long[x, precm1];
			c_term == xLong$New[]; (* nth term in Taylor series *)
			c_sum == xLong$New[];  (* Taylor series truncated   *)
                                              (* at nth term.              *)
                                              (* Both of the above are     *)
                                              (* scaled by -calc_precision *)
#			ifdef SHORT_PRECISION
			    ZERO == Short$0;	ONE == Short$1;
#			else
			    ZERO == 0;		ONE == 1;
#			endif
	               max_trunc_error == scale[1, (precm1) - calc_precision];
		      in
			n := ZERO;
                        c_term := c_sum := scale[1, -calc_precision];
			do abs[c_term] > max_trunc_error ==>
			    n := n + ONE;
                            c_term := scale[c_term * x_apr, precm1];
			    c_term := c_term/n;
			    c_sum += c_term;
			od;
                        scale[c_sum, calc_precision - prec];
                      ni
                    };

	    exp  == func[x: val I; impure] val I {
		    (* This assumes base = 4 *)
                      let
			rough_appr == val_I_to_Long[x, -PrecT$10];
			comp == 2; (* 2 * 4 ** (-10) *)
                      in
                        if
                          rough_appr < 0 ==> inv[exp[I$-[x]]];
                        # rough_appr >= comp ==>
			  (* scale it *)
                            let
			      fourth_root == exp[I$scale[x,-PrecT$1]];
                              square_root == fourth_root*fourth_root;
                            in
                              square_root * square_root
                            ni;
                        # else ==>
			    I$Mk2[func[prec: val PrecT; prev_appr: val I; impure]
				      val xLong {
				    exp1[prec, x]
				  },
				  exp[fp_appr[x]]
				 ]
                        fi
                      ni
                    };

            (* Compute an approximation of ln(1+x) to precision  *)
            (* prec. This assumes x < 1/base.                    *)
            (* It uses a Taylor series expansion.                *)
            (* Unfortunately there appears to be no way to take  *)
            (* advantage of old information.                     *)
            (* Note: this is known to be a bad algorithm for     *)
            (* floating point.  Unfortunately, other alternatives*)
            (* appear to require tabular information.            *)
	    ln1 == func[prec: val PrecT; x: val I; impure] val xLong {
                      let
                        (* Determine needed calculation accuracy *)
			precm1 == prec - PrecT$1;
                        iterations_needed == -precm1;
                                             (* conservative estimate *)
                          (* Claim: each intermediate term is accurate *)
                          (* to base^calc_precision.  Total error is   *)
                          (* 2*iterations_needed*base^calc_precision   *)
                          (* exclusive of error in x                   *)
                          calc_precision == prec
					    - ndigits[to_xLong[PrecT$2
						       *iterations_needed]]
					    - PrecT$1
					     (* for inaccuracy in x, trunc *);
#                       ifdef SHORT_PRECISION
			  n == Short$New[];    (* number of current iteration *)
			  c_sign == Short$New[]; (* (-1)^(n-1)                *)
#                       else
			  n == xLong$New[];    (* number of current iteration *)
			  c_sign == xLong$New[]; (* (-1)^(n-1)                *)
#                       endif
                        x_apr == val_I_to_Long[x, precm1];
			x_nth == xLong$New[];  (* nth power of x            *)
			c_term == xLong$New[]; (* nth term in Taylor series *)
			c_sum == xLong$New[];  (* Taylor series truncated   *)
					       (* at nth term.              *)
					       (* Both of the above are     *)
					       (* scaled by -calc_precision *)
                        max_trunc_error == scale[1, precm1 - calc_precision];
		      in
#                       ifdef SHORT_PRECISION
			  n := Short$1;
			  c_sign := Short$1;
#                       else
			  n := 1;
			  c_sign := 1;
#                       endif
                        x_nth := 
                          c_term :=
                          c_sum := scale[x_apr, precm1-calc_precision];
			do abs[c_term] > max_trunc_error ==>
#                           ifdef SHORT_PRECISION
				n := n + Short$1;
#                           else
				n := n + 1;
#                           endif
                            c_sign := -c_sign;
			    x_nth := scale[x_nth * x_apr, precm1];
			    c_term := x_nth/(c_sign*n);
			    c_sum += c_term;
                        od;
                        scale[c_sum, calc_precision - prec];
                      ni
		    };

	    (* A version of ln without prescaling  *)
	    (* Converges only in the vicinity of 1 *)
	    simple_ln == func[x: val I] val I {
			    I$Mk2[func[prec: val PrecT; prev_appr: val I; impure]
				       val xLong {
				    ln1[prec, x - I$In[Long$1]]
				  },
				  ln[fp_appr[x]]
			    ]
			 };

	    (* Natural log function.  Uses ln2 = ln[2], computed below *)
	    ln  == func[x: val I; impure] val I {
                      let
			rough_appr == val_I_to_Long[x, -PrecT$2];
                        Lbase2 == Lbase*Lbase;
                      in
                        if
			  rough_appr < -1 ==> (* diverge peacefully *)
					      do True ==> Null[] od;
					      I$In[Long$0]
                        # rough_appr >= -1 cand rough_appr < Lbase2 - 1 ==>
                            I$-[I$ln[I$inv[x]]]
                        # rough_appr >= Lbase2 - 1 cand
			  rough_appr < Lbase2 + Lbase ==>
			    simple_ln[x]
			# rough_appr >= Lbase2 + Lbase cand
			  rough_appr < Lbase2*2 ==>
                            let
                              quarter == I$ln[I$sqrt[I$sqrt[x]]];
                            in
			      I$scale[quarter,PrecT$1]
                            ni;
                        # rough_appr >= Lbase2*2 cand
                          rough_appr < Lbase2*Lbase ==>
                            let
			      log_half == I$ln[x/I$In[Long$2]];
                            in
			      log_half + I$ln2
                            ni;
                        # else ==>
                            let
				nexcdigs == ndigits[rough_appr] - PrecT$3;
                            in
                                I$ln[I$scale[x, -nexcdigs]]
				+ I$In[to_Long[to_xLong[nexcdigs
							* Pbase_exp]]] * I$ln2;
                            ni
                        fi
                      ni
                    };

	(* calculates Taylor series for sin or cos of a constructive    *)
	(* and returns an xLong approximation.  If flag == COS, the cos	*)
	(* is returned, otherwise the sin is returned.			*)

#define COS Short$0		(* flags passed to transxl to indicate  *)
#define SIN Short$1		(* which function to compute.		*)
#define ATAN Short$2		(* (cosine, sine, arctan, arcsin)	*)
#define ASIN Short$3		(* SIN is currently not used.		*)

	    transxl == func[flg: val Short; prec: val PrecT; x: val I; impure]
				val xLong {
	      use PrecT in let

	(* make a good conservative guess at number of iterations	*)
	(* we expect loop to go through.				*)

		its_needed ==	if (flg = ATAN) or (flg=ASIN) ==>
				    shift[-prec,2];	(* quite conservative *)
				# else ==>
				    shift[-prec,-2] + 10;
				fi;
			(* this number depends on the value of comp	*)
			(* used in cos and sin (i.e. the maximum value	*)
			(* that scaling passes to transxl)		*)
			(* the value was empirically derived		*)

		count ==	Short$New[];
		pow ==		Short$New[];

	(* we expect to lose about log[its_needed] digits of accuracy	*)

		calc_precn ==	prec		(* final precision required *)
				- ndigits[to_xLong[2*its_needed]]
				- 1;

		precm1 ==	prec - 1; (* precision minus 1 *)
		scaler ==	scale[xLong$1, -calc_precn];
		count2 ==       xLong$New[];

	    (* these two are scaled by calc_precision *)
		sum ==		xLong$New[];	(* sum of terms in series*)
		term ==		xLong$New[];	(* current term in series *)
		x_term ==	xLong$New[];

#		ifdef SHORT_PRECISION
			twoi == Short$New[];
			'2' == Short$2;
			'1' == Short$1;
			adder == if flg = COS ==> - Short$1
				 # else ==> Short$1
				 fi;
#		else
			twoi == xLong$New[];    (* 2*(current term #) *)
			'2' == xLong$2;
			'1' == xLong$1;
			adder == if flg = COS ==> - xLong$1
				 # else ==> xLong$1
				 fi;
#		endif
		max_error ==	scale[xLong$1, precm1 - calc_precn];

		x_apr == 	val_I_to_Long[x,calc_precn]; (* approx to x *)
		x2 == 		x_apr * x_apr;	   	   (* approx to x^2 *)

		oldterm ==	xLong$New[];
	    in use PrecT in
		count := Short$0;

		twoi := '2';

		if flg = COS ==>	sum := term := scaler;
		# flg = ATAN ==>	x_term := term := sum := x_apr;
		# flg = ASIN ==>	term := sum := x_apr;
		# else ==>		sum := term := x_apr;
		fi;

		(* calculate until term goes to zero due to integer	*)
		(* division truncation or because x_apr was zero.	*)
		if flg = ATAN ==>
		    do abs[term] > max_error ==>
			count := count + Short$1;
			x_term := scale[-x_term * x2,2*calc_precn];
			pow := Short$2*count+Short$1;
			term := x_term/pow;
			sum := sum + term;
		    od;
		# flg = ASIN ==>
		    (* we know arcsin's arg is between 0 and ~.707 *)
		    do abs[term] > max_error ==>
			count += Short$1;

			term := scale[term * x2,2*calc_precn];
			use xLong in let
			    mult == (2*from_Short[count]-1);
			in
			term := term * mult * mult;
			ni ni;

			use Short in
			    term := term/(2*count*(2*count+1));
			ni;
			sum += term;
		    od;
		# else ==> (* SIN, COS *)
		    do abs[term] > max_error ==>
			count := count + Short$1;
		        term := - term * x2;
		        term:= scale[term/(twoi*(twoi + adder)),2*calc_precn];
		        sum := sum + term;
		        twoi := twoi + '2';
		    od;
		fi;

		scale[sum,calc_precn - prec];
	      ni ni ni
	    }; (* end transxl *)



	(* take the sin of a constructive real *)
	    sin == func[x: val I; impure] val I {
		cos[I$pi2 - x]
	    };

	(* cosine of contructive real *)
	    cos == func[x: val I; impure] val I {
		let
		    two ==	I$In[Long$2];
		    one ==	I$In[Long$1];
		    rough_appr == val_I_to_Long[x,-PrecT$4];
		    scaled1 ==     scale[1,PrecT$4]; (* compare to 1 *)
		in
		    if abs[rough_appr] > scaled1 then
			let 
			    scaled8 == scale[8, PrecT$4];
			in
			    if abs[rough_appr] > scaled8 then
			      (* First subtract of multiples of 2 pi *)
				let
				  base2 == base * base;
				  base4 == base2 * base2;
				  long_2pi == from_Long[to_Long[
						use Short in
						  Float$In[2 * base4] * 3.1416
						ni
					      ]];
				  mult_2pi == rough_appr/long_2pi;
				in
				  cos[x - I$In[to_Long[4 * mult_2pi]] * I$pi2];
				ni
			    else
			      (* Use double angle formula *)
				let
				  cshalf == cos[x/two];
				in
				  cshalf * cshalf * two - one;
				ni;
			    fi
			ni
		    else
	            	I$Mk2[
		            func[prec: val PrecT; prev_appr: val I; impure]
			        val xLong {
				    transxl[COS, prec, x];
			        },
			    cos[fp_appr[x]]
		    	];
		    fi
		ni
	    };


	    (* arctan function *)
	    atan == func[x: val I; impure] val I {
	      let
		comp == scale[1,PrecT$2] - 1; (* slightly less than 1 *)
		rough_appr == abs[val_I_to_Long[x,-PrecT$2]];
	      in
		if rough_appr < comp ==>
		    I$Mk2[func[prec: val PrecT; pa: val I; impure]
			val xLong {
			    transxl[ATAN, prec, x];
			},
			atan[fp_appr[x]]
		    ];
		# else ==>
		(* atan x = asin (x / sqrt(x^2 + 1)) *)
		    let
			'1' == I$In[Long$1];
			asinarg == '1' / sqrt[ (x*x) + '1' ];
			ansfn == 
			 func[prec: val PrecT; pa:val I; impure] val xLong
			    { let
				cp == prec-PrecT$1;
				chk == val_I_to_Long[x,cp];
				p2v == val_I_to_Long[I$pi2,cp];
			      in
				if chk = 0 ==> xLong$0
				# else ==>
				  let
				    res == transxl[ASIN,cp,asinarg];
				    fin == scale[p2v-res,-PrecT$1];
				  in
				    if chk<0 ==> -fin;
				    # else ==>   fin;
				    fi
				  ni
				fi
			      ni
			  };
		    in
			I$Mk2[ansfn,atan[fp_appr[x]]];
		    ni
		fi;
	      ni;
	    };


	    (* Compute the arctangent of 1/N the desired precision. *)
	    (* A direct Taylor series expansion is used.            *)
	    (* 4 = base <= N <= sqrt(MaxShort) is assumed.          *)
	    (* Note that this is much faster than using the general *)
	    (* atan function.  It is used primarily to compute pi.  *)
	    atan1 == func[prec: val PrecT; N: val Short] val xLong {
                      let
                        (* Determine needed calculation accuracy *)
			iterations_needed == shift[-prec,-PrecT$1] + PrecT$1;
                                             (* conservative estimate *)
                          (* Claim: each intermediate term is accurate *)
                          (* to base^calc_precision.  Total error is   *)
                          (* 2*iterations_needed*base^calc_precision   *)
			  calc_precision == prec
					    - ndigits[to_xLong[PrecT$2
						      *iterations_needed]]
					    - PrecT$1
					     (* for inaccuracy in x, trunc *);
#                       ifdef SHORT_PRECISION
			  n == Short$New[];    (* number of current iteration *)
#                       else
			  n == xLong$New[];    (* number of current iteration *)
#                       endif
			c_power == xLong$New[]; (* nth power of 1/N         *)
			c_term == xLong$New[];  (* current term in series   *)
			c_sum == xLong$New[];  (* Taylor series truncated   *)
					       (* at nth term.              *)
					       (* Both of the above are     *)
					       (* scaled by -calc_precision *)
			sign == New[Short$1];  (* Sign of current term *)
			Nsquared == N * N;
#                       ifdef SHORT_PRECISION
			    ONE == Short$1;  TWO == Short$2;  FOUR == Short$4;
#			else
			    ONE == 1;        TWO == 2;        FOUR == 4;
#			endif
			max_trunc_error == scale[1, prec - calc_precision
						    - PrecT$1];
			'1' == scale[1, -calc_precision];
		      in
			n := ONE;
			c_sum := c_term := c_power := '1'/N;
			do c_term > max_trunc_error ==>
			    n := n + TWO;
			    sign := -sign;
			    c_power := c_power/Nsquared;
			    c_term := c_power/n;
			    if sign = ONE then
				c_sum += c_term
			    else
				c_sum -= c_term
			    fi;
			od;
                        scale[c_sum, calc_precision - prec];
                      ni
                    };


	   (* pi-valued function.                     *)
    (*
	   (* Uses pi/4 = 4 * atan(1/5) - atan(1/239) *)
	    local_pi == func[] {
		I$Mk2[func[prec: val PrecT; val I; impure] {
		      },
		      use Short, Interval in let
			'1' == from_Float_const[1.0];
			'4' == from_Float_const[4.0];
			'5' == from_Float_const[5.0];
			'239' == from_Float_const[239.0];
		      in
			'4' * ('4' * atan['1'/'5'] - atan['1'/'239'])
		      ni ni
		]
	    };
    *)

	   (* Uses alternating arithmetic/geometric mean algorithm *)
	   (* from Gaston Gonnet's book or Brent's paper.          *)
	   (* The error analysis is sloppy, but should be very     *)
	   (* conservative.  Since there are no arguments          *)
	   (* involved, this doesn't hurt much.                    *)
	    local_pi == func[] {
		I$Mk2[func[prec: val PrecT; val I; impure] {
		       if prec > -PrecT$3000 then
			(* 4 * (4 * atan(1/5) - atan(1/239)) *)
			scale[I$atan1[prec-PrecT$3,Short$5]
			      - I$atan1[prec-PrecT$2,Short$239], -PrecT$1]
		       else
			let
			  bit_prec == to_xLong[- prec * Pbase_exp];
			  slop == 10 + 4 * nbits[bit_prec];
			  calc_prec == bit_prec + slop;
			  a == New[shift[1, calc_prec]];
			  b == New[sqrt[shift[1, 2*calc_prec - 1]]];
			  t == New[shift[1, calc_prec - 2]];
			  x == New[0];  (* Log[2] x in Gonnet's book *)
			  epsilon == 10;
			  sqr == func[x: val xLong] { x * x };
			in
			  do a - b > epsilon ==>
			    let
			      tmpa == V[a]
			    in
			      a := shift[a + b, -1];
			      b := sqrt[tmpa * b];
			      t := t - shift[sqr(a - tmpa), x - calc_prec];
			      x += 1;
			    ni
			  od;
			  scale[shift[(sqr[a+b])/(shift[t,2]),
				      2 * Lbase_exp - slop],
				-PrecT$2]
			ni
		       fi
		      },
		      use Short, Interval in let
			'1' == from_Float_const[1.0];
			'4' == from_Float_const[4.0];
			'5' == from_Float_const[5.0];
			'239' == from_Float_const[239.0];
		      in
			'4' * ('4' * atan['1'/'5'] - atan['1'/'239'])
		      ni ni
		]
	    };
			
	   (* mark a value as being special and returned the marked value *)
	   (* Such special values are evaluated in chunks, rather than a  *)
	   (* digit at a time.                                            *)
	    eager ==
	      func[x: val I] val I {
		let
		  (* round up precision to next highest multiple of 200 *)
		    fn ==
		      func[prec: val PrecT; prev: val I; impure] {
			  if prec < min_prec[x]^ then
			      let
				  Incr == PrecT $200;
				  next == Incr*((prec-Incr)/Incr);
				in
				    val_I_to_Long[x,next]
				ni
			  fi;
			  val_I_to_Long[x,prec]
		      };
		in
		    I$Mk2[fn,fp_appr[x]]
		ni
	      };


	    (* pi/2 value used by other functions *)
	    pi2 == eager[I$local_pi[]/I$In[Long$2]];

	    (* ln[2] value used above *)
	    ln2 == let
			'10/9' == I$In[Long$10]/I$In[Long$9];
			'25/24' == I$In[Long$25]/I$In[Long$24];
			'81/80' == I$In[Long$81]/I$In[Long$80];
			'7' == I$In[Long$7];
			'2' == I$In[Long$2];
			'3' == I$In[Long$3];
		    in
			eager['7'*I$simple_ln['10/9']
			      - '2'*I$simple_ln['25/24']
			      + '3'*I$simple_ln['81/80']];
		    ni;


	    pi == func [impure] { I$pi2 * I$In[Long$2] };

	    put == func[x: val I; ndigits: val Long; impure] {
                   (* print an approximation of x to ndigits *)
                   (* decimal digits to the right of the     *)
                   (* decimal point.                         *)
                   (* The rounding procedure favors the      *)
		   (* value.                                 *)
		     let
                        pos_ndigits == if
					 ndigits <= Long$0 ==> PrecT$0
				       # else ==> PrecT$from_xLong[
						      from_Long[ndigits]
						  ]
                                       fi;
                        from_dec_prec ==
                            (* Conservative conversion from decimal precision *)
                            (* spec                                           *)
				func[n: val PrecT] {
				    (n * PrecT$10)/(PrecT$3 * Pbase_exp)
				    - PrecT$2
                                };
                        prec == from_dec_prec[-pos_ndigits];
                        value == val_I_to_Long[x, prec];
                        abs_value == abs[value] + 1;
                                (* get an upper bound and then truncate *)
			bin_prec == prec * Pbase_exp;
			int_part == shift[abs_value, to_xLong[bin_prec]];
			exp == 10**(to_xLong[pos_ndigits]);
			fract_part == abs_value - shift[int_part,
							to_xLong[-bin_prec]];
                               (* Fraction * base**(-prec) *)
			dec_fract_part == shift[fract_part*exp,
						to_xLong[bin_prec]];
                               (* Fraction * 10**(pos_ndigits) *)
			nzeroes == PrecT$New[];
			       (* Number of leading 0s in fraction *)
			Ptmp == PrecT$New[];
			tmp == xLong$New[];
                     in
                        (* find nzeroes *)
			  nzeroes := PrecT$0;
                          tmp := dec_fract_part;
                          do
                            (tmp := 10 * tmp) < exp
			    cand nzeroes < pos_ndigits - PrecT$1
				 ==> nzeroes += PrecT$1
                          od;

                        if
                            value < 0 ==> put["-"];
                        #   else ==> put[" "];
                        fi;
                        put[int_part];
                        put["."];
                        (* Add zeroes *)
			  Ptmp := nzeroes;
                          do
			    Ptmp > PrecT$0 ==> put["0"]; Ptmp -= PrecT$1
                          od;
			put[dec_fract_part];
			x
                     ni
                   };


	    puts == func[x: val I; ndigits: val Long; impure] val ChStr {
                   (* return a string containing	     *)
		   (* an approximation of x to ndigits	     *)
                   (* decimal digits to the right of the     *)
                   (* decimal point.                         *)
                   (* The rounding procedure favors the      *)
		   (* truncated value.                       *)
		     let
			result == ChStr$New[];
                        pos_ndigits == if
					 ndigits <= Long$0 ==> PrecT$0
				       # else ==> PrecT$from_xLong[
						      from_Long[ndigits]
						  ]
                                       fi;
                        from_dec_prec ==
                            (* Conservative conversion from decimal precision *)
                            (* spec                                           *)
				func[n: val PrecT] {
				    (n * PrecT$10)/(PrecT$3 * Pbase_exp)
				    - PrecT$2
                                };
                        prec == from_dec_prec[-pos_ndigits];
                        value == val_I_to_Long[x, prec];
                        abs_value == abs[value] + 1;
                                (* get an upper bound and then truncate *)
			bin_prec == prec * Pbase_exp;
			int_part == shift[abs_value, to_xLong[bin_prec]];
			exp == 10**(to_xLong[pos_ndigits]);
			fract_part == abs_value - shift[int_part,
							to_xLong[-bin_prec]];
                               (* Fraction * base**(-prec) *)
			dec_fract_part == shift[fract_part*exp,
						to_xLong[bin_prec]];
                               (* Fraction * 10**(pos_ndigits) *)
			nzeroes == PrecT$New[];
			       (* Number of leading 0s in fraction *)
			Ptmp == PrecT$New[];
			tmp == xLong$New[];
                     in
                        (* find nzeroes *)
			  nzeroes := PrecT$0;
                          tmp := dec_fract_part;
                          do
                            (tmp := 10 * tmp) < exp
			    cand nzeroes < pos_ndigits - PrecT$1
				 ==> nzeroes += PrecT$1
                          od;
                        if
                            value < 0 ==> result := "-";
                        #   else ==> result := " ";
                        fi;
			result := result ^* fast_puts[int_part];
                        result := result ^* ".";
                        (* Add zeroes *)
			  Ptmp := nzeroes;
                          do
			    Ptmp > PrecT$0 ==> result := result ^* "0"; 
					       Ptmp -= PrecT$1
                          od;
			result := result ^* fast_puts[dec_fract_part];
			result
                     ni
                   };


	  (*
	   * same as puts, but returns a hex string.  ndigits is number
	   * of hex digits rather than decimal.
	   *)
	    hex_puts ==
		func[x: val I; ndigits: val Long; impure] val ChStr {
		    let
		      (* result string *)
			result == ChStr$New[];

		      (* # digits to return *)
                        pos_ndigits ==
			    if ndigits <= Long$0 ==> PrecT$0
			    # else ==> PrecT$from_xLong[from_Long[ndigits]]
			    fi;

		      (* conversion from hex precision *)
                        from_hex_prec == func[n: val PrecT] { n * PrecT$2; };

		      (* precision in base *)
                        prec == from_hex_prec[-pos_ndigits];

		      (* Long value of mantissa, shifted *)
                        value == val_I_to_Long[x, prec];

		      (* truncate to get int_part *)
                        abs_value == abs[value];
			bin_prec == to_xLong[prec * Pbase_exp];
			int_part == shift[abs_value, bin_prec];	(* truncs *)

		      (*
		       * Fraction * base^(-prec), which, since base = 4,
		       * 	= Fraction * 16^(pos_ndigits)
		       *)
			fract_part == abs_value - shift[int_part,-bin_prec];
			exp == 16**(to_xLong[pos_ndigits]);

		      (* Number of leading 0s in fraction *)
			nzeroes == PrecT$New[];

			Ptmp == PrecT$New[];	(* loop variable *)
			tmp == xLong$New[];	(* another loop variable *)
		    in
		      (* find nzeroes *)
			nzeroes := PrecT$0;
			tmp := fract_part;
			do
			    (tmp := 16 * tmp) < exp
			    cand nzeroes < pos_ndigits - PrecT$1
				 ==> nzeroes += PrecT$1
			od;

                        if  value < 0 ==> result := "-";
                        #   else ==> 	  result := " ";
                        fi;

                        result := result ^* hex_puts[int_part];
                        result := result ^* ".";

		      (* Add zeroes *)
			Ptmp := nzeroes;
			do  Ptmp > PrecT$0 ==>
				result := result ^* "0"; 
				Ptmp -= PrecT$1
			od;

			result := result ^* hex_puts[fract_part];
			result
		    ni
		};


	    In == func[x: val Long] val I {
		      I$Mk[func [prec: val PrecT; val I; impure] {
			       scale[from_Long[x],-prec];
			   },
			   create[PrecT$0],
			   create[from_Long[x]],
			   create[True], True,
			   if abs[from_Long[x]] > max_Float ==>
				Interval$junk
			   # else ==>
				Interval$from_Float_const[to_Float[from_Long[x]]]
			   fi
		      ];
		  };

            (* convert x*base^offset *)
	    In == func[x: val Long; offset: val Long] val I {
		    let
		      Poffset == PrecT$from_xLong[from_Long[offset]]
		    in
		      I$Mk[func [prec: val PrecT; val I; impure] {
			      scale[from_Long[x],Poffset-prec]
			   },
			   create[Poffset],
			   create[from_Long[x]],
			   create[True], True,
			   if abs[from_Long[x]] > max_Float
			      cor abs[Poffset] > big ==>
			     Interval$junk
			   # else ==>
			     shift[Interval$
				    from_Float_const[to_Float[from_Long[x]]],
				   Long$Out[offset]*base_exp]
			   fi
		      ];
		    ni
		  };

	    . == func[whole, fraction, length: val Long] val I {
		    let
			(* Convert everything from Long to xLong. Gross... *)
			Xwhole == from_Long[whole];
			Xlength == from_Long[length];
			Xfraction == from_Long[fraction];
                    in
                      if
			Xfraction = 0 ==>
			   I$In[whole]
		      # else ==>
			   let
			      multiplier == 10**Xlength;
			      Xint_val == Xwhole * multiplier + Xfraction;
			   in
			      I$In[to_Long[Xint_val]]
			      / I$In[to_Long[multiplier]]
			   ni
                      fi;
		    ni
                 };
        }
    in
	cr
	hide {Mk; Mk2; fn; scale; min_prec; max_val; value_valid; value_exact;
	      fp_appr; val_I_to_Long; msd; msd2; inv1; (* inv2; *) exp1; ln1;
	      transxl; round; atan1; simple_ln; ln2; local_pi; pi2}
    ni ni ni
}

	program crtest
	implicit logical (a-z)
	integer a,b,c
	integer crpi, crmult, crsqrt, crexp
	call xcr
	a = crpi()
	call crput(a,20)
	b = crsqrt(crin(163))
	call crput(a,30)
	call crput(b,30)
	c = crexp(crmult(a,b))
	call crput(b,30)
	call crput(c,90)
	stop
	end

(*
 * destructive doubly-linked lists
 *)
# define NIL from_nil[0]
# define NEWNIL D$Out[D$create[from_nil[0]]]

# define DEBUG
# ifdef DEBUG
#  define debug(x) x
# else
#  define debug(x)
# endif

func[t: type T { put: func[val T]val T }] {
    let
	Elt == prod {
	    vl: val t;
	    next, last: val Ref[Relt];
	};

	Relt == union {
	    e: val Elt;
	    nil: val Short;
	};

    in use Ref[Relt], Relt in let
	dlist == extend { Ref[Relt] } with D {
	    create == func[x: val Relt] {
		let
		    v == Relt$New[];
		in
		    v := x;
		    D$In[v]
		ni
	    };
	    '' == func[] val D { D$create[NIL] };
	    is_nil == func[d: val D; impure] { is_nil[d^] };


	  (* copy a dlist *)
	    copy == func[x: val D; impure] val D {
		let
		    copyr == func[x: val Ref[Relt]; ls: val Relt; impure] val Relt {
			if is_nil[x^] then
			    NIL
			else
			    let
				newnode ==
				    Relt$from_e[Elt$Mk[
					vl[to_e[x^]],
					(Ref[Relt])$In[Relt$New[]],
					(Ref[Relt])$In[Relt$New[]]
				    ]];
			    in
				last[to_e[newnode]]^ := ls;
				next[to_e[newnode]]^ :=
				    copyr[next[to_e[x^]],newnode];
				newnode
			    ni
			fi
		    };
		    copyl == func[x: val Ref[Relt]; nx: val Relt; impure] val Relt {
			if is_nil[x^] then
			    NIL
			else
			    let
				newnode ==
				    Relt$from_e[Elt$Mk[
					vl[to_e[x^]],
					(Ref[Relt])$In[Relt$New[]],
					(Ref[Relt])$In[Relt$New[]]
				    ]];
			    in
				next[to_e[newnode]]^ := nx;
				last[to_e[newnode]]^ :=
				    copyl[last[to_e[x^]],newnode];
				newnode
			    ni
			fi
		    };
		in
		    if is_nil[x^] then D$create[from_nil[0]]
		    else
			let
			    newnode ==
				Relt$from_e[Elt$Mk[
				    vl[to_e[x^]],
				    (Ref[Relt])$In[Relt$New[]],
				    (Ref[Relt])$In[Relt$New[]]
				]];
			in
			    last[to_e[newnode]]^ :=
				copyl[last[to_e[x^]],newnode];
			    next[to_e[newnode]]^ :=
				copyr[next[to_e[x^]],newnode];
			    D$create[newnode]
			ni
		    fi
		ni
	    };

	  (* add x to right of cell d points to *)
	    addr == func[x: val t; d: val D; impure] val Void {
		if is_nil[d] then
		    d^ := from_e[Elt$Mk[x,NEWNIL,NEWNIL]];
		else
		    if is_nil[next[to_e[d^]]^] then
			let
			    nlst == D$Out[D$create[d^]]; (* new ptr to d^ *)
			in
			    next[to_e[d^]]^ :=
				from_e[Elt$Mk[x,NEWNIL,nlst]]
			ni
		    else
			let
			    nw == from_e[Elt$Mk[
					x,
					D$Out[D$create[next[to_e[d^]]^]],
					D$Out[D$create[d^]]
				  ]]
			in
			    last[to_e[next[to_e[d^]]^]]^ := nw;
			    next[to_e[d^]]^ := nw;
			ni
		    fi
		fi
	    };

	  (* add x to left of cell d points to *)
	    addl == func[x: val t; d: val D; impure] val Void {
		if is_nil[d] then
		    d^ := from_e[Elt$Mk[x,NEWNIL,NEWNIL]];
		else
		    if is_nil[last[to_e[d^]]^] then
			let
			    nnxt == D$Out[D$create[d^]]; (* new ptr to d^ *)
			in
			    last[to_e[d^]]^ :=
				from_e[Elt$Mk[x,nnxt,NEWNIL]]
			ni
		    else
			let
			    nw == from_e[Elt$Mk[
					x,
					D$Out[D$create[d^]],
					D$Out[D$create[last[to_e[d^]]^]]
				  ]]
			in
			    next[to_e[last[to_e[d^]]^]]^ := nw;
			    last[to_e[d^]]^ := nw;
			ni
		    fi
		fi
	    };

	    put_one == func[d: val D; impure] val Void {
		if is_nil[d^] then put "nil"
		else
		    put "("; put[vl[to_e[d^]]]; put")";
		fi
	    };

	    put_one == func[d: var D; impure] val Void {
		if is_nil[d^] then put "nil"
		else
		    put "("; put[vl[to_e[d^]]]; put")";
		fi
	    };

	    put == func[d: val D; impure] val Void {
		let
		    cur == D$New[];
		in
		    cur := d;
		    do ( if is_nil[cur^] then False else True fi) ==>
			let
			    v == vl[to_e[cur^]];
			in
			    put[v]; put ","
			ni;
			cur := D$In[next[to_e[cur^]]];
		    od
		ni
	    };
	    putl == func[d: val D; impure] val Void {
		let
		    cur == D$New[];
		in
		    cur := d;
		    do ( if is_nil[cur^] then False else True fi) ==>
			let
			    v == vl[to_e[cur^]];
			in
			    put[v]; put ","
			ni;
			cur := D$In[last[to_e[cur^]]];
		    od
		ni
	    };

	  (* delete the object d^ from the list it's in *)
	    delete == func[d: var D; impure] val Void {
		if is_nil[d^] then put "cannot delete nil object\n"
		else
		    let
			dobj == to_e[d^];
			ls == last[dobj];
			nx == next[dobj];
		    in
			if is_nil[ls^] then
			    if is_nil[nx^] then
			      (* nothing to delete - not connected *)
				0
			    else
			      (* is on left end of a list *)
				last[to_e[nx^]]^ := NIL;
			    fi
			else
			    if is_nil[nx^] then
			      (* is on right end of a list *)
				next[to_e[ls^]]^ := NIL;
			    else
			      (* is in the middle of a list *)
				last[to_e[nx^]]^ := ls^;
				next[to_e[ls^]]^ := nx^;
			    fi
			fi
		    ni
		fi
	    };


	    last == func[d: var D; impure] val D { last[V[d]] };
	    last == func[d: val D; impure] val D {
		put "last["; put_one[d]; put "]\n";
		if is_nil[d^] then
		    put "dlist: tried to do last on nil list\n";
		    D$''
		else
		    let res == D$In[last[to_e[d^]]]
		    in
			put "last returning "; put_one[res]; put "\n"; res
		    ni
		fi
	    };
	    next == func[d: var D; impure] val D { next[V[d]] };
	    next == func[d: val D; impure] val D {
		if is_nil[d^] then
		    put "dlist: tried to do next on nil list\n";
		    D$''
		else
		    D$In[next[to_e[d^]]]
		fi
	    };
	    head == func[d: var D; impure] val t {
		if is_nil[d^] then
		    put "dlist: tried to take head of empty dlist\n";
		fi;
		vl[to_e[d^]]
	    };
	};
    in
	dlist
	hide {
	    In<<func[val Ref[Relt]]val dlist>>;
	    Out<<func[val dlist]val Ref[Relt]>>;
	    In<<func[var Relt]val dlist>>;
	    Out<<func[val dlist; impure]var Relt>>;
	    ^; create;
	}
    ni ni ni
}

(* Binary tree data type.  Uses a functional representation for tree *)
(* nodes.                                                            *)
func [L: type {}] {
  let
    lr == enum { left, right };
  in use lr in
    union B { leaf: val L; interior: func [val lr] val B }
    with B {
             left_sub_tree == func [x: val B] {
                                B$to_interior[x][left]
                              };
             right_sub_tree == func [x: val B] {
                                 B$to_interior[x][right]
                               };
             leaf_value == B$to_leaf;
             make_leaf == B$from_leaf;
             make_tree == func [l,r: val B] val B {
                            B$from_interior [
                                func [x: val lr] {
                                    if
                                        x = left ==> l
                                    #   x = right ==> r
                                    fi
                                }
                            ]
                          }
    }
    export { New; :=; V; left_sub_tree; right_sub_tree; leaf_value;
             make_leaf; is_leaf; make_tree }
  ni ni
}

(* curses interface with Russell *)

#define skip Null[]

func [] {
    let
	window == extend { Short } with W {

	    Mk == func[w,x,y,z: val Short; impure] val W
		     { extern "_get_newwin" };

	    delwin == func[x: val W; impure] val Void
			{ extern "_delwin" };

	  (* curses functions *)

	    wstandout == func[w: val W; impure] val Void
		{ extern "_wstandout" };

	    wstandend == func[w: val W; impure] val Void
		{ extern "_wstandend" };

	    wmove == func[w: val W; y,x: val Short; impure] val Void
		{ extern "_wmove" };

	    touchwin == func[w: val W; impure] val Void
		{ extern "_touchwin" };

	    wrefresh == func[w: val W; impure] val Void
		{ extern "_wrefresh" };

	    initscr == func[impure] val Void { extern "_initscr" };

	    box == func[w: val W; vert,hor: val Short; impure] val Void
		{ extern "_box" };

	    wclear == func[w: val W; impure] val Void { extern "_wclear" };
	    wclrtoeol == func[w: val W; impure] val Void
		{ extern "_wclrtoeol" };
	    wclrtobot == func[w: val W; impure] val Void
		{ extern "_wclrtobot" };

	    endwin == func[impure] val Void { extern "_endwin" };
	    werase == func[w: val W; impure] val Void { extern "_werase" };

	  (* curses macros converted *)

	    nonl == func[impure] val Void { extern "_nonlM" };
	    nl == func[impure] val Void { extern "_nlM" };
	    nocbreak == func[impure] val Void { extern "_nocbreakM" };
	    cbreak == func[impure] val Void { extern "_cbreakM" };
	    noecho == func[impure] val Void { extern "_noechoM" };
	    echo == func[impure] val Void { extern "_echoM" };


	  (* other things that an interface was necessary for *)

	    wput == func[w: val W; s: val ChStr; impure] val Void
		{ extern "_putwin" };
	    gety == func[w: val W; impure] val Short { extern "_gety" };
	    getx == func[w: val W; impure] val Short { extern "_getx" };
	    wgetc == func[w: val W; impure] val Short
		{ extern "_win_getch" };
	};
    in
	window
	export { Mk; delwin; New <<func[] var window>>; :=; V;
		 wmove; wrefresh; initscr; box; wclear; wclrtoeol; 
		 wclrtobot; nonl; nl; nocbreak; cbreak; noecho; echo;
		 wput; gety; getx; wgetc;
		 endwin; werase; wstandout; wstandend; touchwin;}
    ni
}


	    

# include "defs.h"
# define STATIC_GC_TMP (FIRST_AVAIL_LOC-1)
	/* A temporary that may be safely used by compile time GC */

(* This file maintains the update array stuff, and then outputs the program
   when asked to, incorporating any updates	*)

func [num_quads, MAX_QUAD : val Short] {

    let updateinfo == prod U {kind, x, y, z, w : val Short};
	UpdateList == List [updateinfo]
    in
	(Array [num_quads, UpdateList])
     with UA {

	NNew == func [] var UA {
		    let q == Short$New [0];
		        u == UA$New []
		    in
			do q < num_quads ==>
			    u.q := UpdateList$'';
			    q += 1
		       od;
		       u
		    ni
		};

	add == func [u : var UA; q : val Short;
			kind, x, y, z, w : val Short] val Void {
		    u.q := cons [updateinfo$Mk [kind, x, y, z, w], u.q]
		};

	write_file == func [Arg1type : type T {
				is_str : func [val T] val Boolean;
				to_str : func [val T] val ChStr;
				to_arg : func [val T] val Short};
			    Basics : type B {V;
				opc, arg2, arg3 : func [val B] val Short;
				arg1 : func [val B] val Arg1type};
			    BA : type A {
				. : func [var A;val Short] var Basics};
			    quads : var BA;
			    updates : var UA;
			    out_file : val File; impure] val Void {

	    let
		writew == func [val Short; val File; impure] val Void 
						{extern "_putw"};
		write_quad == func [opc, arg1, arg2, arg3 : val Short;impure]
								val Void {
			writew [opc, out_file];
			writew [arg1, out_file];
			writew [arg2, out_file];
			writew [arg3, out_file]
		      };

		write_str_quad == func [opc : val Short; str : val ChStr;
							   impure] val Void {
			writew [opc, out_file];
			write [out_file, str];
			writeb [out_file, 0]	(* terminating Null *)
		      };

		q == Short$New [0]
	    in
	      do q < num_quads ==>

		(* handle any updates intended for before the qth quad *)
		let ulist == updates.q;
		    fixed == Boolean$New [False]
			(* KILL and STI updates set this to avoid iterating
				over other updates, after having changed q;
			      there should never be any other updates anyway*)
		in
		do not fixed cand not [is_nil ulist] ==>
		let uinfo == head ulist;
		    upd_kind == kind uinfo
		in
		    ulist := tail ulist;

		if upd_kind = DEA_update ==>
OPEN
put "HINT DEA"; put [x uinfo]; put " "; put [y uinfo]; put "\n";
CLOSE
			(* Need to check that the deallocated object *)
			(* is not referenced in the instruction      *)
			(* that kills it.  This can happen with	     *)
			(* LDI AR,0,AR, which we do regularly.       *)
			(*   Partially (?) fixed 2/8/91 - HB	     *)
			let
			    qinfo == quads.q;
			in
			    if opc[qinfo] = LDI cand
			       to_arg[arg1[qinfo]] = x[uinfo] then
			       if arg3[qinfo] <> x[uinfo] then
			           put "-OO messed up on quad ";
			           put q; put "\n";
			           abort[]
			       fi;
			       write_quad [DCL, STATIC_GC_TMP, DCL_ADDR, SK];
			       write_quad [LDI, arg3[qinfo], arg2[qinfo],
			       	   	   STATIC_GC_TMP];
			       write_quad [HINT, DEA, x uinfo, y uinfo];
			       write_quad [MOV, STATIC_GC_TMP, arg3[qinfo], SK];
			       write_quad [UDC, STATIC_GC_TMP, SK, SK];
			       q += 1; fixed:= True;
			    else
			       write_quad [HINT, DEA, x uinfo, y uinfo]
			       (* x is the var (loc) and y is the size 	*)
			       (* q is unchanged - still need to output	*)
			       (* the qth quad 				*)
			    fi;
			ni

		 # upd_kind = KILL_update ==>
OPEN
put "KILL quad ";put q;put " whose opc=";put [opc [quads.q]]; put "\n";
CLOSE
			q := q + 1; fixed := True

		 # (upd_kind = postponed_UDC)
		   cor (upd_kind = postponed_DEAD) ==>
			(* HINT DEA x  y *)
			(* UDC  x   SK SK or HINT DEAD x SK *)
OPEN
put "after quad ";put [q-1];
DEBUG("\nHINT DEA");put [x uinfo];DEBUG(" ");put [y uinfo];
if upd_kind = postponed_UDC then DEBUG("\nUDC")
else DEBUG("\nHINT DEAD") fi;
put [x uinfo]; put "\n";
CLOSE
			write_quad [HINT, DEA, x uinfo, y uinfo];
			if upd_kind = postponed_UDC then
				write_quad [UDC, x uinfo, SK, SK]
			else write_quad [HINT, DEAD, x uinfo, SK]
			fi
			(* q unchanged *)

		 # upd_kind = RL_before ==>
			(* should be just before the LBA *)
		    let v == x uinfo;
		    in
OPEN
put q;put "\nMOV RL to var ";put v;
CLOSE
			write_quad [DCL, v, DCL_ADDR, SK];
			write_quad [MOV, RL, v, SK];
			(* DEAD of RL seems unnecessary right before a CLC *)
			(*write_quad [HINT, DEAD, RL, SK];*)
		    ni

		# upd_kind = RL_after (* equivalent to postponed_UDC *) ==>
			(* should be just after CLC *)
		    let v == x uinfo;
			sz == y uinfo
		    in
			write_quad [HINT, DEA, v, sz];
			write_quad [UDC, v, SK, SK]
		    ni

		 # upd_kind = STI_update ==>
		    let v == x uinfo;
		    	offset == y uinfo;
			next_var == z uinfo;
			size == w uinfo		    
		    in if size = 3 then (* STI loc offset C3 *)
OPEN
DEBUG("\nSTI ");put v;DEBUG(" ");put offset;DEBUG(" C3 ");
CLOSE
		   		write_quad [STI, v, offset, C3]
			else (* need to load size into next_var first *)
OPEN
DEBUG("\nbig STI ");put [v];DEBUG(" ");put offset;DEBUG(" ");put next_var;
DEBUG(" ");put size;DEBUG(" ");
CLOSE
				write_quad [DCL, next_var, DCL_INT, SK];
				write_quad [LDN, size, next_var, SK];
				write_quad [STI, v, offset, next_var];
				write_quad [UDC, next_var, SK, SK]
		   	fi
		    ni;
		    q += 2;  (* to skip both the HINT STSZ and the STI instr *)
		    fixed := True

		fi (* case on upd_kind *)
		ni (* uinfo, upd_kind *)
		od	(* iterate over ulist; abort if KILL or STI updates *)
		ni (* ulist *);

		(* write out the next quad *)
		let qinfo == quads.q
		in
OPEN put q;DEBUG(" "); CLOSE
		    if is_str [arg1 [qinfo]]
		    then write_str_quad [opc [qinfo], to_str [arg1 [qinfo]]]
		    	else write_quad [opc [qinfo], to_arg [arg1 [qinfo]], 
						 arg2 [qinfo], arg3 [qinfo]]
		    fi
		ni;
		q += 1
		
	  od
	ni
	}
      } with UA {New == UA$NNew}
	export {New; add; write_file}
     ni
}

(* Returns a function that performs a single Solovay-Strassen test *)
(* on the number n                                                 *)
(* The correctness argument appears to require that n is not a     *)
(* perfect square.                                                 *)
func[] {
    let
	xl == extern { "xlong" } [];
    in use xl in let
	factors == 2 * 3 * 5 * 7 * 11 * 13 * 17 * 19 * 23 * 29 * 31 * 37;

	(* Compute the value of a Jacobi symbol returns a value *)
	(* different from 1 and -1 if gcd(a,b) != 1             *)
	J == func[a,b: val xl] {
		if a = 0 then
		    b
		elsif a = 1 then
		    1
		elsif a > b then
		    J[a%b,b]
		elsif odd[a] then
		    J[b,a]
		    * if use Short in a % 4 = 1 cor b % 4 = 1 ni then
			    1
			else
			    -1
		      fi
		else
		    J[shift[a,-1], b]
		    * let
			mod8 == b % Short$8
		      in
			if use Short in mod8 = 1 cor mod8 = 7 ni then
			    1
			else
			    -1
			fi
		      ni
		fi
	     };

	random == func[impure] val Short { extern "_random" };
	Zmod == extern { "primes/Zmod" };
	** == extern { "cr/exp" };
    in
	func[N: val Long; impure] {
	  if N < Long$2 then
	    False[]
	  elsif N = Long$2 then
	    True[]
	  elsif N % Short$2 = Short$0 then
	    False[]
	  else
	    let
		n == from_Long[N];
		a == abs[xl$In[random[]]] % n;
		g == gcd[n, if n > a*factors then a*factors else a fi];
		Zmodn == Zmod N;
		'-1' == Zmodn$from_Long[-Long$1];
		jacobi == Zmodn$New[];
		power == Zmodn$New[];
	    in
		if a = 0 then
		    True
		elsif g <> 1 then
		    False
		else
		    power := (Zmodn$from_Long[to_Long[a]]) ** to_Long[(n - 1)/2];
		    if power <> Zmodn$'1' cand power <> '-1' then
			False
		    else
			jacobi := Zmodn$from_Long[to_Long[J[a,n]]];
			power = jacobi
		    fi
		fi
	    ni
	  fi
	}
    ni ni ni
}

let
    c == ChStr$New[]
    ; s == ChStr$New[]
    ; newlinecode == 10
    ; newline == func[]
		    { put[ ChStr$In[newlinecode] ] }
in
    put["enter a line:"]
    ; newline[]
    ; s := (c := getchar[FS])
    ; do
	Out[c] <> newlinecode ==> c := getchar[FS]
				  ; s := s ^* c
      od
    ; put["thanks, your string was"]
    ; newline[]
    ; put[ s ]
ni

let
    epsilon == 0.0001;
    deriv == func[f: func[val Float]val Float] {
		 func[x: val Float] val Float {
	 	    (f[x] - f[x - epsilon])/epsilon
		 }
	     };
    square == func[x: val Float] {x * x};
    double == deriv[square]
in
    put[double[13.0]]; put["\n"];
ni

(* compile lazy_sexpr.r first *)
(* compile with rc -pL        *)

# define impure var Void
# define delay(se) SEdelay[func[impure] val SE {se}]

let
    SE == extern{"lazy_sexpr"} [Long]
in use SE, Long in
    let
        Squares == func[n: val Long; impure] {
                       cons[In[n*n],delay(Squares[n+1])]
                   };
        squares == Squares[1];
        ith == func[x: val SE; i: val Long; impure] val SE {
                    let
                        y == SE$New[];
                        current == Long$New[];
                    in
                        current := 1;
                        y := x;
                        do current < i ==>
                            y := cdr[y]; current := current + 1;
                        od;
                        car[y];
                    ni
                };
        n == Long$New[]
    in
        do (n := In[Short$get[]]) > 0 ==>
            put [Out[ith[squares, n]]];
            put "\n";
        od
    ni
ni ni

# define DEBUG(S) write [File$stdout, S]
(* Implementation of a hash table with indicees of type Short *)
(* Deletions are currently not supported.                     *)
(* New will return an uninitialised array; Init will return an*)
(* initialised array, ready for insertions		      *)

func[size: val Short; key_type: type{=}; ET: type{}; not_found: val ET] {
    let
      (* Hash table chains and associated operations *)
	Entry == prod { key_val: val key_type; value: val ET };
	L == List[Entry];  (* Hash table chains *)
	list_add == func[key: val key_type; value: val ET; list: val L] {
			use L, Entry in
			    cons[Mk[key,value],list]
			ni
		    };
	list_find == func[key: val key_type; list: val L] val ET {
			if
			    is_nil[list] ==> not_found
			#   else ==>
				if
				    key_val[head[list]] = key ==>
					value[head[list]]
				#   else ==>
					list_find[key, tail[list]]
				fi
			fi
		     };

      (* Function mapping any positive short into the range 0..(size - 1) *)
	hash == func[x:val Short] val Short { x % size };

	HTable == (Array[size, L])
		with HT {
	    insert == func[hash_val: val Short;	(* hashed by caller *)
			   key: val key_type;
			   value: val ET; table: var HT] val Void {
			let
			    h == hash[hash_val]
			in
			    table.h := list_add[key, value, table.h]
			ni
		      };
	    lookup == func[hash_val: val Short;
			   key: val key_type; table: var HT] val ET {

			list_find[key, table.(hash[hash_val])]
		      };

	    Init == func[] var HT {HT$New []}
(*
		(* Since all new lists are inited. to '', no need to do it
								explicitly *)
		 	let
			    t == HT$New[];
			    i == Short$New[0];
			in
			    do i < size ==>
				t.i := L$'' (* empty *);
				i += 1;
			    od;
			    t
			ni
		     };
*);
(* unused so far - both :='s

	    := == func[x: var HT; y: val HT] val HT {
		    let
			i == Short$New[0];
		    in
			do i < size ==>
			    x.i := y.i;
			    i += 1;
			od;
			y
		    ni
		  };
	(* overloaded :=  -- this one saves on array copies *)
	    := == func[x: var HT; y: var HT] var HT {
		    let
			i == Short$New[];
		    in
			i := 0;
			do i < size ==>
			    x.i := y.i;
			    i += 1;
			od;
			y
		    ni
		  };
*)
	}
    in
	HTable export {(*:= <<func[var HTable; val HTable] val HTable>>;
		       := <<func[var HTable; var HTable] var HTable>>;*)
		       Init; (*V;*) insert; lookup}
    ni
}

func [nodes : val Nodes; Nodes : type N {size : func [] val Short;
					. : func [val N; val Short] 
							val NodeInfo};
		NodeInfo : type N {is_result : func [val N] val Boolean;
				   is_mem : func [val N] val Boolean}] {

    let
	L == extend {(List [Short])} with S {

		top == func [] val S {
			S$In [(List [Short])$'']
		    };

		create == func [i : val Short] val S {
			S$In [cons [i, (List [Short])$'']]
		    };

		member == func [x : val Short; s : val S] val Boolean {
				if is_nil s then False
				elsif x = (head s) then True
				elsif x < (head s) then False
				else member [x, tail s]
				fi
			};

		eq == func [s1, s2 : val S; var Void] val Boolean
				{ extern "_eq" };


		equal == func [s1, s2 : val S; var Void] val Boolean {
				eq [s1, s2] cor
				(if is_nil s1 then
						is_nil s2
				elsif is_nil s2 then False (* <= s1 not nil *)
				else
					(head s1 = head s2) cand
				        equal [tail s1, tail s2]
				fi)
			};

		meet == func [s1, s2 : val S] val S {

			    if is_nil s1  ==> s2
			     # is_nil s2  ==> s1
			     # else   ==>
				 if  (head s1) < (head s2) ==>
					cons [head s1, meet [tail s1, s2]]
				  #  (head s1) = (head s2) ==>
					cons [head s1, meet [tail s1, tail s2]]
				  #  else   ==>
					cons [head s2, meet [s1, tail s2]]
				fi
			    fi
			};

		apply == func [n : val Short; s : val S] val S {
		(* if n is a result or mem node then merge that with s;
			else just return s *)
			if is_result [nodes.n] cor is_mem [nodes.n] then
				S$meet [S$create [n], s]
			else s
			fi
		
		    };

		print == func [s : val S] val Void {

			if not is_nil [s] then 
			  put [head s]; put [" "]; S$print [tail s]
			fi

		    };
	    }
    in
	L export { New; V; :=; top; equal; meet; apply; member; print
; create
							}
    ni
}

let
    z == 0.0;
    Complex == record { re,im : Float }
               with C {
                        * == func[x,y : val C]
                                 { C$Mk[re[x]*re[y] - im[x]*im[y],
                                        re[x]*im[y] + im[x]*re[y]] } };
    x == Complex$New[];
    i == Short$New[];
in
    re[x] := 0.707; im[x] := 0.707;  (* roughly 8th root of unity *)
    i := 0;
    do  i < 4 ==>   put[re[x]]; put[" + "]; put[im[x]]; put["i\n"];
                    x := x * x;
                    i := i + 1;
    od
ni

# include "defs.h"
# define ABS(I) (if I < 0 then - I else I fi)
# define NULLNODE (-1)

(* The MEMNODE is both source and sink of edges, unlike the other standard
	nodes which are only sources; when an edge goes TO MEM it indicates
	an argument gets squirrelled away *)

func [graph_size, num_fns : val Short; Vflag : val Boolean] {
let

	put_list == func [l : val List [Short]] val Void {
		if not is_nil [l] then 
		  put [head l]; put [" "]; put_list [tail l]
		fi
	    };

    ResultNode == extend {ChStr}; (* Fn name *)
    ArgNode == prod {
		    fn : val ChStr;
		    fn_node : val Short; (* the node representing the result *)
		    num : val Short
		};
    AllocNode == extend {Short}; (* size/atomicity *)  
			
    NodeInfo == union {
		    result : val ResultNode;
		    arg : val ArgNode;
		    alloc : val AllocNode;
		    mem : val Boolean;
		    none : val Boolean;
		    static : val Boolean;
		    stack : val Boolean
		    };
			
    Nodes == Array [graph_size, NodeInfo];

    Edges == Array [graph_size, (List [Short])];

    DForder == func [edges : val Edges; size : val Short; impure]
							val (List [Short]) {
		let mark == (Array [size, Boolean])$New [];
		    list == (List [Short])$New [];
		    root == Short$New [];
		    n == Short$New [];
		    search == func [n : val Short; impure] val Void {
			    let es == (List [Short])$New []
			    in
				mark.n := True;
				es := edges.n;
				do not is_nil [es] ==>
					if not [mark.(head es)] then
						search [head es]
					fi;
					es := tail es
				od
			    ni;
			    list := cons [n, list]
			}
		in
		    n := 0;
		    do n < size ==>
			mark.n := False;
			n += 1
		    od;

		    list := (List [Short])$'';
		    root := 0;
		    (* while there are unmarked nodes search the next one *)
		    do (* put next unmarked node in root *)
			((do root < size cand mark.root ==> root += 1 od);
			root < size)

		    ==>
				search [root]
		    od;

		    list (* returned *)
		ni
	};

    LocTable === (Array [500, Short]);(* gives node # for representative
						of the size of alloc, or the
						result node for MAYBEALC fns *)

    Summary === extern {"summary"} [num_fns, Vflag];

    NodeTable == extern {"hash"} [50, Short, Short, NULLNODE];
    		(* keys are loc sizes/atomicity - i.e. +ve or -ve *)
		(* values are node numbers *)

	(* these next two are really only needed inside flow function, 
	    except for type arg to flow, which references FnSumm *)
	TwoBits === prod { mem, thro : val Boolean };
	FnSumm === prod {
		code : val Short;
		size_or_argnum : val Short;
		numargs : val Short;
		args_summ : val (List [TwoBits])
	    };

    (* the NodeTable and nextnode are only needed during the building stages *)
    Graph == prod {
		nodes : val Ref Nodes;
		preds : val Ref Edges;
		succs : val Ref Edges;
		sizednodes : val Ref NodeTable;
		nextnode : val Ref Short;
		firstalloc : val Ref Short
	      }

	with G {
	Init == func [] val G {
		let n == Nodes$New [];
		    p == Edges$New [];
		    s == Edges$New [];
		    sa == NodeTable$Init [];
		    next == Short$New [AVAIL_NODE];
		    firstalloc == Short$New [next]
		in
		    n.GENERICNODE := NodeInfo$from_alloc [AllocNode$In 0];(* 0 => unknown size/ atomicity *)
		    n.MEMNODE := NodeInfo$from_mem [True];
		    n.NONENODE := NodeInfo$from_mem [True];
		    n.STATICNODE := NodeInfo$from_static [True];
		    n.STACKNODE := NodeInfo$from_stack [True];

		    G$Mk [(Ref Nodes)$In [n], (Ref Edges)$In [p], 
			  (Ref Edges)$In [s],
			  (Ref NodeTable)$In [sa], (Ref Short)$In [next],
			  (Ref Short)$In [firstalloc] ]

		ni
	    };

	function_nodes == func [name : val ChStr;
				(*index,*) num_args : val Short;
					graph : val G; 
			base : var Short;
							impure] val Short {

		let n == (nodes [graph])^;
		    next == V[(nextnode [graph])^];
		    a == Short$New [1]
		in
		    n.next := NodeInfo$from_result [ResultNode$In [name]];
		    do a <= num_args ==>
			n.(next + a) := NodeInfo$from_arg [
						ArgNode$Mk [name, next, a]];
OPEN
put "\n";put (next + a);put " th node is argnode";
CLOSE
			a += 1
		    od;
		    (nextnode [graph])^ := next + num_args + 1;
		    (firstalloc [graph])^ := (nextnode [graph])^;
			(* the value left here after all calls to this
					function is the desired value *)

OPEN
put "\n";put next;put "th node is the result node for ";put name;put "\n";
CLOSE

base :=		    next (* return the first position used here *)
		ni

	    };

	alloc_node == func [size : val Short; graph : val G; impure] 
							     val Short {
				(* includes check for already existing *)
			    if size = 0 then
				GENERICNODE (* return node for 0-sized objs *)
			    else 
				let abssize == ABS(size);
				    table == (sizednodes [graph])^;
				    node == lookup [abssize, size, table]
				in
				   if (node <> NULLNODE) then
					node (* return node for allocs of this size*)
				   else
				     (* create a node for this size of alloc *)
				     let next == V[(nextnode [graph])^];
					 n == (nodes [graph])^
				     in
					insert [abssize, size, next, table];
					n.next := NodeInfo$from_alloc [
						AllocNode$In [size]];
OPEN
put next;put "th node is allocnode for size ";put size;put "\n";
CLOSE

					(nextnode [graph])^ := next + 1;
					next (* return *)
				     ni
				   fi (* there already ?*)
				ni
			    fi (* 0-sized ? *)
		};

	link == func [n, m : val Short; graph : val G; impure] val Void {

			let ss_of_n == ((succs [graph])^).n;
			    ps_of_m == ((preds [graph])^).m
			in
				ss_of_n := cons [m, ss_of_n];
				ps_of_m := cons [n, ps_of_m]
			ni
	    };

	args_edges == func [reached_node : val Short;
			    locs : val LocList;
			    loctable : val LocTable;
			    graph : val G; 
			    LocList : type L
				{loc_map : func [val L;
					         val LocTable; 
				     		 func [val Short;impure] 
								val Void;
						 impure]
					    			val Void;
				 print : func [val L; impure] val Void };
			    impure] val Void {

			let n == (nodes [graph])^
			in
OPEN
put "Locs that reach the node ";
if reached_node = MEMNODE then put "MEM : "
else put reached_node; put " : "  fi;
LocList$print [locs];
put "Of those the ARGS are ";
CLOSE
				LocList$loc_map [locs, loctable,
					func [l : val Short; impure] val Void {
					    if is_arg [n.l] then
OPEN
put [l];put " ";
CLOSE
						link [l, reached_node, graph];
					    fi
					}];
OPEN
put "\n"
CLOSE
			ni
		};

	result_edges == func [resultnode : val Short;
			      locs : val LocList;
			      loctable : val LocTable;
			      graph : val G;
			      LocList : type L
				{loc_map : func [val L;
					         val LocTable; 
				     		 func [val Short;impure] 
								val Void;
						 impure]
							       val Void };
			      impure] val Void {

OPEN
put "\nNodes that reach the resultnode ";
put resultnode;put ": ";
CLOSE

(* I am not allowed to claim that a fn is an allocator unless any object it
   might return is not on memory's list. Once I put an edge from a loc's node
   to the result node I am assuming that if that is the only node that reaches
   then the fn is an allocator !!!!  I really have to replace any locs that
   are in mem by nonenode *)
			    LocList$loc_map [locs, loctable,
				(* function on nodes *)
				func [l : val Short; impure] val Void {

				    link [l, resultnode, graph];
OPEN
put l; (*  **************** *)
put " "
CLOSE
				}];
OPEN
put " (linked to the resultnode)\n"
CLOSE
		};

	print == func [graph : val G; impure] val Void {

		put "\n**** The Nodes of the Graph ****\n";
		let n == Short$New [0];
		    numnodes == (nextnode [graph])^;
		    ns == (nodes [graph])^;
		    ss == (succs [graph])^
		in
		    do n < numnodes ==>
			put n;
			let node == ns.n;
			    edges == (List [Short])$New []
			in
			    if is_result [node] ==>
				put " RESULT for ";
				put [to_result node]

			    # is_arg [node] ==>
				put " ARG # ";
				put [num [to_arg node]];
				put " for ";
				put [fn [to_arg node]]

			    # is_alloc [node] ==>
				put " ALLOC with size ";
				put [to_alloc node]

			    # else ==>
				put " MEM/NONE/STATIC/STACK"

			    fi;	

			    edges := ss.n;
			    put " Succs :";
			    do not is_nil [edges] ==>
				put [head edges]; put " ";
				edges := tail edges
			    od;

			    put "\n"
			ni;
			n += 1
		    od
		ni
	    };

	flow == func [graph : val G; summary_outfile : val SI;
			SI : type S {
				   write_summ : func [val ChStr;
					val FnSumm;val S;impure] val Void};
							impure] val Summary {

	    let numnodes ==  V[(nextnode [graph])^];
		fa == V [(firstalloc [graph])^];

		nnns == V [(nodes [graph])^];
		RR == extern {"resultsummary"} [nnns, Nodes, NodeInfo];
		RRArray == Array [numnodes, RR];

		TwoBitsArray == Array [fa, TwoBits];

	    whither_args == func [graph : val G; impure] val TwoBitsArray {

		(* arg info - needs a backward pass from MEM and result
		   nodes; need to carry lists of result nodes (and MEM) node
		   encountered on the path back. Apply involves adding the
		   current node to the list, if it is a result or mem node.
		   If the list at an argnode changes on a pass, have to repeat.
		   Start with empty lists at all nodes. Meet is a union op.

		   Decide whether to store values before or after apply ??
			Once the flow is over, look at argnodes and see if
		   either MEM or the corresponding result node is on the list;
		   Set the bits in the summary accordingly. *)

		let ns == V[(nodes [graph])^];
		    AA == extern {"argsummary"} [ns, Nodes, NodeInfo];
		    Args == (Array [numnodes, AA]);
		    args == Args$New [];
		    i == Short$New [0]
		in

		   (* init the nodes to top (empty list) *)
		   do i < numnodes ==>
		   (*this should put MEM and resultnodes onto their own lists *)
			args.i := AA$apply [i, AA$top []]; 
			(* if is_result or is_mem i then AA$create [i]
				else AA$top [] fi*)
			i += 1
		   od;
		let change == Boolean$New [True];
		    nodelist == (List [Short])$New [];
		    DFlist == DForder [(preds [graph])^, numnodes]
		in
		    (* Iterate until no change *)
		    do change ==>
			change := False;
			nodelist := DFlist;
			do not is_nil [nodelist] ==>

			    let node == head nodelist;
				tmp == AA$New [];
				ss == (List [Short])$New []

			    in
				tmp := AA$top;
				(* meet over all succs of node *)
				ss := ((succs [graph])^).node;
				do not is_nil [ss]  ==>
				    tmp := AA$meet [args.(head ss), tmp];
				    ss := tail ss
				od;
 				(* apply *)
				tmp := AA$apply [node, tmp];
				(* if is_result or is_mem node then 
					AA$meet [AA$create [node], tmp]
				    else tmp fi *)

				(* check for change *)
				if (not change) then
				  if (not AA$equal [tmp, args.node])
				  then change := True
				  fi
				fi;
				(* update the value *)
				args.node := tmp

			    ni; (* node, tmp *)
			    nodelist := tail nodelist
			od (* nodelist *)
		    od; (* change *)
		ni; (* change *)
		(* Now the lists in the arg positions need to be searched
			for MEM or the corresponding result node *)

		let summ == TwoBitsArray$New []
		in
		i := 0;
		do i < fa ==>
		    if is_arg [ns.i] then
			let argnode == to_arg [ns.i];
			    mem == AA$member [MEMNODE, args.i];
			    thro == AA$member [fn_node [argnode], args.i]
			in
			(* in fact if it reaches mem then I don't care
						if it reaches its result *)
				summ.i := TwoBits$Mk [mem, thro];
OPEN
if mem or thro then
	put i;put ": ";
	put "Arg #";put [num [argnode]];
	put " of ";
	put [fn [argnode]]; 
	put " reaches";
	if mem then put " MEM, " fi;
	if thro then put " the result" fi;
	put "\n"
fi (* mem or thro *)
CLOSE
			ni;
		    fi; (* is_arg *)
		    i += 1
		od;

			summ (* returned *)

		ni (* summ *)
		
		ni (* AA, args *)

	      };

	    whence_results == func [graph : val G; impure] val RRArray {

		(* result info - forward pass from the standard nodes, and
		   allocnodes. Start with top at all nodes. 
		   The values are just single things - code and size. The meet
		   operation is complicated. The Apply is only interesting at 
		   the standard and allocnodes.
			Once the flow is over the values I want are in the
		   result nodes.		*)

		let results == RRArray$New []
		in

		(* init the nodes to top *)
		let i == Short$New [0]
		in
		   do i < numnodes ==>
		   (* this should set all but resultnodes to themselves,
				resultnodes to top *)
			results.i := RR$apply [i, RR$top []]; 
			i += 1
		   od
		ni;
		
		let change == Boolean$New [True];
		    nodelist == (List [Short])$New [];
		    DFlist == DForder [(succs [graph])^, numnodes]
		in
		    (* Iterate until no change *)
		    do change ==>
			change := False;
			nodelist := DFlist;
			do not is_nil [nodelist] ==>

			    let node == head nodelist;
				tmp == RR$New [];
				ps == (List [Short])$New []
			    in
				tmp := RR$top [];
				(* meet over all preds of node *)
				ps := ((preds [graph])^).node;
				do not is_nil [ps]  ==>
				    tmp := RR$meet [results.(head ps), tmp];
				    ps := tail ps
				od;
				(* apply *)
				tmp := RR$apply [node, tmp];
				(* check for change *)
				if (not change) then
				  if (not RR$equal [tmp, results.node])
				  then change := True
				  fi
				fi;
				(* update the value *)
				results.node := tmp

			    ni; (* node, tmp *)
			    nodelist := tail nodelist
			od (* nodelist *)
		    od; (* change *)

		ni; (* change *)

(* the values now in the resultnode positions are the 
	desired values *)
OPEN
let i == Short$New [AVAIL_NODE];
in
    do i < fa ==>
	let node == ((nodes [graph])^).i
	in
	    if is_result [node] then
		put [Out [to_result [node]]];
		put "'s result summary node is : ";
		RR$put [results.i]; put "\n"
	    fi
	ni;
	i += 1
    od
ni;
CLOSE

			results (* returned *)
		ni (* results *)
	      }; (* whence_results *)


	    (**********************************)
	    argsumm == whither_args [graph];
	    resultsumm == whence_results [graph];
	    (***********************************)

	    ns == (nodes [graph])^;

	    summary == Summary$Init [];

	    i == Short$New [AVAIL_NODE]

	    in
		(* now I can go through the two arrays function by function
			and produce a full summary for the function *)
		do i < fa ==> (* or count by num_fns *)
		    let name == Out [to_result [ns.i]];
			n == Out [resultsumm.i];
				 (* n is THE node that reaches the result *)
			code == if n = NONENODE   ==> ALCNIL
				#  n = STATICNODE  ==> ALCSTAT
				#  n = STACKNODE   ==> ALCSTACK
				#  n = TOP         ==> ALCNIL
				(* no path from ALLOC or STD node to the 
					result; seems equiv to NONE *)
				# is_alloc [ns.n] ==> ALLOC
				# is_arg [ns.n] cand
					(fn_node [to_arg [ns.n]] = i) 
					(* it is an arg of this function *)
					cand (num [to_arg [ns.n]] 
							< MAXWATCHARGS)
						  ==> ASSIGN
				# else 		  ==> ANY
		(* should I produce UNSAFE in some cases ?? *)
				fi;

			sizeorargnum == if code = ALLOC then 
						Out [to_alloc [ns.n]]
					elsif code = ASSIGN then
						num [to_arg [ns.n]]
					else 0
					fi;
			arglist == (List [TwoBits])$New [];
			num_args == Short$New [0]
		    in
			i += 1; (* for the result node *)
			arglist := (List [TwoBits])$'';
			do (i < fa) cand (is_arg [ns.i]) ==>
			    num_args += 1;
			    arglist := cons [argsumm.i, arglist];
			    (* note that the arglist is in reverse order -
				the head is the num_args'th one *)
			    i += 1
			od;

			let fs == FnSumm$Mk [code, sizeorargnum, 
						 num_args,arglist]
			in
(*at the moment append also prints the info *)
			    append [name, fs, summary];
			    write_summ [name, fs, summary_outfile]
			ni
		    ni
		od;

		summary (* returned *)
	    ni
	    } (* flow *)

	} (* with *)

in 
		Graph 

export {Init; function_nodes; alloc_node;
			args_edges; result_edges; print; flow }
ni}

# include "defs.h"
(* This is a hash table of summary info for functions. 		*)
(* Vflag indicates that some information should be written out 	*)
(* in user readable form.				       	*)
func [numfns : val Short; Vflag : val Boolean] {

    let 
	put_list == func [l : val List [Short]] val Void {
		if not is_nil [l] then 
		  put [head l]; put [" "]; put_list [tail l]
		fi
	    };

	TwoBits === prod { mem, thro : val Boolean };

	FnSumm === prod {
			code : val Short;
			size_or_argnum : val Short;
			numargs : val Short;
			args_summ : val (List [TwoBits])
		    };

	print == func [name : val ChStr; fnsumm : val FnSumm; impure] 
								val Void {
			put "Summary for ";put name;put " : ";
			put [let c == code fnsumm in
				if c = ALCNIL ==> "unknown"
				# c = ANY ==> "unknown"
				# c = ALCSTAT ==> "ptr to data seg"
				# c = ALCSTACK ==> "ptr to stack"
				# c = ALLOC ==> "allocated object"
				# c = ASSIGN ==> ""
				# else ==> "unknown"
				fi
			      ni];
			if code[fnsumm] = ALLOC cand
			   size_or_argnum [fnsumm] <> 0 then 
				put " size = ";put [size_or_argnum fnsumm]
			elsif [code fnsumm] = ASSIGN then
				put " arg# ";put [size_or_argnum fnsumm]
			fi;
			put "\n";
			let i == Short$New [numargs fnsumm];
			    as == (List [TwoBits])$New []
			in
			    as := args_summ [fnsumm];
			    do i > 0 ==>
				if mem [head as] then
				    put "    arg # ";put i;
				    put " goes to memory;\n"
				fi;
				if thro [head as] then
				    put "    arg # ";put i;
				    put " passed through;\n"
				fi;
				as := tail as; i -= 1
			    od
			ni			
		}; (* print *)

	noInfoFn == FnSumm$Mk [NULLCAT, 0, 0, (List [TwoBits])$''];

	CallSumm === prod { category : val Short;
			    supplement : val Short };

	hash == func [sym : val ChStr] val Short {
		let l == len [sym]
		in
			(31 * ChStr$Out[sym] + 5 * sym.(l - 1) + l)
		ni
		};

	TTT == extern {"hash"} [numfns, ChStr, FnSumm, noInfoFn];

	Table == TTT  with T {

	    look == func [name : val ChStr; t : var T] val FnSumm {
			T$lookup [hash name, name, t]
		    }

	     } (* with *)

    in prod  P {
	table : val Ref [Table];
	arg_register : val Ref [Short]; (* to record special register 
					    for the only (last) arg passed 
					    to a call between categorizing 
					    the arg and the call *)
(* this forces you to call categorize_arg on all the args before categorizing
				the call *)
	   } with S {

	    Init == func [] val S {
		let table == Table$Init [];
		    arg_register == Short$New []
		in
			S$Mk [(Ref Table)$In [table],
			      (Ref Short)$In [arg_register]]
		ni
		};

	    (* insert a summary of function "name" into the table t *)
	    append == func [name : val ChStr; fnsumm : val FnSumm; 
						summ : val S; impure] {
			if Vflag then
			    print [name, fnsumm];
			fi;
			Table$insert [hash name, name, fnsumm, (table summ)^]
		    };

	    is_summarized == func [name : val ChStr; summ : val S; impure]
								val Boolean {
			(code [Table$look [name, (table summ)^]]) <> NULLCAT
		};

	    (* return a the category dictated by the result code for the
				function name in the table t *)
	    (* with this new scheme, it might be worth recording when a result
		can be an ALLOC or a STACK/STAT, since deallocation of such a
		result, and even one that could also be an arg, is allowable *)

	    categorize_call == func [name : val ChStr; summ : val S;impure] 
								val CallSumm {
OPEN
put "Categorize call to ";put name; put "\n";
CLOSE
			let s == Table$look [name, (table summ)^];
			    resultcode == if code s = NULLCAT then
					put name;put " NOT found in table\n";
						ANY
					  else  code s
					  fi;
			    other == if resultcode = ALLOC then 
					size_or_argnum s
				     elsif resultcode = ASSIGN then
				(* other is the special register in which the
				       arg that reaches thro is saved *)
				        (arg_register summ)^
			   	     else 0
				     fi
			in
OPEN
put " resultcode = ";put resultcode;
if resultcode = ALLOC cor resultcode = ASSIGN
then put " other field = ";put other
fi;put "\n";
CLOSE
			   CallSumm$Mk [resultcode, other]
			ni
		    };

	    (* return the category for an ARG op dictated by the bits in table 
		for the argnumth arg of function "name"; also record any arg
		that are passed thro - only needed if only one is passed through
		so overwrite previous value *)
	    categorize_arg == func [name : val ChStr; argnum : val Short;
		    			     summ : val S;impure] val Short {
OPEN
put "\nCategorize ARG#";put argnum;
put " cat = ";put [
CLOSE
		    if argnum >= MAXWATCHARGS then TOMEM
		    else
			let s == Table$look [name, (table summ)^]
			in
			    if code s = NULLCAT (* i.e. noInfo *)
			    then put name;put " NOT found in table\n";
				 TOMEM
			    else (* find the argnumth element on the list *)
				let i == Short$New [numargs s];
				    alist == (List [TwoBits])$New []
				in (* the head is the ith arg *)
				    alist := args_summ s;
				    do i > argnum ==>
					alist := tail alist;
					i -= 1
				    od;

				    let arginfo == head alist
				    in
					if mem arginfo then TOMEM
				        elsif thro arginfo then
(* code s is ASSIGN only if it is known that one and only one of the args 
   (one numbered less than MAXWATCHARGS)
  passes to result. The negative of that arg's number is the special register
  in which the arg value is assumed to be for the call to see. Record it now. 
  The arg is WATCHARG only if it is THE correct one *)
						if (code s = ASSIGN) cand
						   (size_or_argnum s = argnum)
						then 
						     (arg_register summ)^ := 
							- argnum;
						     WATCHARG
						     (* the arg only goes to
							result and will be treated
							as an ASSIGN *)
						else TOMEM
						fi
					else WATCHARG (* the arg goes nowhere *)
					fi
				    ni
				ni
			    fi (* code s = NULLCAT *)
			ni (* s *)
		    fi
OPEN
]
CLOSE
		}; (* categorize_arg *)

	   } (* with *) hide { Mk; New; table }

	

    ni
}

# define impure var Void
# define skip Null[]

(* Compile with rc -cpL *)

(* Lazy S-expression implementation.  A SEdelay primitive is added.  *)
(* Evaluation is automatically forced where appropriate.             *)
(* The SEdelay function is intended to be sugared as follows:        *)
# define delay(se) SEdelay[func[impure] {se}]

func[atype : type {}] {
  let
    UN == union U { atom : val atype;
                    cn: val CN;
                    lazy: func[impure] val Ref[UN];
                    empty_list: val Void };
    CN == prod { hd: val Ref[UN]; tl : val Ref[UN] };
    SE ==
      extend {Ref[UN]}
      hide { Out <<func[val extend {Ref[UN]}; impure] var UN>> }
      with SE {
        create_ref == func[x:val UN] val SE {
                        let
                            y == UN$New[]
                        in
                            y := x;
                            SE$In[y]
                        ni
                      };
        force == func[x: val SE; impure] val SE {
                    if
                        is_lazy[Out[x]^] ==>
                            (x^) := ((to_lazy[x^][])^); x
                    #   else        ==>
                            x
                    fi
                 };
        SEdelay == func[f: func[impure] val SE] val SE {
                     SE$create_ref[
                       UN$from_lazy[
                         func[impure] val Ref[UN] {
                           SE$Out[f[]]
                         }
                       ]
                     ]
                   };
        car == func[x: val SE; impure] val SE {
                  SE$In[hd[to_cn[force[x]^]]]
               };
        cdr == func[x: val SE; impure] val SE {
                  SE$In[tl[to_cn[force[x]^]]]
               };
        cons == func[x,y: val SE] val SE {
                  SE$create_ref[
                    UN$from_cn[ CN$Mk [SE$Out[x], SE$Out[y]] ]
                  ]
                };
        In == func[x: val atype] val SE {SE$create_ref[UN $from_atom[x]]};
        Out == func[x: val SE; impure] val atype {to_atom[force[x]^]};
        atom == func [x: val SE; impure] val Boolean {is_atom[force[x]^]};
        null == func [x: val SE; impure] val Boolean {is_empty_list[force[x]^]};
        nil == func[] val SE { SE$create_ref[UN$from_empty_list[Null]] }
      }
    in
      SE export { New; := ; V; car; cdr; cons; force; SEdelay;
                  In <<func[val atype] val SE>>;
                  Out <<func[val SE; impure] val atype>>;
                  atom; null; nil }
    ni
}

# include "defs.h"
# define QuadList (List [Short])

func [in_file : val File; max_quads : val Short;    ] {

(* is there a cleverer way to do this patching stuff ? *)

    let
      tablesize == Short$1024;
      MAXLABELSZ == 512;

      QorPL == union Q {
		quad : val Short;
		fn : val Short; (* only for strings that are names of fns
					being defined (BSF/BFN); the value is
					the index into fn_array, later *)
					
		patchlist : val QuadList;
	    };

      QorPLRef == extend {Ref [QorPL]} with Q {
	    create == func[x: val QorPL] {
		let
		    v == QorPL$New[];
		in
		    v := x;
		    Q$In[v]
		ni
	    }};

      Dtable == extern {"hash"} [tablesize, Short, Short, -1];

      Htable == extern {"hash"}[tablesize, ChStr, QorPLRef, QorPLRef$Nil []];

      (* hash function returns a POSITIVE number; the htable implementation
	 takes care of getting it in range *)
      hash == func [sym : val ChStr] val Short {
		let length == len [sym]
		in
			(31 * ChStr$Out[sym] + 5 * sym.(length - 1) + length)
		ni
		};

    in
	prod P {
	    dests : val Ref Dtable;
	    htable : val Ref Htable
		}

    with L {

	fn_def == func [opc : val Short] val Boolean {
			(opc = BSF) cor (opc = BFN)};

	branch == func [opc : val Short] val Boolean {
			(opc >= 1) cand (opc <= 3)};

	getstr == func [s : val ChStr; i : val Short; impure] val ChStr
		{
		    let c == readc [in_file] in
			if (c <> ChStr$In[0]) and (not [eof[in_file]])
			then
			    if (i + 1) >= MAXLABELSZ then
				write [File$stderr, "Label too long\n"];
				L$getstr [ChStr$'', 0]
			    else L$getstr [s ^* c, i + 1]
			    fi
			else s
			fi
		   ni
		};


	Init == func [] val L {(***********************************)

		let ht == Htable$Init [];
		    ds == Dtable$Init [];
		in
			L$Mk [(Ref Dtable)$In [ds], 
			      (Ref Htable)$In [ht]]
		ni
	    };

	(* should only be used for q a qd that is a branch *)
	q_for_lbl_at == func [q : val Short; labels : val L;impure] val Short
			 { lookup [q, q, (dests [labels])^] };

	exists == func [name : val ChStr; labels : val L; impure]
								val Boolean {
			(name <> ChStr$'') cand
				not (Htable$lookup [hash name, name, 
							(htable [labels])^]
					= QorPLRef$Nil [])
		    };

	is_defined_fn == func [name : val ChStr; labels : val L;impure]
								val Boolean {
		(* return True if there is an entry for this string and it is
			a fn variant; null strings result from CLI calls
			which I can't deal with (can't hash the string) *)
		    (name <> ChStr$'') cand
		    let	l == Htable$lookup [hash name, name, 
							(htable [labels])^]
		    in
		      not (l = QorPLRef$Nil []) cand is_fn [l^]
		    ni
		};

	def_fn_index == func [name : val ChStr; labels : val L; impure] 
								val Short {
		    let l == Htable$lookup [hash name, name, 
							(htable [labels])^]
		    in
		      to_fn [l^]	(* the value stored with the name *)
		    ni
		};


	process_string == func [curr_quad, opc, fn_def_num : val Short;
					labels : val L;	impure]	val ChStr {

	  let 		str == L$getstr [ChStr$'', 0]
	  in
(*
DEBUG( "\n");put curr_quad;put " "; DEBUG( str);
*)

	    if L$fn_def [opc] then
		(* enter the string with a fn variant *)
		let new_entry == QorPL$New []
		in
		    new_entry := QorPL$from_fn [fn_def_num];
		    Htable$insert [hash str, str, QorPLRef$create [new_entry],
							   (htable [labels])^]
		ni		
	    elsif L$branch [opc] cor (opc = LBL) then
	    (* do whatever needs to be done with hash table and patch lists *)
		let
		    h == hash [str];
		    l == QorPLRef$New[];
		in

		    l := Htable$lookup [h, str, (htable [labels])^];
		    if  l = QorPLRef$Nil []	(* i.e. not found *)
		    then

			let new_entry == QorPL$New [] in
			    if (opc = LBL) then
(*
DEBUG( "\ndef of new :"); DEBUG( str);
*)
				new_entry := QorPL$from_quad [curr_quad + 1]
				(* the defined lbl refers to the next quad *)
			    else 
(*
DEBUG( "\nuse of new :"); DEBUG( str);
*)
				new_entry :=
				  QorPL$from_patchlist [cons [curr_quad, QuadList $'']]
			    fi;

			    Htable$insert [h, str, QorPLRef$create [new_entry],
							   (htable [labels])^]
			ni (* new_entry *)

		    else (* str was in the table *)

			if (opc = LBL) then
(*
DEBUG( "\ndef of old :"); DEBUG( str);
*)
			(* map patch on QorPL$to_patchlist [l^]    i.e.
			for each j on pl set dests [j] to curr_quad + 1 *)
			    let patch == func [pl : val QuadList; impure]
							val Void {
				if is_nil [pl] then Null[]
				else
				    let j == head pl in
				        insert [j, j, curr_quad + 1, 
							(dests [labels])^];
				        patch [tail pl]
				    ni;
			    	fi;
			    } in patch [QorPL$to_patchlist [l^]] ni;
			    (* now the l patchlist can be replaced by the correct
			      quadnum for the label being defined	*)
			    l^ := QorPL$from_quad [curr_quad]

			elsif QorPL$is_quad [l^] then
(*
DEBUG( "\nuse,already defined :"); DEBUG( str);
*)
			    (* label already defined - it's quad is known *)
			    insert [curr_quad, curr_quad, QorPL$to_quad [l^],
							    (dests [labels])^]
			else
(*
DEBUG( "\nother use of old :"); DEBUG( str);
*)
			   l^ := QorPL$from_patchlist [cons [curr_quad, 
							  to_patchlist [l^]]];

			fi
		    fi (* l is not found *)

		ni (* h, l *)
	    fi; (* branch or LBL *)

	    str (* returned value *)

	  ni (* str *)

	} (* process string *)
      } (* with *) export { Init; q_for_lbl_at; exists; 
				is_defined_fn; def_fn_index; process_string}
ni
} (* func *)

(* This is a simple illustration of a parametrized data type. *)
(* The problem was suggested by Scott Danforth.               *)
(* It turned out to be a surprisingly useful test of the      *)
(* compiler.                                                  *)
let
    (* Point data type, with addition operation *)
    point == prod {
		xpos, ypos: val Float
	     } with p {
		+ == func [x, y: val p] {
			p$Mk[xpos[x] + xpos[y], ypos[x] + ypos[y]]
		     }
	     } export {Mk; +; xpos; ypos};

    (* Poor square root routine.  Actually it's now built in, but this *)
    (* is more interesting.                                            *)
    sqrt == func [x: val Float] {
		let
		    xn == Float$New[];
		    xnp1 == Float$New[];
		    eps == 0.0001;
		    abs == func[x:val Float] {
				if x > 0.0 ==> x # else ==> -x fi
			   }
		in
		    xn := x;
		    do abs((xnp1 := xn/2.0 + x/(2.0*xn)) - xn) > eps ==>
			xn := xnp1;
		    od;
		    xn
		ni
	    };

    (* Line data type, parametrized with respect to the type of points *)
    line == func [p: type P {xpos, ypos: func[val P] val Float}] {
		prod {
		    x, y: val p; (* end points *)
		} with L {
		    length == func[z: val L] {
				let
				    xdiff == xpos[x[z]] - xpos[y[z]];
				    ydiff == ypos[x[z]] - ypos[y[z]]
				in
				    sqrt[xdiff * xdiff + ydiff * ydiff]
				ni
			      }
		} export {Mk; length}
	    };

in use point, line[point] in
    (* length of line from (1,1) to (3,3) *)
    put[length[Mk[Mk[1.0, 1.0], Mk[3.0, 3.0]]]]; put "\n";
ni ni

# define fn  func[ x: val Short ] val Short

let
    Y == func[ g func[ fn] fn ] {
	     func [ x val Short ] val Short {
		 (g[Y[g]]) [x]
	     }   
	 };

    G == func[ f fn  ] {
	     func[ n val Short ] val Short {
		 if
		    n > 0 ==> n * f [n - 1]
		 #  n = 0 ==> 1
		 fi
	     }
	};

    fact == Y[G]

in

    let 
	x == Short$New[];

	getarg == func[FS: var Void] {
		    put["Factorial of? "];
		    get[FS]
		  };

	nl == func[] {put["\n"]};
    in

	x := getarg[FS];

	do

	    x >= 0  ==>  put[fact[x]];  nl[]; x := getarg[FS]

	od

    ni

ni

#define Short32 (* Short integers are 32 bits long     *)
		(* if not defined, 16 bits are assumed *)
#define skip Null[]

func [] {
  let
#   ifdef Short32
	 SMaxShort == 2147483647;
	 Sdig_size == 31; (* # of 1 bits in MaxShort *)
#   else
	 SMaxShort == 32767;
	 Sdig_size == 15; (* # of 1 bits in MaxShort *)
#   endif
    MaxShort == Long$In[SMaxShort];
    dig_size == Long$In[Sdig_size];
    (* Build the n-fold concatenation of a string c *)
    repeat   ==  func[c: val ChStr; n: val Short] val ChStr {
                   let
		     curr_exp == Short$New[];
		     curr_power == ChStr$New[];
		     curr_result == ChStr$New[];
		     rem_n == Short$New[];
		   in
                     (* curr_exp := 1; *)
                     curr_power := c;
                     curr_result := "";
                     rem_n := n;
                     do rem_n > 0 ==>
                       (* curr_result * c^(rem_x*curr_exp)  =  y^x *)
                       (* curr_power = c^curr_exp, * = concat,     *)
		       (* ^ = repeated concatenation		   *)
                       if rem_n % 2 = 1 then
                           (* rem_n -= 1; *)
                           curr_result := curr_result ^* curr_power
                       fi;
                       (* curr_exp *= 2; *)
		       rem_n := rem_n/2;
                       curr_power := curr_power ^* curr_power;
                     od;
                     curr_result
		   ni
                 };
  in
    extend {Long} with L {
	from_Float == func[x: val Float] val L {
			(L$In<<func[val Long]val L>>)[to_Long[x]]
		      };

	from_Short == L$In<<func[val Short]val L>>;
	to_Short == L$Out<<func[val L]val Short>>;

	from_Long == L$In<<func[val Long]val L>>;
	to_Long == L$Out<<func[val L]val Long>>;

        (* Compute y^x, x >= 0 *)
	**   ==  func[y,x: val L] val L {
                   let
		     curr_exp == L$New[];
		     curr_power == L$New[];
		     curr_result == L$New[];
		     rem_x == L$New[];
		   in use L in
                     (* curr_exp := 1; *)
                     curr_power := y;
                     curr_result := 1;
                     rem_x := x;
                     do rem_x > 0 ==>
                       (* curr_result * y^(rem_x*curr_exp)  =  y^x *)
                       (* curr_power = y^curr_exp *)
                       if
			   odd[rem_x]  ==>
                               (* rem_x -= 1; *)
                               curr_result *= curr_power
                           # else ==>
                               skip
                       fi;
                       (* curr_exp *= 2; *)
		       rem_x := shift[rem_x, -1];
                       curr_power *= curr_power;
                     od;
                     curr_result
		   ni ni
                 };

	(* A fast version of factorial:  *)
	! == func[n: val L] val L {
		use L in let
		    (* Compute n * (n-m) * (n-2m) * ...  *)
		    f == func[n, m: val L] {
			    let
				k == 2 * m
			    in
				if n > m then
				    f[n, k] * f[n-m, k]
				else
				    n
				fi
			    ni
			 };
		in
		    if n = 0 then
			1
		    else
			f[n,1]
		    fi
		ni ni
	     };
    
	(* Convert a Long to a Float. Caller is responsible for checking *)
	(* that an overflow will not occur.                              *)
	to_Float == func [x: val L] val Float {
			use L in let
			    nbits == 15;  (* Number of bits that can *)
					  (* be converted at once    *)
			    Snbits == L$to_Short[nbits];
			    result == Float$New[];
			    rem == L$New[];
			    log_multiplier == Short$New[];
			    tmp == L$New[];
			    c_chunk == Short$New[];
			    sgn == use Short in
				     if x < L$0 ==> -1.0 # else ==> 1.0 fi
				   ni
			in
			    result := use Short in 0.0 ni;
			    log_multiplier := Short$0;
			    rem := L$abs[x];
			    do rem <> 0 ==>
				tmp := shift[rem, -nbits];
				c_chunk := L$to_Short[rem - shift[tmp, nbits]];
				rem := tmp;
				result := result + shift[Float$In[c_chunk],
							 log_multiplier];
				log_multiplier += Snbits;
			    od;
			    sgn * result
			ni ni
		    };

	abs == func [x: val L] { if x <= L$0 ==> -x # else ==> x fi };
	sign == func [x: val L] val L {
		    use L in
		      if x < 0 ==> -1
		      #  x > 0 ==> 1
		      #  else  ==> 0
		      fi
		    ni
		};
	min == func [x,y: val L] { if x < y ==> x # else ==> y fi };
	max == func [x,y: val L] { if x > y ==> x # else ==> y fi };

	-= == func [x: var L; y: val L] val L { x := x - y };
	+= == func [x: var L; y: val L] val L { x := x + y };
	*= == func [x: var L; y: val L] val L { x := x * y };
	/= == func [x: var L; y: val L] val L { x := x / y };

	(* Compute 2^n/x using Newton iteration: *)
        (* new = old * (2^(n+1) - x*old) * 2^-n  *)
	(* Assumes x > 0			 *)
	(* The result is only approximate	 *)
	inv == func [x: val L; n: val L]  val L {
		   use L in let
			cutoff == 1024;  (* < cutoff bits ==> use division *)
			xlen == nbits[x];
			rlen == n - xlen + 2; (* upper bound on  *)
					      (*  result length. *)
			half_prec == rlen/2;
		   in
			if rlen < cutoff cor xlen < half_prec then
			    shift[1,n]/x
			else
			    let
				xscale_amount == xlen - half_prec - 1;
				appr_inv == inv[shift[x, - xscale_amount],
                                                rlen];
				inv_scale_amount ==  n - rlen
						     - xscale_amount;
			    in
				shift[shift[appr_inv, n+1-inv_scale_amount]
                                      - x * (appr_inv * appr_inv),
				      2*inv_scale_amount - n];
			    ni
			fi
		   ni ni
	       };

	(* Compute an approximation (accurate to +- 3) to sqrt(x) *)
	sqrt == func [x: val L]  val L {
		   use L in let
			cutoff == 96;  (* < cutoff bits ==> use floating pt *)
			fast_div_threshold == 4096;
			xlen == nbits[x];
		   in
			if xlen < cutoff then
			    L$from_Long[to_Long[sqrt[to_Float[x]]]]
			else
			    let
				half_len == shift[xlen, -1];
				scale == if odd[half_len] then
					     half_len - 3
					 else
					     half_len - 2
					 fi;
				appr_sqrt == shift[
                                                sqrt[shift[x, -scale]],
						shift[scale, -1]];
				quotient == if xlen < fast_div_threshold then
						x/appr_sqrt
					    else
						appr_div[x, appr_sqrt]
					    fi;	
			    in
				shift[appr_sqrt + quotient, -1]
			    ni
			fi
		   ni ni
	       };

	(* Fast division using above inverse routine, assumes args >= 0 *)
	    fast_div ==
		func[x,y: val L] val prod {q: val L; r: val L} {
		    use L in let
			ly == nbits[y];
			lx == nbits[x];
			lr == lx - ly;
			inv_bits == lr + 2;
			scaled_y == shift[y, inv_bits - ly];
			scaled_x == shift[x, inv_bits - lx];
			appr_inv == inv[scaled_y, 2 * inv_bits];
			quotient == L$New[];
			remainder == L$New[];
			nq == L$New[];
		    in
			quotient := shift[scaled_x * appr_inv, 
					  lx - ly - 2 * inv_bits];
			remainder := x - quotient * y;
			if remainder >= shift[y,1] then
			    nq := remainder/y;
			    quotient += nq;
			    remainder -= nq * y;
			elsif remainder >= y then
			    quotient += 1;
			    remainder -= y;
			    nq := 1;
			elsif remainder < 0 then
			    nq := (-remainder)/y + 1;
			    quotient -= nq;
			    remainder += nq * y;
			else
			    nq := 0;
			fi;     
			if nwords[nq] > 1 then
			    put "Fast_div blew it\n"
			fi;
			prod {q: val L; r: val L}$Mk[quotient, remainder]
		    ni ni
		};

	(* Approximate division *)
	    appr_div ==
		func[x,y: val L] val L {
		    use L in let
			ly == nbits[y];
			lx == nbits[x];
			lr == lx - ly;
			inv_bits == lr + 2;
			scaled_y == shift[y, inv_bits - ly];
			scaled_x == shift[x, inv_bits - lx];
			appr_inv == inv[scaled_y, 2 * inv_bits];
		    in
			shift[scaled_x * appr_inv, 
			      lx - ly - 2 * inv_bits]
		    ni ni
		};

	(* Divide and conquer base conversion: *)
	    fast_puts ==
		func[x: val L] val ChStr {
		    if x < L$0 then
			"-" ^* fast_puts1[x]
		    else
			fast_puts1[x]
		    fi
		};

	    fast_puts1 ==
                func[x: val L] val ChStr {
		    let 
			cutoff == 256;
                             (* < cutoff words ==> use naive algorithm *)
			l == to_Short[nwords[x]];
		    in
			if l < cutoff then
			    puts[x]
			else
		            let
				dec_power == 5 * l;
				divisor == L$In[10] ** L$In[dec_power];
				split == fast_div[x, divisor];
				quotient == q[split];
				remainder == r[split];
				head == fast_puts1[quotient];
				tail == fast_puts1[remainder];
				length == len[tail];
				zeroes == repeat["0", dec_power-length];
			    in
				head ^* zeroes ^* tail
			    ni
			fi
		    ni
		};

	(* Binary gcd algorithm *)
	gcd == func[x,y: val L] val L {
		flush[File$stdout];
		use L in let
		    u == New[abs[x]];
		    v == New[abs[y]];
		    t == New[1];
		    k == New[Short$0];
		    '-1' == -1;
		    used_u == Boolean$New[];
		in
		    if x = 0 then
			y
		    elsif y = 0 then
			x
		    elsif y = 1 then (* common case that can be sped up *)
			1
		    else
			do not[odd[u]] cand not[odd[v]] ==>
			    k := k + Short$1;
			    u := shift[u,'-1'];
			    v := shift[v,'-1'];
			od;
			if odd[u] then t := - v
			else t := u
			fi;
			do t <> 0 ==>
			    do not[odd[t]] ==> t := shift[t,'-1'] od;

			    if t < 0 then
				v := - t
			    else
				u := t
			    fi;

			    t := u - v;
			od;
			shift[u,L$In[k]];
		    fi
		ni ni
	       };

	(* Convert to hex string representation *)
	hex_puts ==
	    func[x: val L; impure] val ChStr {
	      let
		 base == Short$16;
		 to_ChStr == func[x: val Short] {
				if x < 10 then
				    ChStr$In[x + Out["0"]]
				else
				    ChStr$In[x - 10 + Out["a"]]
				fi;
			     };
		 hputs1 == func[x: val L; impure] val ChStr {
			     use L in
			       if 
#                                ifdef UNDEFINED
				   (* The Russell code: *)
				     x > 0 ==> (hputs1[x/base])
					       ^* to_ChStr[x%base]
				   # x = 0 ==> ""
#                                else
				   (* The dirty (but much faster) hack: *)
				   x >= 0 ==>
				     let
				       s == func[val L; impure] val ChStr
						{ extern "_to_hex" } [x];
				       i == New[Short$0];
				       length == len[s];
				     in
				       (* Delete all leading 0s *)
					 do i < length cand s.i = Out["0"] ==>
					   i += Short$1;
					 od;
				       substr[s,i,length-i];
				     ni
#                                endif
			       # x < 0 ==> "-" ^* hputs1[-x]
			       fi
			     ni
			   };
	      in use L in
		  if x = 0 then "0" else hputs1[x] fi
	      ni ni
	    };
    }
  ni
}

(* A Fortran and C interface for the constructive real type 	*)
(* Note that Fortran function names end with an underscore. 	*)
(* Russell representations of machine integers (Short) are  	*)
(* compatible with C integers.  Similarly ChStr corresponds 	*)
(* to an immutable (char * ).  All storage allocation is    	*)
(* implicit.  The garbage collector will normally be 	    	*)
(* invoked implicitly. Constructive real numbers should be	*)
(* treated as opaque 32 bit quantities by the client.  They	*)
(* should not be stored in malloc'ed data areas.  If they are 	*)
(* to be stored in dynamically allocated memory, then that 	*)
(* memory should be allocated with gc_malloc, so that the	*)
(* collector will see it.					*)
(
  Expand_Hp[Short$200];
  let
    cr == extern {"cr/fusion"}[];
  in use Long in
    cr with C {
	crmult == C$*;
	crmult_ == func[x,y: var C] { x*y };
	cradd == C$+;
	cradd_ == func[x,y: var C] { x+y };
	crsub == C$- <<func[x,y:val C]val C>>;
	crsub_ == func[x,y: var C] { x-y };
	crneg == C$- <<func[x:val C]val C>>;
	crneg_ == func[x: var C] { -x };
	crdiv == C$/;
	crdiv_ == func[x,y: var C] { x/y };
	crsqrt == C$sqrt;
	crsqrt_ == func[x: var C] { sqrt x };
	crsin == C$sin;
	crsin_ == func[x: var C; impure] { sin x };
	crcos == C$cos;
	crcos_ == func[x: var C; impure] { cos x };
	cratan == C$atan;
	cratan_ == func[x: var C; impure] { atan x };
	crexp == C$exp;
	crexp_ == func[x: var C; impure] { exp x };
	crln == C$ln;
	crln_ == func[x: var C; impure] { ln x };
	crput == func[x: val C; prec: val Short; impure]
		{ put[x, Long$In[prec]] };
		(* Print on standard out to given precision 	*)
		(* prec is in units of decimal digits to the	*)
		(* right of the decimal.			*)
	crput_ == func[x: var C; prec: var Short; impure]
		      { put[x, Long$In[prec]]; put "\n" };
	crputs == func[x: val C; prec: val Short; impure]
		      { puts[x, Long$In[prec]] };
		(* Convert to character string *)
	crin == func[x: val Short] {C$In[Long$In[x]]};
	crin_ == func[x: var Short] {C$In[Long$In[x]]};
	crpi == C$pi;
	crpi_ == C$pi;
	crcomp == func[x,y:val C; r,a: val Short; impure] val Short {
		    compare[x,y,Long$In[r],Long$In[a]]
		  };
	    (* Return 0 if x = y to within the indicated tolerance, *)
	    (* -1 if x < y, and +1 if x > y.  If x and y are indeed *)
	    (* equal, it is guaranteed that 0 will be returned.  If *)
	    (* they differ by less than the tolerance, anything     *)
	    (* may happen.  The tolerance is specified in terms     *)
	    (* of a relative tolerance r (in bits) and an absolute  *)
	    (* tolerance a (in bits).  The tolerance allowed is     *)
	    (* the maximum of (abs(x)+abs(y))*(2**r) and 2**a       *)
	crcomp_ == func[x,y:var C; r,a: var Short; impure] val Short {
		    compare[x,y,Long$In[r],Long$In[a]]
		  };
	    (* Convert to double.  Accurate to +-1 digit in the last 	*)
	    (* place.  Note that with C conventions, this returns a 	*)
	    (* pointer to a double precision value.			*)
	    (* Assumes 32 bit Short, <= 60 bit mantissa double 		*)
	    (* precision floating point, with at most IEEE exponent	*)
	    (* range.							*)
	crtodouble == func[x: val C; impure] val Float {
	  		use Short in let
			   msb_pos == most_significant_bit_pos[x,-1100];
			   offset == msb_pos-61;
			   scaled == shift[x, -offset];
			   appr == Long$New[];
			   lsp == Long$New[];
			   msp == Long$New[];
			   fp_appr == Float$New[];
			in
			   appr := to_Long[scaled, -Long$2];
			   msp := shift[appr, -Long$31];
			   lsp := appr - shift[msp, Long$31];
			   fp_appr := shift[Float$In[Out[msp]], 31]
			   	      + Float$In[Out[lsp]];
			   shift[fp_appr, offset]
			ni ni
		      };
		(* Convert the other way.  The argument is a ptr to a 	*)
		(* double.						*)
	crfromdouble == func[x: val Float; impure] val C {
			    use Short in let
			    	e == exponent[x] - 70;
			    	scaled == to_Long[shift[x, -e]];
			    in
			        shift[C$In[scaled], e]
			    ni ni
			};
    } export {
	cradd; cradd_;
	crsub; crsub_;
	crmult; crmult_;
	crdiv; crdiv_;
	crneg; crneg_;
	crsqrt; crsqrt_;
	crsin; crsin_;
	crcos; crcos_;
	cratan; cratan_;
	crexp; crexp_;
	crln; crln_;
	crput; crput_;
	crputs;
	crin; crin_;
	crpi; crpi_;
	crcomp; crcomp_;
	crtodouble; crfromdouble;
    }
  ni ni
)

(* infinite precision calculator for any "curses" terminal *)
(* Must be compiled with -pL                 *)
# define KEYPAD
# undef KEYPAD

# define skip Null[]
# define info_loc(y,x) wmove[info_win,y,x]
# define info_put(s) wput[info_win,s]

let
  Win == extern { "window" } [];
  xLong == extern { "xlong" } [];
  pt == extern {"primes/prime_test" } [];
  sleep == func[val Short; impure] val Void { extern "_sleep" };
  system == func[val ChStr; impure] val Void { extern "_system" };
in use Win in
  let
    RIGHT == 0;		(* some procedure flags *)
    LEFT == 1;
    modes == enum {DEC, HEX, FLOAT};    (* Calculator display modes *)

    SIGINT == 2;                (* interrupt signal *)
    SIGWINCH == 28;             (* signal indicating window changed *)

    ScrnWid == Short$New[];     (* width of screen (columns) *)
    ScrnHgt == Short$New[];     (* height of screen (lines) *)
    Help_avail == Boolean$New[];  (* Enough space for help *)
    windows_exist == New[False];  (* They've been created *)
    Xwindows == New[False];
    MainWid == Short$New[];
    HistWid == Short$New[];
    MainHgt == Short$New[];
    StartPos == Short$New[];
    InfoHgt == 23;
    get_lines == func[impure] val Short { extern "_get_lines" };
    get_columns == func[impure] val Short { extern "_get_columns" };
    forced_resize == func[impure] val Boolean { extern "_forced_resize" };
			(* Returns true iff preceding call to get_lines *)
			(* or get_columns itself adjusted window size   *)

    (* Reset window dimensions to the given screen size.  Remove any *)
    (* existing windows.                                             *)
    reset_size == func[ncols, nlines: val Short; impure] {
		      ScrnWid := ncols;
		      ScrnHgt := nlines;
		      if ScrnWid < 17 (* not enough for Float *)
			 cor ScrnHgt < 6 then
			 if windows_exist then
			     echo[]; nocbreak[]; nl[]; endwin[];
			 fi;
			 write[File$stderr,
			       "Window too small\n"];
			 exit[1];
		      fi;
		      if windows_exist then
			if Help_avail then
			    delwin[info_win];
			fi;
			delwin[bord_win];
			delwin[main_win];
		      fi;
		      if ScrnHgt < 23 cor ScrnWid <50 then
			MainWid := ScrnWid-2;
			HistWid := MainWid+2;
			Help_avail := False;
			write[File$stderr,
			      "Not enough space for help window\n"];
			sleep[1];
		      else
			Help_avail := True;
			MainWid := ScrnWid-22;
			HistWid := MainWid+2;
		      fi;
		      StartPos := -MainWid/2;
		      old_pos := main_pos := StartPos;
		      MainHgt := ScrnHgt-3;
		  };

    make_windows == func[impure] val Void {
		      bord_win := Win$Mk[ScrnHgt-1,MainWid+2,0,0];
		      main_win := Win$Mk[MainHgt,MainWid,1,1];
		      hist_win := Win$Mk[1,HistWid,ScrnHgt-1,0];
		      if Help_avail then
			info_win :=
			     Win$Mk[InfoHgt,ScrnWid-MainWid-3,0,MainWid+3];
		      fi;
		      windows_exist := True;
		    };
		    
    history == New[""];
		    
    add_hist == func[s: val ChStr; impure] val Void {
    		    history := history ^* s;
    		    if len[history] >= HistWid then
    		        history := substr[history,
    		        	          len[history] - (HistWid-1),
    		        	          HistWid-1]
    		    fi;
    		    wmove[hist_win,0,0];
    		    wput[hist_win,history];
    		    wrefresh[hist_win];
    		    move_to_top_of_stack[];
    		};

    bord_win == Win$New[];
    main_win == Win$New[];
    info_win == Win$New[];
    hist_win == Win$New[];

    main_pos == Short$New[];
    old_pos ==	Short$New[];
    mode ==     modes$New[];
    working == 	Boolean$New[];

    update_info ==
	func[impure] val Void {
	  if Help_avail then
	    wmove[info_win,1,1];
	    use modes in let
		lc == -main_pos + if main_pos<0 ==> -1 # else ==> 0 fi;
		rc == -main_pos - MainWid +
			if (-main_pos-MainWid<0) ==> 1 # else ==> 0 fi;
		lst == puts[lc];
		rst == puts[rc];
		ll == New[len[lst]];
		lr == New[len[rst]];
		lpr == if ll <= 6 ==> lst # else ==> ll := 5; "*****" fi;
		rpr == if lr <= 6 ==> rst # else ==> lr := 5; "*****" fi;
		x == getx[main_win];
		y == gety[main_win];
		i == New[0];
	    in
		wput[info_win," ["]; wput[info_win,lpr];
		wput[info_win,","]; wput[info_win,rpr];
		wput[info_win,"]"];
		i := ll + lr;
		do i < 12 ==> wput[info_win, " "]; i += 1 od;
		info_loc(2,1);
		if (mode = HEX) ==>
		    wput[info_win," Hex mode    "];
		    info_loc(15,1); info_put("m float/dec mode");
		    info_loc(16,1); info_put("<,> scroll view");
		    info_loc(17,1); info_put("$ center");
		# (mode = DEC) ==>
		    wput[info_win," Decimal mode"];
		    info_loc(15,1); info_put("m hex/float mode");
		    info_loc(16,1); info_put("<,> scroll view");
		    info_loc(17,1); info_put("$ center");
		# (mode = FLOAT) ==>
		    wput[info_win," Float mode  "];
		    info_loc(15,1); info_put("m dec/hex mode  ");
		    info_loc(16,1); info_put("               ");
		    info_loc(17,1); info_put("        ");
		fi;
		wrefresh[info_win];
		wmove[main_win,y,x];	(* move cursor back to main_win *)
		wrefresh[main_win];
	    ni ni
	  fi
	};

    werror ==
	func[s: val ChStr; impure] val Void {
	  if Help_avail then
	    let
	      x == getx[main_win]; y == gety[main_win];
	    in
	      wmove[info_win,3,1];
	      wput[info_win,"                 "];
	      wmove[info_win,3,1];
	      wput[info_win,ChStr$In[7]];         (*beep*)
	      wput[info_win,s];
	      wrefresh[info_win];
	      wmove[info_win,3,1];
	      sleep[1];
	      wput[info_win,"                 "];
	      wrefresh[info_win];
	      update_info[];
	      wmove[main_win,y,x];
	      move_to_top_of_stack[];
	    ni
	  else
	    wput[main_win,ChStr$In[7]];         (*beep*)
	    wrefresh[main_win];
	  fi
	};

    move_to_top_of_stack ==
	func[impure] val Void {
	    wmove[main_win,trunc_sp[stack_ptr+1],0];
	    wrefresh[main_win];
	};

    get_prec ==
	func[impure] val Short {
	    MainWid + main_pos + 1;
	};

    sidestep ==
	func[amt, x: val Short; impure] val Void {
	  if amt = 0 ==>
	    if x = LEFT ==>
		main_pos -= MainWid-1;
	    # else ==>
		main_pos += MainWid-1;
	    fi;
	  # else ==>
	    if x = LEFT ==>
		main_pos -= amt;
	    # else ==>
		main_pos += amt;
	    fi
	  fi;
	  werase[main_win]; wrefresh[main_win];
	  update_info[];
	};

    working_flag ==
	func[impure] val Void {
	  if Help_avail then
	    wmove[info_win,3,1];
	    wput[info_win," working... "];
	    wrefresh[info_win];
	  fi;
	  working := True;
	};

    done_working ==
	func[impure] val Void {
	  if Help_avail then
	    wmove[info_win,3,1];
	    wput[info_win,"            "];
	    wrefresh[info_win];
	  fi;
	  working := False;
	  move_to_top_of_stack[];
	};

    (* Print a message in a position where it will be overwritten by *)
    (* the "working" flag.                                           *)
    print_msg ==
	func[msg: val ChStr; impure] val Void {
	    if Help_avail then
		wmove[info_win,3,1];
		wput[info_win, msg];
		wrefresh[info_win];
	    else
		wput[main_win, msg];
		wrefresh[main_win];
		sleep[1];
		display[];
	    fi;
	    move_to_top_of_stack[];
	};

    print_help ==
	func[impure] val Void {
	  if Help_avail then
	    info_loc(4,1); info_put("~ change sign");
	    info_loc(5,1); info_put("R square root");
	    info_loc(6,1); info_put("X exponential");
	    info_loc(7,1); info_put("P pi");
	    info_loc(8,1); info_put("S sine");
	    info_loc(9,1); info_put("K cosine");
	    info_loc(10,1); info_put("T arctan");
	    info_loc(11,1); info_put("I interchange");
	    info_loc(12,1); info_put("^ power (base>0)");
	    info_loc(13,1); info_put("L logarithm");
	    info_loc(14,1); info_put("Q copy bottom");
	    (* Leave room for M, <, >, $ *)
	    info_loc(18,1); info_put("[sp] enter");
	    info_loc(19,1); info_put("[bs] backup");
	    info_loc(20,1); info_put("? more help");
	    info_loc(21,1); info_put("^D quit");
	    wrefresh[info_win];
	  fi;
	};


    print_more_help ==
	func[impure] val Void {
	  if Help_avail then
	    wclear[info_win];
	    box[info_win,ChStr$Out["|"],ChStr$Out["-"]];
	    info_loc(1,1); info_put("=c save in loc");
	    info_loc(2,1); info_put("Gc get from loc");
	    info_loc(3,1); info_put("   where c is");
	    info_loc(4,1); info_put("   any character");
	    info_loc(5,1); info_put("^L redraw the");
	    info_loc(6,1); info_put("   screen");
	    info_loc(7,1); info_put("n<,n>, scroll n");
	    info_loc(8,1); info_put("       digits");
	    info_loc(9,1); info_put ("Z  truncate to");
	    info_loc(10,1); info_put("   integer    ");
	    info_loc(11,1); info_put("! factorial");
	    info_loc(12,1); info_put("# is it prime?");
	    info_loc(15,1); info_put("^C abort last");
	    info_loc(16,1); info_put("   calculation");
	    info_loc(18,1); info_put("hit any key to");
	    info_loc(19,1); info_put("return to");
	    info_loc(20,1); info_put("calculator");
	    wrefresh[info_win];
	    let c == wgetc[info_win]
	    in
		wclear[info_win];
		box[info_win,ChStr$Out["|"],ChStr$Out["-"]];
		print_help[];
		update_info[]
	    ni
	  fi
	};

    erase_one ==
	func[impure] val Void {
	    let x == getx[main_win]; y == gety[main_win];
		px == if x>0 ==> x-1 # else ==> 0 fi;
	    in
		wmove[main_win,y,px];
		wput[main_win," "];
		wmove[main_win,y,px];
		wrefresh[main_win];
	    ni
	};

    (* returns position of first occurence of character of c in s *)
    index ==
	func[s: val ChStr; c: val Short] val Short {
	    let i == Short$New[];
		l == len[s];
	    in
		i := 0;
		do (s.i <> c) cand i < l ==>
		    i += 1;
		od;
		if i = l ==> -1 # else ==> i fi;
	    ni
	};

    (* Display the the currently appropriate section of string s *)
    (* s is presumed to be a prefix of a real number containing  *)
    (* enough precision for the display request.                 *)
    putnum ==
	func[s: val ChStr; impure] {
	    let
		p == index[s, Out["."]];
	    in
		if p >= -main_pos ==> (* main_pos <= 0 && int part wraps off
					 left side of current view *)
		    wput[main_win,substr[s,p+main_pos,MainWid]];
		# p = -1 ==>
		    wput[main_win,"BLEAGH"];
		# else ==>
		    let x == getx[main_win]; y == gety[main_win];
			inc == -main_pos - p;	(* spaces between left side of
						   scrn and decimal pt *)
		    in
			if inc >= MainWid then
			    wput[main_win, "--->"];
			else
			    let
			      d == substr[s,0,MainWid-inc]
			    in
			      if d = " " then
				wput[main_win, "--->"];
			      else
				wmove[main_win,y,x+inc];
				wput[main_win,d];
			      fi
			    ni
			fi
		    ni
		fi;
		wrefresh[main_win];
	    ni
	};

   (*
    * Ascii codes
    *)
    esc_ch ==	ChStr$In[27];	(* ESC *)
    backsp ==   ChStr$In[8];    (* Backspace *)
    del_ch ==   ChStr$In[127];  (* Delete *)
    eof_ch ==	ChStr$In[4];	(* EOF *)
    redraw ==   ChStr$In[12];   (* ^L (redraw screen) *)
    cond_redraw == ChStr$In[1]; (* ^A, redraw if size is different   *)
				(* generated in response to SIGWINCH *)

   (*
    * keypad characters - keypad sends a sequence starting with esc_ch
    * and terminating in one of these.
    *)
    KEYPAD9 ==	"y";		(* 9 key on wyse and vi200		*)
    KEYPAD0 ==	"p";		(* 0 key on wyse and vi200		*)
    KEYPADDOT == "n";		(* . key on wyse and vi200		*)
    KEYPADPF1 == "P";		(* PF1 key on wyse *)
    KEYPADPF2 == "Q";		(* PF2 key on wyse *)
    KEYPADPF3 == "R";		(* PF3 key on wyse *)
    KEYPADPF4 == "S";		(* PF4 key on wyse *)
    KEYPADDASH == "m";		(* dash key on wyse, vi200 keypads *)
    KEYPADCOM == "l";		(* comma key on wyse keypad	*)
    KEYPADENT == "M";           (* enter key on wyse keypad     *)

    newline ==       func [impure] { wput[main_win,"\n"] };
#   define NL   newline[]

  (*
   * UNIX interface
   *)
    exit == func [val Short; impure] val Void { extern "_exit" };

    is_eof_char == func [c: val ChStr] val Boolean {Out[c] = 255};

    clear == func [impure] val Void { extern "_clearM" };

    refresh == func [impure] val Void { extern "_refreshM" };

  (*
   * Calculator stuff
   *)
    inf_p == extern { "cr/fusion" } [];    (* constructive reals           *)
    stack_lim ==        100;             (* max num of entries in stack  *)
    stack_elem == 	inf_p;		(* type of elements on stack	*)

   (*
    * define the stack
    *)
    stack_type == (Array[stack_lim, stack_elem])
	with I {
            (*
	     * subscription, with array 0 filled for <0 indices
	     *)
		sub == func[a: var I; i: val Short; impure]
			   val stack_elem {
			    if
				i >= 0 ==> I$.[a,i]
			    #   else  ==>  stack_elem$In[Long$0]
			    fi
		       };

		push == func[a: var I; sp: var Short;
			     new: val stack_elem] val Void {
			    sp += 1;
			    a.sp := new;
			};

		pop == func[a: var I; sp: var Short] val Void {
			 if
			     sp >= 0 ==> sp -= 1;
			 #  else    ==> skip;
			 fi
		       };
	} hide {V};	(* end of stack type definition *)

    (*
     * The cache of string representations of values
     *)

    ce_empty_flag == -Long$1000000;

    cache_entry == prod {
			ce_base: val modes; (* mode used to do base conversion *)
			ce_prec: val Long;  (* precision used in conversion    *)
			ce_string: val ChStr; (* output of base conversion     *)
		    } with CE {
			empty == func [] {
				    CE$Mk[modes$DEC, ce_empty_flag, ""]
				 };
			NNew == func[] var CE {
				    let
					r == CE$New[]
				    in
					r := CE$empty[];
					r
				    ni
				}
		    } with CE { New == CE$NNew };

    cache_type == Array[stack_lim, cache_entry];

    (* raise x to the power y *)
    power == func[x,y: val stack_elem; impure] {
		    stack_elem$power[x,y];
		};

   (*
    * misc variables and constants
    *)
    stack ==            stack_type$New[]; (* the stack *)

    cache ==            cache_type$New[]; (* A cache of print representations *)
					  (* for numbers, parallel to stack.  *)

    regs ==             (Array[256, stack_elem])$New[];
					   (* Memory locations *)

    stack_ptr == 	Short$New[];	(* pointer to a stack element	*)
    trunc_sp == 	func[sp: val Short; impure]
    			  { if sp >= MainHgt then MainHgt - 1 else sp fi };
    i == 		Short$New[];

    entering == 	Boolean$New[];  (* Currently entering a number	*)
    seen_period == 	Boolean$New[];  (* Saw dec point in current number *)
    esc_seq ==		Boolean$New[];	(* saw a keypad prefix		*)
    saw_e == 		Boolean$New[];  (* Interpret a + or - as part of *)
    					(* the number being entered.	 *)

    upper_case ==	func[c: val ChStr] val ChStr {
			    if (ChStr$Out[c] >= ChStr$Out['a']) cand
			       (ChStr$Out[c] <= ChStr$Out['z']) ==>
				ChStr$In[ChStr$Out[c]-Short$32];
			    # else ==> c
			    fi
			};
    lower_case ==	func[c: val ChStr] val ChStr {
			    if (ChStr$Out[c] >= ChStr$Out['A']) cand
			       (ChStr$Out[c] <= ChStr$Out['Z']) ==>
				ChStr$In[ChStr$Out[c]+Short$32];
			    # else ==> c
			    fi
			};
    huge == Long$10000000;  (* A value greater than any reasonable *)
			    (* precision request.                  *)
#   define esc_seq_match(c,m)	(esc_seq cand upper_case(c) = m)
#   define normal_match(c,m)    ((not esc_seq) cand upper_case(c) = m)

    entry ==		ChStr$New[];	(* current incomplete entry	    *)
    prec ==             Long$New[];     (* current operating precision      *)

    reprint_input == func [impure] val Void {
    			wput[main_win, entry];
		     };

    c == 		ChStr$New[];	(* Current input character	*)

   (*
    * Return the i the entry in the display cache, updating it if necessary
    * Assumes that mode is either HEX or DEC
    *)
    get_cache == func[i: val Short; impure] val ChStr {
		    let
			ce == cache.i (*ce = the variable, not the value *);
		    in
			if mode <> ce_base[ce]
			   cor ce_prec[ce] = ce_empty_flag
			   cor ce_prec[ce] < prec then
			    if mode = modes$HEX then
				ce := cache_entry$Mk[mode, prec,
						     hex_puts[stack.i, prec]];
			    else
				ce := cache_entry$Mk[mode, prec,
						     puts[stack.i, prec]];
			    fi
			fi;
			ce_string[ce]
		    ni
		 };

    ln10 == ln[stack_elem$In[Long$10]];

   (*
    * Display n in scientific notation
    *)
    putfloat ==
	func[n: val stack_elem; impure] {
	    use stack_elem, Long in let
		(* Precisions used in comparisons *)
		abs_prec == -1000;
		rel_prec == -200;
		small_prec == -20;
		exp_field_wid == 10;
		abs_n == abs[n];
		exponent == xLong$New[];
		printed_val == stack_elem$New[];
		scale_factor == stack_elem$New[];
		'0.1' == 0.1;
		'1' == xLong$1;
	    in
		if compare[n, 0.0, rel_prec, abs_prec] = Short$0 then
		    wput[main_win, " 0.0"];
		else
		    exponent := xLong$from_Long[to_Long[ln[abs_n]/ln10,
							small_prec]];
		    scale_factor := In[to_Long[xLong$10**abs[exponent]]];
		    if abs[exponent] > xLong$500 then
			scale_factor := force_cr_rep[scale_factor];
			(* Constructive real arithmetic is probably faster *)
			(* than rational arithmetic.                       *)
		    fi;
		    if exponent >= xLong$0 then
			printed_val := n / scale_factor;
		    else
			printed_val := n * scale_factor;
		    fi;
		    (* Compensate for truncation toward 0 in to_Long *)
		      if compare[abs[printed_val], 1.0,
				 small_prec, small_prec] < Short$0 then
			printed_val := printed_val * stack_elem$In[10];
			exponent -= xLong$1;
		      fi;
		    (* mantissa: *)
		      wput[main_win, puts[printed_val,
					  In[MainWid] - exp_field_wid - 3]];
		    (* exponent *)
		      wput[main_win, " E"];
		      wput[main_win, puts[exponent]];
		fi
	    ni ni
	};

   (*
    * (re-)display the stack
    *)
    display ==
	func[impure] {
	    use modes in let
		i == Short$New[]
	    in
		wmove[main_win,0,0];
		werase[main_win];
		i := 0;
		do i <= stack_ptr cand i < MainHgt-1 ==>
		    wmove[main_win,i,0];
		    working_flag[];
		    if mode = FLOAT then
			putfloat[stack.i];
		    else
			putnum[get_cache[i]];
		    fi;
		    done_working[];
		    i += 1;
		od;
		wmove[main_win,trunc_sp[stack_ptr+1],0]
	    ni ni
	};

   (*
    * (re-)display the top element on the stack.  Currently does not take
    * into account numbers wrapping around (i.e. one stack elt = one line)
    *)
    display_top ==
	func[impure] {
	    if stack_ptr >= Short$0 cand stack_ptr < MainHgt-1 then
		erase_top[];
		working_flag[];
		if mode = modes$FLOAT then
		    putfloat[stack.stack_ptr];
		else
		    putnum[get_cache[stack_ptr]];
		fi;
		done_working[];
		wmove[main_win,trunc_sp[stack_ptr+1],0]
	    fi;
	};

   (*
    * erase the top entry on the stack, and clear the associated cache
    *)
    erase_top ==
	func[impure] {
	    if (stack_ptr >= Short$0 cand stack_ptr < MainHgt) ==>
		cache.stack_ptr := cache_entry$empty[];
		wmove[main_win, trunc_sp[stack_ptr], 0];
		wclrtoeol[main_win];
		wrefresh[main_win];
	    # else ==> skip
	    fi
	};

   (*
    * Build a constructive real from hex representation
    *)
    hex_point == func[whole, fraction, length: val Long; impure] val stack_elem {
		    let
			(* Convert everything from Long to xLong. Gross... *)
			Xwhole == xLong$from_Long[whole];
			Xlength == xLong$from_Long[length];
			Xfraction == xLong$from_Long[fraction];
                    in
                      if
			Xfraction = xLong$0 ==>
			   stack_elem$In[whole]
		      # else ==>
			   let
			      multiplier == xLong$16**Xlength;
			      Xint_val == Xwhole * multiplier + Xfraction;
			   in
			      stack_elem$In[to_Long[Xint_val]]
			      / stack_elem$In[to_Long[multiplier]]
			   ni
                      fi;
		    ni
                 };
                 
   (*
    * Convert a character string to a stack_elem value.
    *)
    convert_entry ==
    	func [impure] val stack_elem {
    	    let
    	        int_part == New[Long$0];
    	        fract_part == New[Long$0];
    	        exp_part == New[Long$0];
    	        exp_negative == New[False];
    	        scale == New[0];	(* No. of digits right of dec. pt. *)
    	        i == New[0];
    	        current == Short$New[];
    	        zero == ChStr$Out["0"];
    	        nine == ChStr$Out["9"];
    	        letter_a == ChStr$Out["a"];
    	        letter_f == ChStr$Out["f"];
    	        letter_A == ChStr$Out["A"];
    	        letter_F == ChStr$Out["F"];
    	        period == ChStr$Out["."];
    	        is_digit == func[c: val Short; impure] {
    	            	       (c >= zero cand c <= nine)
    	            	       cor (mode = modes$HEX
    	            	            cand (c >= letter_a cand c <= letter_f)
    	            	                 cor (c >= letter_A cand c <= letter_F))
    	            	   };
    	        digit_val == func[c: val Short] {
    	        	       Long$In[
    	        		if c >= zero cand c <= nine then
    	        		    c - zero
    	        		elsif c >= letter_a cand c <= letter_f then
    	        		    c - letter_a + 10
    	        		else
    	        		    c - letter_A + 10
    	        		fi
    	        	       ]
    	        	     };
    	        base == use Long,modes in if mode = HEX then 16 else 10 fi ni;
    	    in
    	        do (current := entry.i; is_digit[current]) ==>
    	            int_part := int_part * base;
    	            int_part := int_part + digit_val[current];
    	            i += 1;
    	        od;
    	        if current = period then
    	            i += 1;
    	            do (current := entry.i; is_digit[current]) ==>
    	                fract_part := fract_part * base;
    	                fract_part := fract_part + digit_val[current];
    	                scale += 1;
    	                i += 1;
    	            od;
    	        fi;
    	        if upper_case[ChStr$In[current]] = "E" then
    	            i += 1;
    	            current := entry.i;
    	            if current = ChStr$Out["+"] then
    	                i += 1;
    	            elsif current = ChStr$Out["-"] then
    	                i += 1;
    	                exp_negative := True;
    	            fi;
    	            do (current := entry.i; is_digit[current]) ==>
    	                exp_part := exp_part * base;
    	                exp_part := exp_part + digit_val[current];
    	                i += 1;
    	            od;
    	            if exp_negative then exp_part := - exp_part fi;
    	        fi;
    	        use stack_elem, Long in
    	          if current <> Short$0 then
    	            werror[" syntax err. "]; stack_elem$In[0]
    	          else
    	            if mode = modes$HEX then
			hex_point[int_part,fract_part,Long$In[scale]]
		    else
		        if exp_part = 0 then
		            In[1]
		        else
		            power[In[base],In[exp_part]]
		        fi
		        * stack_elem$.[int_part,
				       fract_part,Long$In[scale]]
		    fi
		  fi
		ni
    	    ni
    	};

   (*
    * put current entry on the stack
    *)
    fix_entry ==
	func [impure] val Void {
	    if entering then
		if stack_ptr = stack_lim-1 then
		    wput[main_win,"\n"];
		    werror[" stack too deep"];
		    wrefresh[main_win];
		    stack_ptr -= 1;
		fi;
		add_hist[entry];
		let
		    new_val == convert_entry[];
		in
		    push[stack,stack_ptr,new_val];
		ni;
		entry := ""; saw_e := False;
		entering := False;  seen_period := False;
	    fi
	};

   (*
    * execute a binary operation
    * assume one stack entry = one line
    *)
    binop ==
	func [f: func[x,y: val stack_elem] val stack_elem; impure]
		val Void {
	    fix_entry[];	(* put current number (if any) on stack *)
	    if stack_ptr <= 0 ==>
		werror[" too few args"];
	    # else ==>
		let
		    x == sub[stack,(stack_ptr-1)];
		    y == sub[stack,stack_ptr];
		in
		    erase_top[]; pop[stack, stack_ptr];
		    erase_top[]; pop[stack, stack_ptr];
		    (* We do the push piecemeal, so that stack_ptr     *)
		    (* has a predictable value if we diverge and abort *)
		    stack_ptr += 1;
		    working_flag[];
		    stack.stack_ptr :=  f[x, y];
		ni;
		display_top[];
	    fi
	};

    (* An impure version *)
    binop ==
	func [f: func[x,y: val stack_elem; impure] val stack_elem; impure]
		val Void {
	    fix_entry[];	(* put current number (if any) on stack *)
	    if stack_ptr <= 0 ==>
		werror[" too few args"];
	    # else ==>
		let
		    x == sub[stack,(stack_ptr-1)];
		    y == sub[stack,stack_ptr];
		in
		    erase_top[]; pop[stack, stack_ptr];
		    erase_top[]; pop[stack, stack_ptr];
		    stack_ptr += 1;
		    working_flag[];
		    stack.stack_ptr :=  f[x, y];
		ni;
		display_top[];
	    fi
	};

   (*
    * execute a unary operation
    *)
    unop ==
	func [f: func[y: val stack_elem; impure] val stack_elem; impure]
		val Void {
	    fix_entry[];
	    if stack_ptr < 0 ==>
		werror[" need an arg!"];
	    # else ==>
		let
		    y == sub[stack,stack_ptr];
		in
		    erase_top[]; pop[stack, stack_ptr];
		    stack_ptr += 1;
		    working_flag[];
		    stack.stack_ptr :=  f[y];
		ni;
		display_top[];
	    fi
	};

    (* Again, for pure operations *)
    unop ==
	func [f: func[y: val stack_elem] val stack_elem; impure]
		val Void {
	    fix_entry[];
	    if stack_ptr < 0 ==>
		werror[" need an arg!"];
	    # else ==>
		let
		    y == sub[stack,stack_ptr];
		in
		    erase_top[]; pop[stack, stack_ptr];
		    stack_ptr += 1;
		    working_flag[];
		    stack.stack_ptr :=  f[y];
		ni;
		display_top[];
	    fi
	};

   (*
    * Check whether an argument is definitely negative.
    * May fail in the direction of identifying a number as nonnegative.
    * Has the side effect of displaying the "working" sign,
    * WHICH MUST BE CLEARED by caller.  Normally this happens
    * implicitly as the result of a redisplay operation.
    *)
     is_neg == func[x:val stack_elem; impure] val Boolean {
		    working_flag[];
		    use Long in let
			pos_prec == if prec < 0 then 0 else prec fi;
		    in
			if is_rat[x] then
			    compare[x, stack_elem$In[0],-huge,-huge] < Short$0
			else
			    compare[x, stack_elem$In[0],
				    -huge,
				    -pos_prec*4-100 (* abs prec in bits *)]
			    < Short$0
			fi
		    ni ni
	       };

   (*
    * Check whether the two argument are definitely not equal.
    * Has the side effect of displaying the "working" sign,
    * WHICH MUST BE CLEARED by caller.  Normally this happens
    * implicitly as the result of a redisplay operation.
    *)
     are_unequal ==
		  func[x,y: val stack_elem; impure] val Boolean {
		    working_flag[];
		    use Long in let
			pos_prec == if prec < 0 then 0 else prec fi;
		    in
			if is_rat[x] then
			    compare[x, y, -huge, -huge] <> Short$0
			else
			    compare[x, y,
				    -huge,
				    -pos_prec*4-100 (* abs prec in bits *)]
			    <> Short$0
			fi
		    ni ni
		  };

   (*
    * Check whether an argument is definitely zero.
    * May fail in the direction of identifying a number as nonzero.
    *)
     is_zero == func[x:val stack_elem; impure] val Boolean {
		    use Long in
			if is_rat[x] then
			    compare[x, stack_elem$In[0],-huge,-huge] = Short$0
			else
			    False  (* Can't possibly tell *)
			fi
		    ni
	       };

in
   (* initialization *)
    Expand_Hp[64];
    stack_ptr := -1;                    (* empty stack          *)

    (* Start up display *)
      reset_size[get_columns[], get_lines[]];
      initscr[];
      nonl[]; cbreak[]; noecho[];
      make_windows[];

    esc_seq := entering := seen_period := False;
    entry := ""; saw_e := False;
    
    c := " ";
    prec := Long$In[get_prec[]];	(* precision depends on window	   *)

    let

	add_digit ==
	    func[dig: val ChStr; impure] val Void {
	        entry := entry ^* dig;
	        saw_e := mode <> modes$HEX cand (dig = 'e' cor dig = 'E');
	    };
	    

	(* remove a digit from number being entered *)
	rem_digit ==
	    func[impure] val Void {
	        let
	            length == len[entry];
	        in if length <> 0 then
		    erase_one[];		(* erase digit *)
		    if entry.(length-1) = ChStr$Out["."] then
		        seen_period := False;
		    fi;
		    if length > 1 then
		        saw_e := upper_case[ChStr$In[entry.(length-2)]] = "E"
		    else
		    	saw_e := False
		    fi;
		    entry := substr[entry, 0, length-1];
		fi ni
	    };
    in
       Xwindows := func[impure] val Boolean { extern "_is_x_win" } [];
       (* initialize windows *)
	working := False;

	mode := modes$DEC;    /* default is decimal mode */
	print_help[];
	box[bord_win,ChStr$Out["|"],ChStr$Out["-"]];
	if Help_avail then
	    box[info_win,ChStr$Out["|"],ChStr$Out["-"]];
	fi;
	wrefresh[bord_win];
	update_info[];
	wmove[main_win,0,0];
	wrefresh[main_win];

       (*
	* Initialize register array
	*)
	let
	    i == New[0]
	in
	    do i < 256 ==>
		regs.i := stack_elem$In[Long$0];
		i += 1;
	    od
	ni;

	if Signal[SIGWINCH] then
	    c := cond_redraw;
	fi;

       (*
	* loop on input character until a ^D is entered
	*)
	do not (is_eof_char(c) cor c = ChStr$In[-1] /* X windows */) ==>
	 let
	  stopped == Signal[SIGINT];
	 in
	  if stopped ==>	(* check for interrupt *)
	    if not(working) ==>
		werror[" what?       "];
	    # else ==>
		werror[" aborted     "];
		if normal_match(c,"<") cor normal_match(c,">") ==>
		    if main_pos > old_pos ==>
			main_pos := old_pos
		    # else ==>
			main_pos -= MainWid-1
		    fi;
		    entry := ""; saw_e := False;
		    entering := False;  seen_period := False;
		    prec := Long$In[get_prec[]];
		    update_info[];
		    display[];
		# else ==>
		    if not(entering) ==>
			erase_top[]; pop[stack, stack_ptr];
			done_working[];
		    # else ==>
			fix_entry[];
			done_working[]
		    fi
		fi
	    fi
	  # else ==>	    
	    if

	  (* digit from typewriter keys *)
	    (not esc_seq) cand
		((c >= "0" cand c <= "9") cor
		 (c >= "A" cand c <= "F") cor
		 (c >= "a" cand c <= "f")) ==>
		entering := True;
		c := lower_case[c];
		wput[main_win,c];
		wrefresh[main_win];
		add_digit[c];

	    # not esc_seq cand c = "m" ==>
		mode := if mode = modes$Last then
			    modes$First
			else
			    Succ[mode]
			fi;
		update_info[];
		display[];
		add_hist["m"];

	    # not esc_seq cand c = "M" ==>
	    	mode := if mode = modes$First then
			    modes$Last
			else
			    Pred[mode]
			fi;
		update_info[];
		display[];
		add_hist["M"];

	    # normal_match(c,"?") ==>
		print_more_help[];

	    # normal_match(c,"$") ==>
		main_pos := StartPos;
		prec := Long$In[get_prec[]];
		update_info[];
		display[];

	    # normal_match(c,"<") ==>
		let amt == Long$Out[to_Long[convert_entry[], -Long$2]]
		in
		    old_pos := main_pos;
		    sidestep[amt,LEFT];
		    prec := Long$In[get_prec[]];
		    entry := ""; saw_e := False;
		    entering := seen_period := False;
		    display[];
		ni;

	    # normal_match(c,">") ==>
		let amt == Long$Out[to_Long[convert_entry[], -Long$2]]
		in
		    old_pos := main_pos;
		    sidestep[amt,RIGHT];
		    prec := Long$In[get_prec[]];
		    entry := ""; saw_e := False;;
		    entering := seen_period := False;
		    display[];
		ni;

# ifdef KEYPAD
	  (* keypad key start flag *)
	    # c = esc_ch ==>
		esc_seq := True;
# endif

	  (* keypad digit *)
	    # esc_seq cand c >= KEYPAD0 cand c <= KEYPAD9 ==>
		entering := True;
		let
		    dig == Long$In[ChStr$Out[c] - ChStr$Out[KEYPAD0]];
		    char == puts[dig];
		in
		    wput[main_win,char];
		    wrefresh[main_win];
		    add_digit[char];
		ni;
		esc_seq := False;
	  (* decimal point *)
	    # esc_seq_match(c,KEYPADDOT) cor normal_match(c,".") ==>
	        esc_seq := False;
		if (not seen_period) ==>
		    entering := True;
		    wput [main_win,"."];
		    add_digit["."];
		    wrefresh[main_win];
		    seen_period := True;
		# else ==> 
		    skip
		fi;

	  (* backspace - delete top entry from stack *)
	    # c = backsp cor c = del_ch  cor normal_match(c,"\\") ==>
		if entering cand entry <> "" ==>
		    rem_digit[];
		# else ==>
		    entering := False; saw_e := False;
		    if (stack_ptr >= 0) ==> erase_top[];
					    stack_ptr -= 1;
		    # else ==>		    skip
		    fi;
		    add_hist["\\"];
		fi;
		esc_seq := False;

	   (* add top two entries *)
	    # esc_seq_match(c,KEYPADPF1) cor normal_match(c,"+") ==>
	        esc_seq := False;
	        if saw_e then
	            (* Start of an exponent *)
	            wput[main_win,"+"];
		    wrefresh[main_win];
		    add_digit["+"];
	        else
		    binop[stack_elem$+];
		    add_hist["+"];
		fi;

	   (* subtract top two entries *)
	    # esc_seq_match(c,KEYPADPF2) cor normal_match(c,"-") ==>
	        esc_seq := False;
	        if saw_e then
	            (* Start of an exponent *)
	            wput[main_win,"-"];
		    wrefresh[main_win];
		    add_digit["-"];
	        else
		    binop[stack_elem$-
			  <<func[x,y: val stack_elem] val stack_elem>>];
		    add_hist["-"];
		fi;

	   (* multiply top two entries *)
	    # esc_seq_match(c,KEYPADPF3) cor normal_match(c,"*") ==>
	        add_hist["*"];
		binop[stack_elem$*];
		esc_seq := False;

	   (* interchange top values *)
	    # normal_match(c,"I") ==>
		fix_entry[];
		if stack_ptr >= 1 then
		    let
			top == V[stack.stack_ptr];
			second == V[stack.(stack_ptr-1)];
		    in
			erase_top[];
			pop[stack, stack_ptr];
			erase_top[];
			pop[stack, stack_ptr];
			push[stack, stack_ptr, top];
			display_top[];
			push[stack, stack_ptr, second];
			display_top[];
		    ni
		fi;   
		add_hist["I"];

	   (* Save a value in a register *)
	    # normal_match(c, "=") ==>
		fix_entry[];
		display_top[];
		add_hist["="];
		let
		    rid == wgetc[main_win]
		in 
		    add_hist[ChStr$In[rid]];
		    regs.(rid) := sub[stack,stack_ptr];
		ni;

	   (* Get a value from a register *)
	    # normal_match(c, "G") ==>
		fix_entry[];
		display_top[];
		add_hist["G"];
		let
		    rid == wgetc[main_win]
		in 
		    add_hist[ChStr$In[rid]];
		    push[stack, stack_ptr, regs.(rid)];
		ni;
		display_top[];

	   (* divide top entry into second from top *)
	    # esc_seq_match(c,KEYPADPF4) cor normal_match(c,"/") ==>
		fix_entry[];
		use Long in let
		    arg2 == sub[stack,stack_ptr];
		in
		    if is_zero[arg2] then
			display_top[];
			werror["0 divisor"];
		    else
			binop[stack_elem$/];
		    fi
		ni ni;
		add_hist["/"];

	   (* change sign *)
	    # esc_seq_match(c,KEYPADDASH) cor normal_match(c,"~") ==>
		unop[stack_elem$-
			<<func[val stack_elem] val stack_elem>>];
		esc_seq := False;
		add_hist["~"];

	   (* power *)
	    # normal_match(c,"^") ==>
		fix_entry[];
		let
		    arg1 == sub[stack,stack_ptr - 1];
		in
		    if is_neg[arg1] then
			display_top[];
			werror["negative base"];
		    elsif is_zero[arg1] then
			display_top[];
			werror["zero base"];
		    else
			binop[power];
		    fi
		ni;
		add_hist["^"];

	   (* square root *)
	    # esc_seq_match(c,KEYPADCOM) cor normal_match(c,"R") ==>
		fix_entry[];
		let
		    arg == sub[stack,stack_ptr];
		in
		    if is_neg[arg] then
			display_top[];
			werror["sqrt(negative)"];
		    else
			unop[stack_elem$sqrt];
		    fi
		ni;
		add_hist["R"];

	   (* pi *)
	    # normal_match(c,"P") ==>
		fix_entry[];
		display_top[];
		push[stack, stack_ptr, stack_elem$pi[]];
		display_top[];
		add_hist["P"];

	   (* sin *)
	    # normal_match(c,"S") ==>
		unop[stack_elem$sin];
		add_hist["S"];

	   (* cosine *)
	    # normal_match(c,"K") ==>
		unop[stack_elem$cos];
		add_hist["K"];

	   (* arctangent *)
	    # normal_match(c,"T") ==>
		unop[stack_elem$atan];
		add_hist["T"];

	   (* enter number onto stack *)
	    # (esc_seq cand c = KEYPADENT)
	      cor c = " "
	      cor ((c = "\n" cor c = "\r") cand not Xwindows) ==>
		let
		    y == gety[main_win];
		in
		    wmove[main_win,y,0];
		    wclrtobot[main_win];
		    fix_entry[];
		    display_top[];
		ni;
		add_hist[" "];

	   (* quit program *)
	    # c = eof_ch ==>
		wmove[hist_win,0,0];
		wput[hist_win,"\n"];
		wrefresh[hist_win];
		endwin[];
		exit[0];

	   (* redraw the screen *)
	    # c = redraw cor c = cond_redraw ==>
	      (* Suspend SIGWINCH in the middle of this.  This appears *)
	      (* to be essential under under SunOS 4.0, since SIGWINCH *)
	      (* appears to be stuttered in an rlogin session.         *)
		func [impure] val Void { extern "_block_sigwinch" } [];
	      let
		nlines == get_lines[];
		ncols == get_columns[];
		size_changed == nlines <> ScrnHgt cor ncols <> ScrnWid
				cor forced_resize[];
	      in
		if size_changed then
		  reset_size[ncols, nlines];
		  nl[]; nocbreak[]; echo[]; endwin[];
		  initscr[];
		  nonl[]; cbreak[]; noecho[];
		  make_windows[];
		fi;
		if c = redraw cor size_changed then
		  clear[];
		  wclear[hist_win];
		  wclear[bord_win];
		  if Help_avail then
		    wclear[info_win];
		  fi;
		  wclear[main_win];
		  refresh[];
		  box[bord_win,ChStr$Out[" "],ChStr$Out[" "]];
		  box[bord_win,ChStr$Out["|"],ChStr$Out["-"]];
		  if Help_avail then
		    box[info_win,ChStr$Out[" "],ChStr$Out[" "]];
		    box[info_win,ChStr$Out["|"],ChStr$Out["-"]];
		  fi;
		  print_help[];
		  update_info[];
		  if Help_avail then
		    wrefresh[info_win];
		  fi;
		  wrefresh[bord_win];
		  prec := Long$In[get_prec[]];
    		  add_hist[""];
		fi;
		func [impure] val Void { extern "_unblock_sigwinch" } [];
		(* Redisplay in any case, since a SIGWINCH interrupts *)
		(* computation.                                       *)
		display[];
		reprint_input[];
		wrefresh[hist_win];
		wrefresh[main_win];
	      ni;

	   (* duplicate top entry on stack *)
	    # normal_match(c,"Q") ==>
	        add_hist["Q"];
		fix_entry[];
		display_top[];
		let
		    top == sub[stack,stack_ptr]
		in
		    if (stack_ptr < stack_lim-1) ==>
			push[stack, stack_ptr, top];
			display_top[];
		    # else ==>
			wput[main_win,"\n"];
			werror[" stack too deep"];
			wrefresh[main_win];
		    fi
		ni;

	   (* exponential function *)
	    # normal_match(c,"X") ==>
		unop[stack_elem$exp];
		add_hist["X"];

	   (* natural logarithm *)
	    # normal_match(c,"L") ==>
		fix_entry[];
		let
		    arg == sub[stack,stack_ptr];
		in
		    if is_neg[arg] then
			display_top[];
			werror["log(negative)"];
		    elsif is_zero[arg] then
			display_top[];
			werror["log(0)"];
		    else
			unop[stack_elem$ln];
		    fi
		ni;
		add_hist["L"];

	    (* Truncate to integer *)
	    # normal_match(c,"Z") ==>
		let
		    abs_prec == -Long$1000;
		in
		    fix_entry[];
		    working_flag[];  (* Normally used only during *)
				     (* redisplay.  But here      *)
				     (* function evaluation       *)
				     (* takes time.               *)
		    unop[func[x: val stack_elem; impure]
			 { stack_elem$In[to_Long[x, abs_prec]] }
		    ];
		ni;
		add_hist["Z"];

	    # c = "!" ==>
		fix_entry[];
		let
		    arg == to_Long[sub[stack,stack_ptr], -Long$20];
		in
		    if stack_ptr < 0 cor
		       arg < Long$0 cor
		       are_unequal[stack_elem$In[arg],
				   sub[stack, stack_ptr]] then
		      display_top[];
		      werror("not pos int");
		    else
		      erase_top[]; pop[stack, stack_ptr];
		      stack_ptr += 1;
		      stack.stack_ptr :=
			    stack_elem$In[to_Long[(xLong$In[arg])!]];
		      display_top[];
		    fi
		ni;
		add_hist["!"];

	    # c = "#" ==>
		fix_entry[];
		add_hist["#"];
		let
		    arg == to_Long[sub[stack,stack_ptr], -Long$20];
		    sqrt_arg == to_Long[sqrt[abs[sub[stack,stack_ptr]]],
					-Long$20];
		    abs == func[x: val Long]
				{ if x < Long$0 then -x else x fi };
		    abs_arg == abs[arg];
		    answer == New[True];
		    factor == New[0];
		    i == New[2];
		    limit == if abs_arg > Long$100 then
				100
			     else
				Out[abs_arg] - 1
			     fi;
		in
		    if stack_ptr < 0 cor
		       are_unequal[stack_elem$In[arg],
				   sub[stack, stack_ptr]] then
		      display_top[];
		      werror("not integer");
		    elsif sqrt_arg*sqrt_arg = abs_arg then
		      display_top[];
		      print_msg "square";
		    else
		      (* working flag is still set from are_unequal call *)
		      do i < limit cand answer ==>
			if abs_arg % i = 0 then
			    factor := i;
			    answer := False;
			fi;
			i += 1;
		      od;
		      if answer then
			  answer := pt[abs_arg]
		      fi;
		      display_top[];
		      if answer then
			if abs_arg < Long$In[limit*limit]
			   cor abs_arg = Long$2 then
			    print_msg "prime      ";
			else
			    print_msg "prob. prime";
			fi
		      else
			if factor <> 0 then
			    print_msg ["factor: " ^* puts[factor]];
			else
			    print_msg "composite";
			fi
		      fi
		    fi
		ni;

	   (* ignore all other input *) 
	    # else  ==>
		skip;
	    fi
	  fi;
	  c := ChStr$In[wgetc[main_win]];
	 ni
	od;
    wmove[hist_win,0,0];
    wput[hist_win,"\n"];
    wrefresh[hist_win];
    endwin[];
    exit[0];
ni ni ni ni

let
  Strange == extend { Short } with S { a == S$+ };
  f == func[T:type t {a: func[x,y: val t]val t; '1'; '2'; ^+}] val T
        {use T in a[21,2] ni}
in
  put["This should print 13, 17, and 23\n"];
  put[Strange$13]; put['\n'];
  put[Out[Strange$17]]; put['\n'];
  put[f[Strange]]; put['\n'];
ni

let
    GaussianInteger ==
                record { Real,Imaginary: Short }
                with GI{
                    i ==  func[] val GI {
                              GI$Mk[0,1]
                          };
                    toGI == func[x: val Short] val GI {
                                GI$Mk[x,0]
                            };
                    + == func[x,y: val GI] {
                            GI$Mk[
                                Real[x] + Real[y],
                                Imaginary[x] + Imaginary[y]
                            ]
                         };
                    - == func[x,y: val GI] {
                            GI$Mk[
                                Real[x] - Real[y],
                                Imaginary[x] - Imaginary[y]
                            ]
                         };
                    * == func[x,y: val GI] {
                            GI$Mk[
                              Real[x] * Real[y] - Imaginary[x] * Imaginary[y],
                              Real[x] * Imaginary[y] + Imaginary[x] * Real[y]
                            ]
                        };
                    put == func[x: val GI] val Void {
                                   put[Real[x]];
                                   put["+"];
                                   put[Imaginary[x]];
                                   put["i"];
                               }
                }
                hide {Mk}
in use GaussianInteger in
    put[ toGI[5] + toGI[2] * i]; put ["\n"]
ni ni

let
    to_ChStr == func[x: val Short] {ChStr$In[x + Out["0"]]};
    base == Short$10;
    print1 == func[x: val Long] val Void {
                  use Long in
                    if 
                      x > 0 ==> print1[x/base]; put[to_ChStr[x%base]]
                    # x = 0 ==> Null
                    # x < 0 ==> put["-"]; print1[x]
                    fi
                  ni
              };
    print == func[x: val Long] val Void {
                use Long in
                  if
                    x = 0 ==> put["0"];
                  # else  ==> print1[x];
                  fi
                ni
             };
    ** == func[x,y: val Long] {
            use Long in
                if
                    y = 0 ==> 1
                #   else  ==> x**(y-1) * x
                fi
            ni
          }
in
    use Long in
        print[12345];
        put["\n"];
        print[2**32];
        put["\n"];
    ni
ni

let
    ! == func [ n : val Short ]
                {  
                    if 
                        n > 0 ==> Long$In[n] * ((n - 1)!)
                    #   n = 0 ==> Long$1
                    fi
                 };
    x == Short$New[];
in
    do
        (put["Factorial of?"]; x := get[FS]) >= 0  ==>  put[x!]; put["\n"]
    od
ni

(* Primitive implementation of interval arithmetic.  A number is *)
(* represented by a floating point value and a tolerance.        *)
(* This assumes that floating point underflow exceptions are     *)
(* disabled.  Fortunately this normally seems to be the case     *)
(* under UNIX.                                                   *)
(* Some functions catch floating point exceptions.  This         *)
(* effectively prevents the client from also doing so.           *)

# define skip Null[]

func [] {
    let
	(* First a lot of gross stuff to get around primitive floating *)
	(* point constants:                                            *)
	zero == 0.0;
	one == 1.0;

	(* Dumb integer exponentiation *)
	** == func[x: val Float; y: val Short] val Float {
		let
		    i == Short$New[];  (* result = x ** i *)
		    result == Float$New[];
		in
		    i := 0; result := 1.0;
		    do
			i < y ==> i += 1; result := result * x
		    #   i > y ==> i -= 1; result := result / x
		    od;
		    result
		ni
	      };
	max_exp == 127;   (* Maximum exponent of a floating point number *)
	inf_toler == 10.0 ** 36;
			(* This tolerance value indicates the result is   *)
			(* completely bogus. Also upper bound on meaning- *)
			(* ful tolerance.                                 *)
	smallest == 10.0 ** (-36);
			(* Upper bound on smallest representable and *)
			(* invertable number                         *)
	max_exp_arg == 82.0;
			(* Largest valid argument to floating point *)
			(* exponential function                     *)
	m_err == 10.0 ** (-15);
		    (* Maximum floating point representation error for x *)
		    (* is x * m_err                                      *)
	(* Compute the representation error, i.e. the maximum error due  *)
	(* to granularity of representation for the floating point value *)
	rep_error == func[x: val Float] val Float {
			max[m_err * abs[x], smallest]
		     };
	abs == func [x: val Float] { if x < 0.0 ==> -x # else ==> x fi };
	abs == func [x: val Short] { if x < 0 ==> -x # else ==> x fi };
	max == func [x, y: val Float] { if x < y ==> y # else ==> x fi };
    in
	prod { appr, tol: val Float }
	with I {
	    (* Meaningless value *)
	    junk == func[] val I { I$Mk[zero, inf_toler] };

	    is_junk == func[x: val I] { tol[x] >= inf_toler };

	    + == func[x,y: val I] val I {
		    if
			exponent[appr[x]] > max_exp
			cor exponent[appr[y]] > max_exp
			cor tol[x] + tol[y] >= inf_toler ==>
			    I$junk
		    #   else ==>
			    let
				new_appr == appr[x] + appr[y]
			    in
				I$Mk[ new_appr,
				      tol[x] + tol[y] + rep_error[new_appr]
				]
			    ni
		    fi
		 };

	    * == func[x,y: val I] val I {
		    if
		      tol[x] + tol[y] >= inf_toler
		      cor exponent[appr[x]] + exponent[tol[y]] >= max_exp
		      cor exponent[appr[y]] + exponent[tol[x]] >= max_exp
		      cor exponent[appr[x]] + exponent[appr[y]] >= max_exp ==>
			(* New tolerance or result might generate overflow *)
			    I$junk
		    # else ==>
			let
                            new_tol == (abs[appr[x]] + abs[tol[x]]) * tol[y]
                                       + (abs[appr[y]] + abs[tol[y]]) * tol[x];
			    new_appr == appr[x] * appr[y]
			in
			    I$Mk[new_appr,
				 new_tol + rep_error[new_appr]
			    ]
			ni
		    fi
		 };

	    (* Convert a monotone function on floating point numbers *)
	    (* to the corresponding function on intervals            *)
	    (* Assumes f is a total function floating point numbers  *)
	    from_monotone ==
		func [f: func[val Float] val Float] {
		    func [x: val I] val I {
			if tol[x] >= inf_toler ==>
			    I$junk
			# else ==>
			    let
				high_appr == f[appr[x] + tol[x]];
				mid_appr == f[appr[x]];
				low_appr == f[appr[x] - tol[x]];
				new_tol == abs[high_appr - low_appr]
					   + rep_error[mid_appr];
			    in
				I$Mk[
				     mid_appr,
				     if new_tol > inf_toler ==>
					inf_toler
				     #  else ==>
					new_tol
				     fi
				]
			    ni
			fi
		    }
		};

	    (* Convert a monotone function on the nonnegative floating   *)
	    (* point numbers to the corresponding function on intervals  *)
	    from_monotone_pos ==
		func [f: func[val Float] val Float] {
		    I$from_monotone [func [x: val Float] val Float {
					f[if x < zero ==> zero # else ==> x fi]
				   }
		    ]
		};

	    (* Additive inverse *)
	    - == func[x: val I] {
		    I$Mk[-appr[x], tol[x]]
		 };

	    (* Subtraction *)
	    - == func[x,y : val I] {
		    x + (-y)
		 };

	    (* Multiplicative inverse (could be improved) *)
	    inv == func[x: val I] {
			if appr[x] - tol[x] < zero
			   cand appr[x] + tol[x] > zero
			   cor appr[x] <= smallest ==>
			    (* Value could be 0 *)
			    I$junk
			# else ==>
			    I$from_monotone[func[x: val Float] {1.0/x}] [x]
			fi
		    };

	    / == func[x,y: val I] {
		    x * inv[y]
		 };

	    (* Return -1 if definitely x < y, +1 if definitely x > y, *)
	    (* 0 if intervals overlap                                 *)
	    compare == func[x, y: val I] val Short {
			    if
			      tol[x] >= inf_toler cor tol[y] >= inf_toler ==>
				0
			    # else ==>
			      if
				appr[x] + tol[x] < appr[y] - tol[y] ==>
				    -1
			      # appr[x] - tol[x] > appr[y] + tol[y] ==>
				    1
			      # else ==>
				    0
			      fi
			    fi
		       };
    
	    max == func[x,y: val I] {
		     if
			tol[x] >= inf_toler cor tol[y] >= inf_toler ==>
			    I$junk
		     #  else ==>
			    if
			      appr[x] - tol[x] > appr[y] + tol[y] ==>
				x
			    # appr[y] - tol[y] > appr[x] - tol[x] ==>
				y
			    # else ==>
				I$Mk[max[appr[x], appr[y]],
				     max[tol[x], tol[y]]]
			    fi
		     fi
		   };

	    exp == func[x: val I] {
		       if appr[x] + tol[x] > max_exp_arg ==>
			   I$junk
		       # else ==>
			   I$from_monotone[Float$exp][x]
		       fi
		   };

	    shift == func[x: val I; n: val Short] {
			let
			    e1 == exponent[appr[x]];
			    e2 == exponent[tol[x]]
			in
			    if abs[e1 + n] > max_exp
			       cor abs[e2 + n] > max_exp ==>
				I$junk
			    # else ==>
				I$Mk[shift[appr[x],n], shift[tol[x],n]]
			    fi
			ni
		     };

	    ln == func[x: val I] {
		    if appr[x] - tol[x] <= zero ==>
			I$junk
		    # else ==>
			I$from_monotone[Float$ln][x]
		    fi
		  };

	    (* reasonable only over [-1.5 .. 1.5] *)
	    sin == func[x: val I] {
			if max[abs[appr[x]-tol[x]], abs[appr[x]+tol[x]]]
			   > 1.5 then
			    I$Mk[zero,one]
			else
			    I$from_monotone[Float$sin][x]
			fi
		   };

	    (* ditto ... *)
	    cos == func[x: val I] {
			if max[abs[appr[x]-tol[x]], abs[appr[x]+tol[x]]]
			   > 1.5 then
			    I$Mk[zero,one]
			else
			    let
				y == sin[x]
			    in
				sqrt[I$from_Float_const[one] - y * y]
			    ni
			fi
		   };

	    atan == func[x: val I] {
			I$from_monotone[Float$atan][x]
		   };

	    sqrt == func[x: val I] {
			I$from_monotone_pos[Float$sqrt][x]
		    };

	    put == func[x: val I] {
			if tol[x] < inf_toler ==>
			    put[appr[x]];
			    put[" (+- "];
			    put[tol[x]];
			    put[")"];
			# else ==>
			    put["junk"];
			fi;
			x
		   };

	    (* Return true if x is known to be accurate *)
	    (* to 2**n.                                 *)
	    accurate == func[x: val I; n: val Short] {
			    tol[x] < inf_toler cand
			    exponent[tol[x]] <= n
			};

	    (* Convert a floating point constant to an interval *)
	    from_Float_const == func[x: val Float] {
				    I$Mk[x, rep_error[x]]
				}
	}
    ni
}

(* This should be implemented with a sorted list of entries. But I am being
   lazy for now. *)

func [maxval : val Short] {
	(Array [maxval, Boolean])
	with A {

	    NNew == func [] var A {
		let a == A$New [];
		    i == Short$New [0]
		in
		   do i < maxval ==>
			a.i := False;
			i += 1
		   od;
		   a
		ni
		};

	    add == func [x : val Short; a : var A;impure] val Void {
			a.x := True
		};

	(* next returns the entry following x; returns maxval if no more *)
	    next == func [x : val Short; a : var A(*unchanged*)] val Short {
		     let n == Short$New []
		     in
			n := x + 1;
			do (n < maxval) cand (not a.n) ==>
				n += 1
			od;
			n
		     ni
		}
	} with A {New == A$NNew} export { New; add; next}
}

(*
 * Russell Compiler Help Program
 * Original author: Hans-J. Boehm
 * Revised 1/13/87 by Glenn Skinner to look at env variables
 *)
 
# include "root_path.h"

let
    DefaultBaseDirectory        == ROOT_PATH ^* "/src";
    DefaultPager		== "/usr/ucb/more";
    usage_line			== "Usage: rhelp [-k] [construct]\n";

    (*
     * Functions to interface to the host system.
     *)
    open == func[val ChStr; flags, mode: val Short; impure] val Short
                { extern "_open" };
    O_RDONLY == 0;  (* read flag for open *)
    system == func [val ChStr; impure] val Short { extern "_system" };
    execl == func [name, arg0, arg1: val ChStr; val Short; impure] val Short
                  { extern "_execl" };
    exec2 == func [name, arg: val ChStr; FS: impure]
                  { execl[name, name, arg, 0] };
    chdir == func [val ChStr; impure] val Short { extern "_chdir" };
    getenv == func[val ChStr; impure] val ChStr { extern "_getenv" };
    (* We use Short below to accomodate C semantics for boolean values. *)
    inenv == func[val ChStr; impure] val Short { extern "_inenv" };

    to_lower == func [x: val ChStr] val ChStr {
	let
	    first == substr[x,0,1];
	    infinity == 100;
	in
	    if
		len[x] = 0 ==> x
	    #   else ==>
		     if
			Out[first] <= Out['Z'] cand
			Out[first] >= Out['A'] ==>
			   ChStr$In[Out[first] + 32]
		     #   else ==>
			   first
		     fi  ^* to_lower[substr[x,1,infinity]]
	    fi
	ni
    };
    (*
     * Return the value of the environment variable env,
     * or default if env isn't set in the environment.
     *)
    GetenvDefaulted == func[env, default: val ChStr; impure] val ChStr {
	if
	    inenv[env] <> 0 ==> getenv[env]
	#   else ==> default
	fi
    };
    (* N.B.: wired in subdirectory structure. *)
    help_dir == GetenvDefaulted["RUSSELL_BASE", DefaultBaseDirectory]
		^* "/help/";
    MORE == GetenvDefaulted["PAGER", DefaultPager]
in
    if
        argc = 1 ==>
            system[MORE ^* " " ^* help_dir ^* "general"];
            put["Available help files are:\n"];
            exec2["/bin/ls", help_dir]
    #   argc = 2 ==>
            let
                fn == help_dir ^* to_lower[argv[1]]
            in
                if
                    open[fn, O_RDONLY, 0] >= 0  ==>
			system[MORE ^* " " ^* help_dir ^* to_lower[argv[1]]];
                #   else  ==>
                        put["No help available for "];
                        put[argv[1]];
                        put["\nAvailable help files are:\n"];
                        exec2["/bin/ls", help_dir];
                fi
            ni
    #   argc = 3 ==>
            chdir[help_dir];
            if
                argv[1] = "-k"  ==>
                    system["fgrep -i " ^* argv[2] ^* " *"
                           ^* " | " ^* MORE]
            #   argv[2] = "-k"  ==>
                    system["fgrep -i " ^* argv[1] ^* " *"
                           ^* " | " ^* MORE]
            #   else ==>
                    put[usage_line]
            fi
    #   else ==>
            put[usage_line]
    fi
ni

let
  compose ==
    func[f: func[val t2]val t3; g: func[val t1]val t2; t1,t2,t3: type{}]
        {func[x: val t1]val t3 { f[g[x]] }};
  incr == func[x: val Short] { x + 1 };
  nput == compose[Short$put, incr];
in
  nput[3]
ni

# include "defs.h"
# define NOTCONST (-1)

func [max_var : val Short] {
	let predefvars == T2 ^ TL ^ RL ^ SK ^ UN ^ GF ^ SP ^ AR ^ mem_var;

	    (* assists reverse and concat by providing an accumulating reverse *)
	    rev == func [l, accum : val List [Short]] val List [Short] {
			if is_nil l then accum
			else
			    rev [tail l, cons [head l, accum]]
			fi
		};
	
	    (* concatrev reverses the first list and concats onto second list *)
	    concatrev == func [lst1, lst2 : val List [Short]] 
							    val List [Short] {
			rev [lst1, lst2]
		};

	    CArray == Array [max_var, Short];
	    Slist == extern {"slist"} [Short] (* destructive lists with 
								remove op *)
	in
		prod {
			consts : val Ref CArray;
			vs : val Ref Slist;
			killed_vs : val Ref Slist
		    }

	with V {
	    Init == func [] val V {
		let c == CArray$New [];
		    v == Slist$New [];
		    k == Slist$New []
		in
		    (* C0 thro C4 are constant locations always *)
		    c.C0 := 0; c.C1 := 1; c.C2 := 2; c.C3 := 3; c.C4 := 4;

		    v := Slist$'';
		    k := Slist$'';

		    V$Mk [(Ref CArray)$In [c], (Ref Slist)$In [v],
				(Ref Slist)$In [k]]
		ni
	      };

	    reset == func [vvv : val V; impure] val Void {
		(* vs := vs - killed_vs; killed_vs := '' *)
		let cptr == consts [vvv];
		    vptr == vs [vvv];
		    kptr == killed_vs [vvv]
		in
OPEN
put "to reset ks = ";put [kptr^];put "\n";
CLOSE
		    do not is_nil [kptr^] ==>
			remove [head (kptr^), vptr^];
			kptr^ := next (kptr^)
		    od;
OPEN
put "after reset vs = ";put [vptr^];put "\n";
CLOSE
		    (* clear the consts value for all vs and predefvars *)
		    let tempvs == Slist$New []
		    in
			tempvs := vptr^;
			do not is_nil [tempvs] ==>
			    (cptr^).(head tempvs) := NOTCONST;
			    tempvs := next tempvs
			od
		    ni;
		    let tempvs == (List [Short])$New []
		    in
			tempvs := predefvars;
			do not is_nil [tempvs] ==>
			    (cptr^).(head tempvs) := NOTCONST;
			    tempvs := tail tempvs
			od
		    ni;

		ni
	      };
		   
	    gen == func [v : val Short; vvv : val V; impure] val Void {
			add [v, (vs [vvv])^];
			not_constant [v, vvv]
	      };

	    kill == func [v : val Short; vvv : val V; impure] val Void {
			add [v, (killed_vs [vvv])^];
			not_constant [v, vvv]
	      };

	    vs_out == func [vvv : val V; impure] val (List [Short]) {
		(* return a real list of the vs and the predefvars *)

		concatrev [predefvars, normal_list [(vs [vvv])^]]

		(* cheaper than real concat and order doesn't matter *)
		(* Actually predefvars end up in order, but vs aren't *)
	      };

	    constant == func [v, value : val Short; vvv : val V; impure]
								    val Void
			{ ((consts [vvv])^).v := value };

	    not_constant == func [v : val Short; vvv : val V; impure] val Void
			{ ((consts [vvv])^).v := NOTCONST };

	    is_constant == func [v : val Short; vvv : val V; impure]
								val Boolean
			{ ((consts [vvv])^).v <> NOTCONST };

	    value == func [v : val Short; vvv : val V; impure] val Short
			{ ((consts [vvv])^).v };

	    print == func [vvv : val V; impure] val Void {
			put "vars :"; Slist$put [(vs [vvv])^];put "\n";
			put "killed vars :";Slist$put [(killed_vs [vvv])^];put "\n";
			put "\nCONSTS";
			let xx == Short$New [0];
			    c == (consts [vvv])^
			in
			    do xx < max_var ==>
				if c.xx <> 0 (* NOTCONST *) then
				    put xx; put ":"; put [c.xx]; put " "
				fi;
				xx += 1
			    od
			ni;
		    }


	    } hide { consts; vs; killed_vs; New; Mk; :=; V }
	ni
    }

let
    fruits == enum {apple, orange, banana, cherry}
	      with F {
		put == func[x: val F] {
		       use F in
			if
			  x = apple ==> put("apple");
			# x = orange ==> put("orange");
			# x = banana ==> put("banana");
			# x = cherry ==> put("cherry");
			fi
		       ni; x }
	      };
    f == fruits$New[];
in
    f := fruits$First;
    do
	(put[f]; put["\n"]; f <> fruits$Last) ==> f := Succ[f]
    od;
    put["Finished printing names of "];
    put[fruits$Card];
    put[" fruits\n"]
ni

(* Compile tree.r first *)

(* Computes 3 * 2**n the hard way, where n is read from stdin *)
let
    tree == extern { "tree" };

    TREE == tree[Short];
	     
    x == Short$New[];
    t == TREE$New[]
in
    t := TREE$make_leaf[3];
    x := get[FS];
    do
	x > 0 ==>
            t := make_tree[t, t];
	    x := x - 1;
    od;
    let
        Add_Leaves ==
            func[ x: val TREE ]
		{
                    if  is_leaf[x] ==>
                            leaf_value[x]    
		    #   else ==>
                            Add_Leaves[left_sub_tree[x]]
                            + Add_Leaves[right_sub_tree[x]]
                    fi
                }
    in
        put[ Add_Leaves[t] ]; put["\n"]
    ni
ni

func [
    argc: val Short;
    trace: var Boolean;
    argv: func[val Short] val ChStr;
    eof: func[var Void] val Boolean;
    abort: func [] val Void;
    Void: type (simple) {};
    Null: func (inline "\tpushl\t$0") [] val Void;
    FS: var Void;

    Boolean: type (simple) B {
      (* constants *)
	False:  func (inline "\tpushl\t$0") [] val B;
	True:   func (inline "\tpushl\t$1") [] val B;
      (* operations *)
	:= :    func (standard := 1)
		     (inline "\tmovl\t4(sp),*(sp)+")
		     [var B; val B] val B;
	<> :    func (inline "\txorl2\t(sp)+,(sp)")
		     [x,y: val B] val B;
	= :     func (inline "\txorl2\t(sp)+,(sp)\n\tmcoml\t(sp),(sp)")
		     [x,y: val B] val B;
	New:    func (standard New 1)
		     (inline "\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\tmovl\t$0,(r0)\n\tpushl\tr0")
                     [] var B;
	New:    func (standard init_New 1)
		     (inline "\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\tmovl\t(sp)+,(r0)\n\tpushl\tr0")
		     [val B] var B;
	V:      func (standard V 1)
		     (inline "\tmovl\t*(sp),(sp)")
		     [var B] val B;
	and:    func (inline "\tmcoml\t(sp),(sp)\n\tbicl2\t(sp)+,(sp)")
		     [x,y:val B] val B;
        not:    func (inline "\tbicl3\t(sp),$1,(sp)")
		     [val B] val B;
	or:     func (inline "\tbisl2\t(sp)+,(sp)")
                     [x,y:val B] val B;
	put :   func (standard put 0)
		     (inline "\t.globl\t_Bool_Put\n\tcalls\t$1,_Bool_Put\n\tpushl\tr0")
                     [val B] val B;
        puts :  func (inline "\t.globl\t_Bool_Puts\n\tcalls\t$1,_Bool_Puts\n\tpushl\tr0")
		     [val B] val ChStr;
    };
    
    Short: type (simple
		 constants "\tpushl\t$%c"
			   "\tmovzwl\t$%s,-(sp)"
			   "%c") S {
      (* constants *)
	'0' :   func [] val S;
	'1' :   func [] val S;
	'2' :   func [] val S;
	'3' :   func [] val S;
	'4' :   func [] val S;
	'5' :   func [] val S;
	'6' :   func [] val S;
	'7' :   func [] val S;
	'8' :   func [] val S;
	'9' :   func [] val S;
      (* operations *)
        % :     func (inline "\tdivw3\t4(sp),(sp),r0\n\tmulw2\t4(sp),r0\n\tsubw3\tr0,(sp),4(sp)\t\naddl2\t$4,sp")
                     [x,y:val S] val S;
	* :     func (inline "\tmulw2\t(sp),4(sp)\n\taddl2\t$4,sp")
                     [x,y:val S] val S;
        ** :    func (inline "\t.globl\t_Short_Exp\n\tcalls\t$2,_Short_Exp\n\tpushl\tr0")
                     [x,y:val S] val S;
	+ :     func (inline "\taddw2\t(sp),4(sp) #ADD\n\taddl2\t$4,sp")
                     [x,y:val S] val S;
	+= :    func (inline "\taddw2\t4(sp),*(sp)\n\tmovl*(sp),4(sp)\n\taddl2\t$4,sp")
                     [var S; val S] val S;
        - :     func (inline "\tmnegw\t(sp),(sp)")
                     [val S] val S;
	- :     func (inline "\tsubw3\t4(sp),(sp),4(sp) #SUB\n\taddl2\t$4,sp")
                     [x,y:val S] val S;
	-= :    func (inline "\tsubw2\t4(sp),*(sp)\n\tmovl*(sp),4(sp)\n\taddl2\t$4,sp")
                     [var S; val S] val S;
	/ :     func (inline "\tdivw3\t4(sp),(sp),4(sp)\n\taddl2\t$4,sp")
		     [x,y:val S] val S;
	:= :    func (standard := 1)
		     (inline "\tmovl\t4(sp),*(sp)+")
		     [var S; val S] val S;
	< :     func (inline "\taddl2 $8,sp; cmpw\t-8(sp),-4(sp) #COMP jgeq 4\n\tmovpsl\tr0\n\trotl\t$-3,r0,r0\n\tbicl3\t$0xfffffffe,r0,-(sp)")
		     [x,y:val S] val Boolean;
	<= :    func (inline "\taddl2 $8,sp; cmpw\t-4(sp),-8(sp) #COMP jlss 4\n\tmovpsl\tr0\n\trotl\t$-3,r0,r0\n\tbicl3\tr0,$0x1,-(sp)")
		     [x,y:val S] val Boolean;
	<> :    func (inline "\tcmpl\t(sp)+,(sp)+ #COMP jeql 4\n\tmovpsl\tr0\n\trotl\t$-2,r0,r0\n\tbicl3\tr0,$0x1,-(sp)")
		     [x,y:val S] val Boolean;
	= :     func (inline "\tcmpl\t(sp)+,(sp)+ #COMP jneq 4\n\tmovpsl\tr0\n\trotl\t$-2,r0,r0\n\tbicl3\t$0xfffffffe,r0,-(sp)")
		     [x,y:val S] val Boolean;
	> :     func (inline "\taddl2 $8,sp; cmpw\t-4(sp),-8(sp) #COMP jgeq 4\n\tmovpsl\tr0\n\trotl\t$-3,r0,r0\n\tbicl3\t$0xfffffffe,r0,-(sp)")
		     [x,y:val S] val Boolean;
	>= :    func (inline "\taddl2 $8,sp; cmpw\t-8(sp),-4(sp) #COMP jlss 4\n\tmovpsl\tr0\n\trotl\t$-3,r0,r0\n\tbicl3\tr0,$0x1,-(sp)")
		     [x,y:val S] val Boolean;
	New:    func (standard New 1)
		     (inline "\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\tmovl\t$0,(r0)\n\tpushl\tr0")
		     [] var S;
	New:    func (standard init_New 1)
		     (inline "\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\tmovl\t(sp)+,(r0)\n\tpushl\tr0")
		     [val S] var S;
	V:      func (standard V 1)
		     (inline "\tmovl\t*(sp),(sp)")
		     [var S] val S;
        ^+ :    func (inline "\tmulw3\t(sp),$10,r0\n\taddw2\tr0,4(sp)\n\taddl2\t$4,sp")
                     [x,y: val S] val S;
	get :   func (inline "\t.globl\t_Short_Get\n\tcalls\t$1,_Short_Get\n\tpushl\tr0")
		     [var Void] val S;
	put :   func (standard put 0)
		     (inline "\t.globl\t_Short_Put\n\tcalls\t$1,_Short_Put\n\tpushl\tr0")
                     [val S] val S;
        puts:   func (inline "\t.globl\t_Short_Puts\n\tmovl\t$0x%X,r11\n\tcalls\t$1,_Short_Puts\n\tpushl\tr0")
                     [val S] val ChStr;
        shift : func (inline "\tcvtwl\t(sp),(sp)\n\tashl\t4(sp),(sp),4(sp)\n\taddl2\t$4,sp\n\tclrw\t2(sp)")
                     [x,y: val S] val S;
    };

    (* The following two types are essentially identical on the Vax. *)
    (* Their implementation differs on other machines.               *)
    SFloat: type (simple) F {
      (* operations *)
        * :     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmuld3\t*(sp)+,*(sp),(r0)\n\tmovl\tr0,(sp)")
                     [x,y:val F] val F;
        + :     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\taddd3\t*(sp)+,*(sp),(r0)\n\tmovl\tr0,(sp)")
                     [x,y:val F] val F;
        - :     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmnegd\t*(sp),(r0)\n\tmovl\tr0,(sp)")
                     [val F] val F;
        - :     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmovl\t4(sp),r1\n\tsubd3\t(r1),*(sp)+,(r0)\n\tmovl\tr0,(sp)")
                     [x,y:val F] val F;
        . :     func (inline "\t.globl\t_Float_Dot\n\tmovl\t$0x%X,r11\n\tcalls\t$3,_Float_Dot\n\tpushl\tr0")
                     [whole, fraction, fraction_length: val Short] val F;
        / :     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmovl\t4(sp),r1\n\tdivd3\t(r1),*(sp)+,(r0)\n\tmovl\tr0,(sp)")
                     [x,y:val F] val F;
        := :    func (inline "\tmovd\t*4(sp),*(sp)+")
                     [var F; val F] val F;
        < :     func [x,y:val F] val Boolean;
        <= :    func [x,y:val F] val Boolean;
        <> :    func [x,y:val F] val Boolean;
        = :     func [x,y:val F] val Boolean;
        > :     func [x,y:val F] val Boolean;
        >= :    func [x,y:val F] val Boolean;
        In:     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tcvtwd\t(sp),(r0)\n\tmovl\tr0,(sp)")
                     [val Short] val F;
	New:    func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmovl\t$0,(r0)\n\tpushl\tr0")
		     [] var F;
	New:    func [val F] var F;
	Out:    func (inline "\t.globl\t_Float_Out\n\tcalls\t$1,_Float_Out\n\tpushl\tr0")
		     [val F] val Short;
        V:      func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmovd\t*(sp),(r0)\n\tmovl\tr0,(sp)")
		     [var F] val F;
	atan:   func [val F] val F;
	cos:    func [val F] val F;
	exp:    func [val F] val F;
	exponent: func (inline "\t.globl\t_Float_Exponent\n\tcalls\t$1,_Float_Exponent\n\tpushl\tr0")
		       [val F] val Short;
	get :   func [var Void] val F;
	ln:     func [val F] val F;
	put :   func (standard put 0)
		     (inline "\t.globl\t_Float_Put\n\tcalls\t$1,_Float_Put\n\tpushl\tr0")
		     [val F] val F;
	puts:   func [val F] val ChStr;
	shift:  func [val F; val Short] val F;
	sin:    func [val F] val F;
	sqrt:    func [val F] val F;
	to_Float: func (inline " ")
		       [val F] val Float;
	to_Long: func (inline "\t.globl\t_Float_to_Long\n\tmovl\t$0x%X,r11\n\tcalls\t$1,_Float_to_Long\n\tpushl\tr0")
		      [val F] val Long;
    };

    Float: type (simple) F {
      (* operations *)
        * :     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmuld3\t*(sp)+,*(sp),(r0)\n\tmovl\tr0,(sp)")
                     [x,y:val F] val F;
        + :     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\taddd3\t*(sp)+,*(sp),(r0)\n\tmovl\tr0,(sp)")
                     [x,y:val F] val F;
        - :     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmnegd\t*(sp),(r0)\n\tmovl\tr0,(sp)")
                     [val F] val F;
        - :     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmovl\t4(sp),r1\n\tsubd3\t(r1),*(sp)+,(r0)\n\tmovl\tr0,(sp)")
                     [x,y:val F] val F;
        . :     func (inline "\t.globl\t_Float_Dot\n\tmovl\t$0x%X,r11\n\tcalls\t$3,_Float_Dot\n\tpushl\tr0")
                     [whole, fraction, fraction_length: val Short] val F;
        / :     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmovl\t4(sp),r1\n\tdivd3\t(r1),*(sp)+,(r0)\n\tmovl\tr0,(sp)")
                     [x,y:val F] val F;
        := :    func (inline "\tmovd\t*4(sp),*(sp)+")
                     [var F; val F] val F;
        < :     func [x,y:val F] val Boolean;
        <= :    func [x,y:val F] val Boolean;
        <> :    func [x,y:val F] val Boolean;
        = :     func [x,y:val F] val Boolean;
        > :     func [x,y:val F] val Boolean;
        >= :    func [x,y:val F] val Boolean;
        In:     func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tcvtwd\t(sp),(r0)\n\tmovl\tr0,(sp)")
                     [val Short] val F;
	New:    func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmovl\t$0,(r0)\n\tpushl\tr0")
		     [] var F;
	New:    func [val F] var F;
	Out:    func (inline "\t.globl\t_Float_Out\n\tcalls\t$1,_Float_Out\n\tpushl\tr0")
		     [val F] val Short;
        V:      func (inline "\tmovl\t_aobjfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+8\n\tmovd\t*(sp),(r0)\n\tmovl\tr0,(sp)")
		     [var F] val F;
	atan:   func [val F] val F;
	cos:    func [val F] val F;
	exp:    func [val F] val F;
	exponent: func (inline "\t.globl\t_Float_Exponent\n\tcalls\t$1,_Float_Exponent\n\tpushl\tr0")
		       [val F] val Short;
	get :   func [var Void] val F;
	ln:     func [val F] val F;
	put :   func (standard put 0)
		     (inline "\t.globl\t_Float_Put\n\tcalls\t$1,_Float_Put\n\tpushl\tr0")
		     [val F] val F;
	puts:   func [val F] val ChStr;
	shift:  func [val F; val Short] val F;
	sin:    func [val F] val F;
	sqrt:    func [val F] val F;
	to_Long: func (inline "\t.globl\t_Float_to_Long\n\tmovl\t$0x%X,r11\n\tcalls\t$1,_Float_to_Long\n\tpushl\tr0")
		      [val F] val Long;
	to_SFloat: func (inline " ")
			[val F] val SFloat;
    };

    ChStr: type (simple
		 constants "\t.globl\t_ChStr_v_%d\n\tpushl\t$_ChStr_v_%d"
			   "\tjbr\t1f\n2:%s\t.byte\t0\n1:\tpushl\t$2b"
                           "\t.byte\t%d\n")
		CS {
	characters;
	'' :     func (inline "\t.globl\t_empty_ChStr\tpushl\t$_empty_ChStr")
		      [] val CS;
	. :      func (inline "\t.globl\t_ChStr_Dot\n\tmovl\t0x%X,r11\n\tcalls\t$2,_ChStr_Dot\n\tpushl\tr0")
		      [val CS; val Short] val Short;
	:= :     func (inline "\tmovl\t4(sp),*(sp)+")
                      [var CS; val CS] val CS;
        <  :     func (inline "\t.globl\t_ChStr_lt\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_ChStr_lt\n\tpushl\tr0")
                      [val CS; val CS] val Boolean;
        <= :     func (inline "\t.globl\t_ChStr_le\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_ChStr_le\n\tpushl\tr0")
                      [val CS; val CS] val Boolean;
        <> :     func (inline "\t.globl\t_ChStr_ne\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_ChStr_ne\n\tpushl\tr0")
                      [val CS; val CS] val Boolean;
        =  :     func (inline "\t.globl\t_ChStr_eq\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_ChStr_eq\n\tpushl\tr0")
                      [val CS; val CS] val Boolean;
        >  :     func (inline "\t.globl\t_ChStr_gt\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_ChStr_gt\n\tpushl\tr0")
                      [val CS; val CS] val Boolean;
        >= :     func (inline "\t.globl\t_ChStr_ge\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_ChStr_ge\n\tpushl\tr0")
                      [val CS; val CS] val Boolean;
        In:      func (inline "\tmovl\t_aobjfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocaobj\n1:\tmovl\t(r0),_aobjfreelist+4\n\tmovzbl\t(sp),(r0)\n\tmovl\tr0,(sp)")
                      [val Short] val CS;
	New:     func (standard ptr_New 1)
		      (inline "\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\t.globl\t_empty_ChStr\n\tmovl\t$_empty_ChStr,(r0)\n\tpushl\tr0")
		      [] var CS;
	New:     func (standard init_New 1)
		      (inline "\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\t.globl\t_empty_ChStr\n\tmovl\t(sp)+,(r0)\n\tpushl\tr0")
		      [val CS] var CS;
        Out:     func (inline "\tmovzbl\t*(sp),(sp)")
                      [val CS] val Short;
        V:       func (inline "\tmovl\t*(sp),(sp)")
		      [var CS] val CS;
	^* :     func (inline "\t.globl\t_ChStr_Concat\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_ChStr_Concat\n\tpushl\tr0")
		      [x,y: val CS] val CS;
        getchar: func (inline "\t.globl\t_ChStr_Getchar\n\tmovl\t$0x%X,r11\n\tcalls\t$1,_ChStr_Getchar\n\tpushl\tr0")
                      [var Void] val CS;
        len:     func (inline "\t.globl\t_strlen\n\tcalls\t$1,_strlen\n\tpushl\tr0")
                      [val CS] val Short;
	put:     func (standard put 0)
		      (inline "\t.globl\t_ChStr_Put\n\tcalls\t$1,_ChStr_Put\n\tpushl\tr0")
                      [val CS] val CS;
        substr:  func (inline "\t.globl\t_ChStr_Sub\n\tmovl\t$0x%X,r11\n\tcalls\t$3,_ChStr_Sub\n\tpushl\tr0")
                      [val CS; i,j: val Short] val CS;
    };

    Alias: func (inline "\tcmpl\t(sp)+,(sp)+; popr\t$1 #COMP jneq 4\n\tmovpsl\tr0\n\trotl\t$-2,r0,r0\n\tbicl3\t$0xfffffffe,r0,-(sp)")
                [x,y: var T; T: type {}] val Boolean;

    Array: func (standard Array 0)
		[size: val Short; comptype: type {New; V}]
		type A {. : func(inline "\tcmpl\t4(sp),*(sp) #---\n\tbgeq\t1f #---\n\ttstl\t4(sp) #---\n\tbgeq\t2f #---\n1:\taddl2\t$4,sp #---\n\t.globl\t_Array_error #---\n\tcalls\t$1,_Array_error #---\n2:\taddl3\t$1,4(sp),r0\n\tmovl\t*(sp)+[r0],(sp)")
				[var A; val Short] var comptype;
			. : func(inline "\tcmpl\t4(sp),*(sp) #---\n\tbgeq\t1f #---\n\ttstl\t4(sp) #---\n\tbgeq\t2f #---\n1:\taddl2\t$4,sp #---\n\t.globl\t_Array_error #---\n\tcalls\t$1,_Array_error #---\n2:\taddl3\t$1,4(sp),r0\n\tmovl\t*(sp)+[r0],(sp)")
				[val A; val Short] val comptype;
			New;
			V;
			size: func [] val Short;
                       };

    Ref: func [T: type {}]
              type t { = :  func (inline "\tcmpl\t(sp)+,(sp)+ #COMP jneq 4\n\tmovpsl\tr0\n\trotl\t$-2,r0,r0\n\tbicl3\t$0xfffffffe,r0,-(sp)")
                                 [val t; val t] val Boolean;
                       := : func (inline "\tmovl\t4(sp),*(sp)+")
                                 [var t; val t] val t;
                       New: func (inline "\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\tmovl\t$0X40000001,(r0)\n\tpushl\tr0")
                                 [] var t;
                       Nil: func (inline "\tpushl\t$0x40000003")
                                 [] val t;
                       V:   func (inline "\tmovl\t*(sp),(sp)")
                                 [var t] val t;
                       In:  func (inline "# ref$In")
                                 [var T] val t;
                       Out: func (inline "\tmovl\t(sp)+,(sp)")
                                 [val t; var Void] var T;
                       ^ : func (inline "\tmovl\t(sp)+,(sp)")
                                [val t; var Void] var T;
                     };

    File: type f { = :  func (inline "\tcmpl\t(sp)+,(sp)+ #COMP jneq 4\n\tmovpsl\tr0\n\trotl\t$-2,r0,r0\n\tbicl3\t$0xfffffffe,r0,-(sp)")
                             [val f; val f] val Boolean;
                   := : func (inline "\tmovl\t4(sp),*(sp)+")
                             [var f; val f] val f;
                   Null: func (inline "pushl\t$0")
                              [] val f;
                   New: func (inline "\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\tmovl\t$0X0,(r0)\n\tpushl\tr0")
                             [] var f;
                   V:   func (inline "\tmovl\t*(sp),(sp)")
                             [var f] val f;
                   close: func (inline "\t.globl\t_File_Close\n\tcalls\t$1,_File_Close\n\tpushl\tr0")
                               [val f] val Void;
                   eof:   func (inline "\t.globl\t_File_Eof\n\tcalls\t$2,_File_Eof\n\tpushl\tr0")
                               [val f; var Void] val Boolean;
                   flush: func (inline "\t.globl\t_File_Flush\n\tcalls\t$1,_File_Flush\n\tpushl\tr0")
                               [val f] val Void;
                   open:  func (inline "\t.globl\t_File_Open\n\tcalls\t$2,_File_Open\n\tpushl\tr0")
                               [fname,mode: val ChStr] val f;
		   readb: func (inline "\t.globl\t_File_Readb\n\tcalls\t$2,_File_Readb\n\tpushl\tr0")
			       [val f; var Void] val Short;
                   readc: func (inline "\t.globl\t_File_Readc\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_File_Readc\n\tpushl\tr0")
                               [val f; var Void] val ChStr;
                   seek:  func (inline "\t.globl\t_File_Seek\n\tcalls\t$2,_File_Seek\n\tpushl\tr0")
                               [val f; val Long] val Void;
                   stderr: func (inline "\t.globl\t__iob\n\tpushl\t$__iob+40")
                                [] val f;
                   stdin:  func (inline "\t.globl\t__iob\n\tpushl\t$__iob")
                                [] val f;
                   stdout: func (inline "\t.globl\t__iob\n\tpushl\t$__iob+20")
                                [] val f;
                   write: func (inline "\t.globl\t_File_Write\n\tcalls\t$2,_File_Write\n\tpushl\tr0")
                               [val f; val ChStr] val ChStr;
		   writeb: func (inline "\t.globl\t_File_Writeb\n\tcalls\t$2,_File_Writeb\n\tpushl\tr0")
				[val f; val Short] val Short;
                 };

    List: func [t:type{}] type l {
                := :     func (inline "\tmovl\t4(sp),*(sp)+")
                              [var l; val l] val l;
                New:     func (inline "\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\tmovl\t$0,(r0)\n\tpushl\tr0")
                              [] var l;
                V:       func (inline "\tmovl\t*(sp),(sp)")
                              [var l] val l;
                '' :     func (inline "\tpushl\t$0")
                              [] val l (*empty list*);
                is_nil:  func (inline "\ttstl\t(sp)+  #COMP jneq 4\n\tmovpsl\tr0\n\trotl\t$-2,r0,r0\n\tbicl3\t$0xfffffffe,r0,-(sp)")
                              [val l] val Boolean (* is empty *);
                cons:    func (inline "\tmovl\t_objfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+8\n\tmovl\t(sp)+,4(r0)\n\tmovl\t(sp)+,(r0)\n\tpushl\tr0")
                              [val t; val l] val l; (* add at left end *);
                ^* :     func (inline "\tmovl\t_objfreelist+8,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$2\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+8\n\tmovl\t(sp)+,(r0)\n\tmovl\t(sp)+,4(r0)\n\tpushl\tr0")
                              [val l; val t] val l; (* cons, with args reversed *);
                head:    func (inline "\ttstl\t(sp) #---\n\tbneq\t1f #---\n\tcalls\t$0,_list_error #---\n1:\tmovl\t(sp),r0\n\tmovl\t4(r0),(sp)")
			      [val l] val t (* first element, error if empty *);
                tail:    func (inline "\ttstl\t(sp) #---\n\tbneq\t1f #---\n\tcalls\t$0,_list_error #---\n1:\tmovl\t*(sp),(sp)")
                              [val l] val l (* all but first, error if empty *);
           };

    LList: func [t:type{}] type l {
                := :     func (inline "\tmovl\t4(sp),*(sp)+")
                              [var l; val l] val l;
                New:     func (inline "\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\tmovl\t$0,(r0)\n\tpushl\tr0")
                              [] var l;
                V:       func (inline "\tmovl\t*(sp),(sp)")
                              [var l] val l;
                '' :     func (inline "\tpushl\t$0")
                              [] val l (*empty list*);
                is_nil:  func (inline "\ttstl\t(sp)+  #COMP jneq 4\n\tmovpsl\tr0\n\trotl\t$-2,r0,r0\n\tbicl3\t$0xfffffffe,r0,-(sp)")
                              [val l] val Boolean (* is empty *);
                cons:    func (inline "\tmovl\t_objfreelist+12,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$3\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+12\n\tmovl\t(sp)+,4(r0)\n\tmovl\t(sp)+,(r0)\n\tclrl\t8(r0)\n\tpushl\tr0")
                              [val t; val l] val l; (* add at left end *);
                cons:    func (inline "\tmovl\t_objfreelist+12,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$3\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+12\n\tmovl\t(sp)+,4(r0)\n\tmovl\t(sp)+,(r0)\n\tmovl\t$1,8(r0)\n\tpushl\tr0")
                              [val t; func [] val l] val l;
                head:    func (inline "\ttstl\t(sp) #---\n\tbneq\t1f #---\n\tcalls\t$0,_list_error #---\n1:\tmovl\t(sp),r0\n\tmovl\t4(r0),(sp)")
                              [val l] val t (* first element, error if empty *);
                tail:    func (inline "\ttstl\t(sp) #---\n\tbneq\t1f #---\n\tcalls\t$0,_list_error #---\n1:\tmovl\t(sp),r0\n\ttstl\t8(r0)\t\n\tbeql\t2f\n\tmovl\t$0x%X,r11\n\tcalls\t$1,_LList_Tail\n\tpushl\tr0\n\tjbr\t3f\n2:\tmovl\t(r0),(sp)\n3:\n")
                              [val l] val l (* all but first, error if empty *);
           };

    Long: type (simple
                constants "\t.globl\t_Long_%c\n\tpushl\t$_Long_%c"
               ) L {
      (* constants *)
	'0' :   func [] val L;
	'1' :   func [] val L;
	'2' :   func [] val L;
	'3' :   func [] val L;
	'4' :   func [] val L;
	'5' :   func [] val L;
	'6' :   func [] val L;
	'7' :   func [] val L;
	'8' :   func [] val L;
	'9' :   func [] val L;
      (* operations *)
        % :     func (inline "\t.globl\t_Long_Mod\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_Long_Mod\n\tpushl\tr0")
                     [val L; val Short] val Short;
        * :     func (inline "\t.globl\t_FLong_Mult\n\tmovl\t$0x%X,r11\n\tjsb\t_FLong_Mult\n\tmovl\t(sp)+,r0")
                     [x,y:val L] val L;
        + :     func (inline "\t.globl\t_FLong_Add\n\tmovl\t$0x%X,r11\n\tjsb\t_FLong_Add\n\tmovl\t(sp)+,r0")
                     [x,y:val L] val L;
        - :     func (inline "\t.globl\t_FLong_Neg\n\tmovl\t$0x%X,r11\n\tjsb\t_FLong_Neg")
                     [x:val L] val L;
        - :     func (inline "\t.globl\t_FLong_Sub\n\tmovl\t$0x%X,r11\n\tjsb\t_FLong_Sub\n\tmovl\t(sp)+,r0")
                     [x,y:val L] val L;
        / :     func (inline "\t.globl\t_Long_Div\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_Long_Div\n\tpushl\tr0")
                     [val L; val Short] val L;
	:= :    func (standard := 1)
		     (inline "\tmovl\t4(sp),*(sp)+")
                     [var L; val L] val L;
	< :     func (inline "\t.globl\t_Long_cmp; calls $2,_Long_cmp; tstw r0 #COMP jgeq 4\n\tmovpsl\tr0\n\trotl\t$-3,r0,r0\n\tbicl3\t$0xfffffffe,r0,-(sp)")
		     [x,y:val L] val Boolean;
	<= :    func (inline "\t.globl\t_Long_cmp; calls $2,_Long_cmp; tstw r0 #COMP jgtr 6\n\tbgtr\t1f\n\tpushl\t$1\n\tjbr\t2f\n1:\tpushl\t$0\n2:")
		     [x,y:val L] val Boolean;
	<> :    func (inline "\t.globl\t_Long_cmp; calls $2,_Long_cmp; tstw r0 #COMP jeql 4\n\tmovpsl\tr0\n\trotl\t$-2,r0,r0\n\tbicl3\tr0,$0x1,-(sp)")
		     [x,y:val L] val Boolean;
	= :     func (inline "\t.globl\t_Long_cmp; calls $2,_Long_cmp; tstw r0 #COMP jneq 4\n\tmovpsl\tr0\n\trotl\t$-2,r0,r0\n\tbicl3\t$0xfffffffe,r0,-(sp)")
		     [x,y:val L] val Boolean;
	> :     func (inline "\t.globl\t_Long_cmp; calls $2,_Long_cmp; tstw r0 #COMP jleq 6\n\tbleq\t1f\n\tpushl\t$1\n\tjbr\t2f\n1:\tpushl\t$0\n2:")
		     [x,y:val L] val Boolean;
	>= :    func (inline "\t.globl\t_Long_cmp; calls $2,_Long_cmp; tstw r0 #COMP jlss 4\n\tmovpsl\tr0\n\trotl\t$-3,r0,r0\n\tbicl3\tr0,$0x1,-(sp)")
		     [x,y:val L] val Boolean;
        In :    func (inline "\t.globl\t_Long_In\n\tmovl\t$0x%X,r11\n\tcalls\t$1,_Long_In\n\tpushl\tr0")
                     [val Short] val L;
	New:    func (standard ptr_New 1)
		     (inline "\t.globl\t_Long_0\n\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\tmovl\t$_Long_0,(r0)\n\tpushl\tr0")
                     [] var L;
	New:    func (standard init_New 1)
		     (inline "\t.globl\t_Long_0\n\tmovl\t_objfreelist+4,r0\n\tjneq\t1f\n\tmovl\t$0x%X,r11\n\tpushl\t$1\n\tcalls\t$1,_allocobj\n1:\tmovl\t(r0),_objfreelist+4\n\tmovl\t(sp)+,(r0)\n\tpushl\tr0")
		     [val L] var L;
	Out:    func (inline "\t.globl\t_Long_Out\n\tmovl\t(sp),r0\n\tcmpl\t(r0),$1 #---\n\tbneq\t1f #---\n\tcmpl\t4(r0),$0x7fff #---\n\tbgtr\t1f #---\n\tcmpl\t4(r0),$0xffff8000 #---\n\tbgtr\t2f #---\n1:\tcalls\t$1,_Long_Out #---\n\tpushl\tr0 #---\n\tjbr\t3f #---\n2:\tmovzwl\t4(r0),(sp)\n3:")
		     [val L] val Short;
	V:      func (standard V 1)
		     (inline "\tmovl\t*(sp),(sp)")
                     [var L] val L;
        ^+ :    func (inline "\t.globl\t_Long_Concat\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_Long_Concat\n\tpushl\tr0")
                     [x,y: val L] val L;
        nbits : func (inline "\t.globl\t_Long_Nbits\n\tmovl\t$0x%X,r11\n\tcalls\t$1,_Long_Nbits\n\tpushl\tr0")
		     [val L] val L;
	nwords: func [val L] val L;
	odd:    func [val L] val Boolean;
	put :   func (standard put 0)
		     (inline "\t.globl\t_Long_Put\n\tmovl\t$0x%X,r11\n\tcalls\t$1,_Long_Put\n\tpushl\tr0")
                     [val L] val L;
	puts:   func (inline "\t.globl\t_Long_Puts\n\tmovl\t$0x%X,r11\n\tcalls\t$1,_Long_Puts\n\tpushl\tr0")
		     [val L] val ChStr;
        shift : func (inline "\t.globl\t_Long_Shift\n\tmovl\t$0x%X,r11\n\tcalls\t$2,_Long_Shift\n\tpushl\tr0")
                     [x,amount: val L] val L;
    };
    Callcc: func (standard Callcc 0)
		 [ body: func[ cc: func[ val T ] val Void; var Void ] val T;
		   T: type {};
		   var Void
		 ] val T;
    Signal: func (standard Callcc 0)
		 [sig_num: val Short; var Void] val Boolean;
    Unsignal: func[ sig_num: val Short; var Void] val Void;
    Expand_Hp: func[ val Short ] val Void;
] 
{   let
	impure === var Void;
	^ == func[x: val T; y: val List[T]; T: type{}] {
		cons[x,y];
	     };
	^ == func[x: val T; y: val T; T: type{}] {
		cons[x, cons[y, (List[T])$'']];
	     };
    in
	use Float in use ChStr in use Boolean in use Short in
	    
	ni ni ni ni;
	Null[]
    ni
}

(* For now these lists are not sorted *)
func[t: type T { put: func[val T]val T; =;
				(*<: func [val t; val t] val Boolean*) }] {

    let Dlist == extern {"dlist"} [t]
    in
	extend {Dlist} with S {

	    (* need is_nil, copy, New, '', add, remove, normal_list *)

	    (* inserts x *)
	    add == func [x: val t; s : val S; impure] val Void {
				addr [x, Out [s]]
			};

	    remove == func [x : val t; s : var S;impure] val Void {
		(* removes one occurrence of x, if there is one, from s *)
			let cur == Dlist$New [];
			    found == New [False]
			in use Dlist in
			    cur := Out [s]; (* assume s points to head of list *)

			    if not is_nil [cur]  then
				if (head cur) = x then
				    s := next s;(* when you remove the first elt of the
						list you need to move the head
						pointer on to the next elt *)
				    delete [cur];
				    found := True
			        else
			            cur := next [cur];
			            do not is_nil [cur] cand not found ==>
					if (head cur) = x then
					      found := True;
					      delete [cur]
					fi;
					if not is_nil [cur] then 
							cur := next [cur] fi
			      	    od
			        fi
			    fi
			    (* if not found then there was a duplicate UDC -
						that's OK *)
			ni ni
		};

	    normal_list == func [s : val S;impure] val (List [t]) {

			let l == (List [t])$New [];
			    s1 == S$New []
			in
			    s1 := s;
			    l := (List [t])$'';
			    do not is_nil [s1] ==>
				l := cons [head s1, l];
				s1 := next s1
			    od;
			    l
			ni
		};

	    } hide {Nil; In; Out; addl; addr; delete}
    ni
}

(* Build a lazy list of primes, and then print the first 900 elements *)
(* Note that the implementation of streams is reasonably good;        *)
(* however the algorithm is so bad that no compiler can possibly bail *)
(* it out.  Compile with -p                                           *)

# define scons(x,y) cons[x, func[]{y}]

let
    S == LList[Short];

    (* Produce list of integers > n *)
    ints == func[n: val Short] val S {
		scons(n, ints[n+1])
	    };

    (* Produce the sublist of all nonmultiples of m *)
    nonm == func[m: val Short; s: val S] val S{
		if head[s] % m = 0 then
		    nonm[m, tail[s]]
		else
		    scons(head[s], (nonm[m, tail[s]]))
		fi
	    };

    (* Produce sublist of s of numbers n that are not multiples of *)
    (* numbers preceding n in the list.                            *)
    p == func[s: val S] val S{
		scons(head[s], (p[nonm[head[s], tail[s]]]))
	 };

    primes == p[ints[2]];

    s == S$New[];
    i == New[0];
in
    s := primes;
    do i < 900 ==>
	put i; put ": "; put[head[s]]; put "\n";
	s := tail[s];
	i += 1;
    od
ni

(* compile memo.r first *)
(* Must be compiled with rc -pL *)

# define impure var Void

let
    tabsize == 30;

    (* Convert a recursive function from Short to Long to a memo-function *)
    memo == func [f: func[val Short; impure] val Long; impure] {
                extern {"memo"} [f, func[x: val Short] {x % tabsize}, tabsize]
            };

    fib == memo[func[ x: val Short; impure ] {
                    if
                        x < 2 ==> Long$1
                    #   else ==> fib[ x-1 ] + fib[ x-2 ]
                    fi
                }];

in
    put[ fib[ 35 ] ]; put["\n"];
ni

(* RefNum objects - Short integers 0...maxrc. Sticky reference counts *)

func [maxrc : val Short] {

let E == extend { Short }
	    with R {

		inc == func [x : val R] val R {
				if x R$< R$In [maxrc]  then
(* to observe how often counts actually get inced to maxrc, as opposed to being
	set to maxrc directly. Useful for deciding on a suitable maxrc value *)
(*
if (x R$+ R$1) = R$In [maxrc] then put "\n\t\tNOTE : counted to maxrc;";
				   put " Is maxrc big enough ?\n"
fi;
*)

					x R$+ R$1
				else R$In [maxrc] 
				fi
			};

		dec == func [x : val R] val R {
				if x R$>= R$In [maxrc]   ==> R$In [maxrc]	(* 'sticky' *)
				#  x R$<= R$0 	==> put [ 
				  "\nWARNING attempt to decrement 0 ref ct."];
						    R$0		(* error ?? *)
				#  else 	==> x R$- R$1
				fi
			};

		max == func [x, y : val R] val R {
				if x < y then
					y
				else x
				fi
			}

		} (* with *)

in   E  

	hide { - <<func [val E] val E>>;
	       - <<func [val E; val E] val E>>;
		 +; +=; -= }	(* really need to hide := to be effective *)
ni
}

(* Tables mapping locations (allocation sites) to reference counts *)
# include "defs.h"

# define R0 (RefNum $In [0])
# define R1 (RefNum $In [1])
# define Rmaxrc (RefNum $In [maxrc])

func [nlocs, maxrc : val Short;
	 C : type P {New; V; :=; Mk : func [a,b,d :val Short] val P}] {
    let

	LocList === (extern {"loclist"} [nlocs]);
	LOCS	=== (extern {"locs"} [nlocs]);

	RefNum 	=== (extern {"refnum"} [maxrc]);
	RArray 	=== (Array [nlocs + 1, RefNum]);

    in  (Ref [RArray])  with R {

	    print == func [r : val R;impure] val Void {
    			let i == Short$New [0];
			    a == r^
			in 
			   do i <= nlocs   ==>
				put i;put ":";put [a.i];put " ";
				i += 1
			   od
			ni;
			put "\n"
		    };

	    top == func [] val R {
			let t == RArray $New [];
			    i == Short$New [0]
			in
			   do i <= nlocs   ==>
				t.i := RefNum $In [0];
				i += 1
			   od;
			   R$In [t]	(* returned *)
			ni
		    };

	    pair_meet == func [r1, r2 : val R; impure] val Void {
			let i == Short$New [0];
			    a1 == r1^;
			    a2 == r2^
			in 
			   do i <= nlocs   ==>
				a2.i := RefNum $max [a1.i, a2.i];
				i += 1
			   od
			ni
		    };

	    equal == func [r1, r2 : val R;impure] val Boolean {
			let a1 == r1^;
			    a2 == r2^;
			    i == Short$New[0]
			in
			    do (i <= nlocs) cand (a1.i = a2.i) ==>
					i += 1
			    od;

			    i > nlocs (* implies equal; else not equal *)
			ni
		    };

	    apply == func [q, category, first, second : val Short;
			   r : val R; l : val LOCS;
			   vlist : val (List [Short]);
			   finalpass : val Boolean;	impure] val C {
			let i == Short$New [];
			    app == r^;
			    clobberer == C$New []; (* return value - only 
						useful in finalpass *)

			    deref == func [x : val Short; impure]
								 val Void {
(* If all the locs x could point to have rc = 1 (0 should be a bug now) then
	the op clobbers.
   If x could point to only one loc then that loc's rc is decremented.	*)

				    let xlocs == LOCS $look [x, l];
					unoloc == LocList $oneloc [xlocs]
					(* loc = 0 => not just one loc *)
				    in
				     if finalpass then
				        (* if there are some locs - no point
					   deallocing otherwise - and 
						all locs have rc = 1 ... *)
					if feasible [xlocs] cand
				           and_map
				              [xlocs,
			                       func [loc : val Short;impure]
			                            val Boolean
					       { (app.loc = R1) cor
					         (LOCS$count [loc, l, vlist]
					         = 1) }]
					then
					    clobberer :=
					      C$Mk[q, x, unoloc]
					(* unoloc used to get size of object
						if only one object possible *)
					fi;
				     fi; (* if final pass *)

				(* actual deref part *)
					if (unoloc <> 0) then
OPEN
	put "DEREF ";put x;put " which refers only to ";put unoloc;
	put " whose rc=";put [app.unoloc];put "\n";
CLOSE
					    app.unoloc :=
						RefNum $dec [app.unoloc]


(* else make sure that RC values of all elements of l(x) (for which there are
		refcounts) are no bigger than their occurences on all lists 
	(including memvar which count as maxrc occurences, 
	  and excluding x (which explains the  -1))
*)

(* This code is executed if we were unable to decrement the refcount of
	x's objects, because there was more than one of them.*)

else 
 rc_map [xlocs, func [loc : val Short; impure] val Void {
			let occs == LOCS$count [loc, l, vlist] - 1
			in
			    if occs < RefNum$Out [app.loc]
			    then
OPEN
	put "**** #occurences of ";put loc;put " is ";
	put occs;
	put " while ref count would have been ";
	RefNum$put [app.loc];
	put "\n";
CLOSE
				   app.loc := RefNum$In [occs]
			    fi
			ni;
			Null []
		      }]

					fi
				    ni
OPEN
  	;DEBUG("\n");
CLOSE

				} (* deref *)
			in
			    clobberer := C$Mk [-1, 0, 0]; (* null value *)
(*
	DEBUG ("RC apply to local "); put [q];DEBUG ("\n");
*)
			    if (category <> UNSAFE)
			      cand (first >= C0) cand (first <= C4) then
						Null []
				(* avoid setting C0..C4 to anything but nil *)
			    else 
			      if
				(category = ANY) cor (category = GARCAT) cor
				(category = ALCNIL) cor (category = ALCSTAT)
				cor (category = ALCSTACK) ==>
					deref [first]
					(* no new refs worth counting *)

			      #	(category = ALLOC) ==>
				(* var(first) := loc(second) *)
					deref [first];
					app.second := RefNum $inc[app.second]

			      #	(category = ASSIGN) ==>
				   let loclist == LOCS $look [second, l]
				   in
				(* can't deref 1st if 2nd is the same var
				   but there should be no ASSIGNs like that *)

					     deref [first];

				(* potential new ref to any loc in second *)
			LocList $rc_map [loclist, 
		             func [loc : val Short;impure]val Void
				   { app.loc := RefNum $inc [app.loc];Null[]}]
				   ni

			      #	(category = WATCHARG) ==>
					Null []

			      #	(category = TOMEM) ==>
			LocList $rc_map [LOCS $look [second, l], 
			     func [loc : val Short;impure]val Void
				     { app.loc := Rmaxrc; Null[]}]

			      # (category = ERRCAT) ==>
				(* simply set all app entries to 0 (top) *)
				let i == Short$New [0]
				in
				   do i <= nlocs   ==>
					app.i := RefNum $In [0];
					i += 1
				   od
				ni

			      #	(category = CATTAR) ==>
				  (* like stack for first and second *)
LocList $rc_map [LOCS $look [first, l], func [loc : val Short;impure]val Void
				   { app.loc := Rmaxrc; Null[]}];
LocList $rc_map [LOCS $look [second, l],func [loc : val Short;impure] val Void
				   { app.loc := Rmaxrc; Null[]}]
			      #	(category = UNSAFE) ==>
				   (* forall locs, if rc not 0 then -> maxrc*)
LocList $rc_map [LocList $bottom[], func [loc : val Short;impure] val Void
					{ if (app.loc <> R0) then
						app.loc := Rmaxrc
					  fi;
					  Null[]}]
			      
			      # else ==> Null []
			      fi
			    fi;

OPEN
	DEBUG("After APPLY rc's are");
	let j == Short$New [1]
	in
   	    do j <= nlocs ==>
	        DEBUG(" ");put j;DEBUG(":");put[app.j];
	        j += 1
   	    od;
            DEBUG("\n")
	ni;
CLOSE

			    V [clobberer] (* returned *)
			ni
		    } (* apply *)

	} (* with *)
    ni
}

(* analogous to locs.r in that it maps virtual registers to allocation
   sites.  This is a variant designed for the first pass, which gathers
   interprocedural summary info. *)
# include "defs.h"
# define ABS(I) (if I < 0 then - I else I fi)

func [nlocs : val Short] {
	let 
	    LocList === (extern {"loclist"} [nlocs]);

	    Note === prod {
			callnum : val Short;
			argnum : val Short;
			locs : val LocList (* the set of locs that could be
					refed by the arg passed as argnum-th
					arg in the callnum-th call *)
	    };


	    tablesize == 64;
	    H == (extern {"hash"} 
			[tablesize, Short, LocList, LocList$notfound[]])
	in
	    (Ref [H])

	      with L {

	    (* Look just looks up the var. It returns top (empty loclist) if
		it does not find an entry *)
	    look == func [key : val Short; table : val L;impure]
							 val LocList {
			let hshkey == ABS(key);
			    a == H$lookup [hshkey, key, table^]
			in
			    if a = LocList$notfound [] then
				LocList$top []
			    else 
				a
			    fi
			ni
		    };

	    (* find will insert a 'top' value if it doesn't find the var and
		thus always returns a valid entry - which is a ref whose value
		can be changed 		*)
	    find == func [key : val Short; table : val L;impure] val LocList {
			let hshkey == ABS(key);
			    a == H$lookup [hshkey, key, table^]
			in
			    if a = LocList$notfound [] then
if key >= 0 then 
	DEBUG("\n HASH find unsuccessful - screwed up var lists. var ");
	put [key];put "\n"
fi;
				H$insert [hshkey, key, LocList$top [], table^];
				H$lookup [hshkey, key, table^]
			    else 
				a
			    fi
			ni
		 };

	    top == func [ vlist : val List [Short]] val L {
		(* Insert a top loclist for each var *)
			let h == H$Init [];
			    vs == (List [Short])$New []
			in
			   vs := vlist;
			   do not is_nil [vs] ==>
			     let v == head vs
			     in
				H$insert [v, v, LocList$top [], h]
			     ni;
			     vs := tail vs
			   od;
			   L$In [h]
			ni
		    };

	    none == func [ vlist : val List [Short]] val L {
		(* Insert a none loclist for each var *)
			let h == H$Init [];
			    vs == (List [Short])$New []
			in
			   vs := vlist;
			   do not is_nil [vs] ==>
			     let v == head vs
			     in
				H$insert [v, v, LocList$create [NONE_OBJ], h]
			     ni;
			     vs := tail vs
			   od;
			   L$In [h]
			ni
		    };

	    pair_meet == func [l1, l2 : val L; vlist : val List [Short];
							impure] val Void {
			let vs == (List [Short])$New [];
			    v == Short$New[]
			in
			    (* for each variable in vlist, put the merging of
				its entry in l1 and l2 into l2	*)
			    vs := vlist;
			    do not is_nil [vs] ==>
				v := head vs;
				vs := tail vs;
				let ref1 == L$look [v, l1];
				    ref2 == L$find [v, l2]
				in
				(* replace uses ref2's ref cell *)
				   replace [ref2, merge [ref1, ref2]]
				ni
			    od
			ni
		    };

	    equal == func [l1, l2 : val L; vlist : val List [Short]
						      ;impure] val Boolean {
			let vs == (List [Short])$New [];
			    eq_sofar == Boolean$New [True]
			in  vs := vlist;
			    do eq_sofar cand (not is_nil [vs]) ==>
				if not LocList$eq [L$look [head vs, l1],
						     L$look [head vs, l2]]
				then eq_sofar := False
				fi;
				vs := tail vs
			    od;
			    eq_sofar
			ni
		    };

	    print == func [l : val L; vlist : val List [Short]; impure] {
			let vs == (List [Short])$New [];
			    v == Short$New []
			in
			    vs := vlist;
			    do not is_nil [vs]  ==>

				v := head vs;
				vs := tail vs;

				let entry == L$look [v, l]
				in
				  if not [is_top entry] then
					put[v];DEBUG (" loclist is ");
					LocList$print [entry]
				  fi
				ni
			    od
			ni
		    };

	    apply == func [category, first, second, callnum : val Short;
			   a : val L; vlist : val List [Short];
			   notes : var List [Note];   impure] val Void {
OPEN
	DEBUG ("LOCS apply; category "); put [category];DEBUG ("\n");
CLOSE
		   let refx == L$find [first, a]
		   in
		      if (first >= C0) cand (first <= C4) then Null []
			   (* to avoid setting C0..C4 to anything but nil *)
		      else
		     if

		       (category = ALCNIL)      ==>
			(* x gets nil (none location) *)
				replace [refx, LocList$create [NONE_OBJ]]
		     # (category = ALCSTAT) ==>
				replace [refx, LocList$create [STATIC_OBJ]]
		     # (category = ALCSTACK) ==>
			(* note that I will never actually deallocate an
			    object on the stack (DEA for a stack object
			    has no effect), so it's safe to ignore the
			    fact that I don't know what set of objects it
			    could actually be *)
				replace [refx, LocList$create [STACK_OBJ]]
  		     # (category = ALLOC) cor (category = MAYBEALC) ==>
			(* x := alloc where alloc number is second *)
				replace [refx, LocList$create [second]]
OPEN
	;DEBUG("ALLOC : first loclist is now")
	;LocList$print [L$look [first, a]]
CLOSE

		     # (category = ASSIGN) ==>
			(* x := y *)
OPEN
	DEBUG ("ASSIGN: second and first loclists \n");
	put[second];DEBUG(":");LocList$print [L$look [second, a]];
CLOSE
			replace [refx, L$look [second, a]]
OPEN
	;put[first];DEBUG(":");LocList$print [L$look [first, a]]
CLOSE

		     # (category = WATCHARG) ==>
				Null []

		     # (category = GARCAT) ==>
			(* x := loc numbered second *)
OPEN
	put "GAR :var ";put first;put " := loc#";put second;put "\n";
CLOSE
			replace [refx, LocList$create [second]]

		     # (category = ANY)	     ==>
			(* x := anything from mem / everything *)
			replace [refx, LocList$create [MEM_OBJ]]

		     # (category = TOMEM)	==>
			(* mem_var gets anything second has as well as what it has*)
			let mem_var_val == L$find [mem_var, a];
			    sources == L$look [second, a]
			in
OPEN
	put "TOMEM :var ";put second;put ";
	locs are ";LocList$print [sources];put "\n";
CLOSE

			    replace [mem_var_val, merge [mem_var_val, sources]];

OPEN
	put "Locs now in memory are ";
	LocList$print [L$look [mem_var, a]];put "\n";
CLOSE

			ni

		     # (category = ERRCAT) ==>
			(* set all loclists to top *)
			(* this is weird because I hadn't anticipated it when
			   I decided on the calling convention for apply *)
			let vs == (List [Short])$New []
			in
			    vs := vlist;
			    do not is_nil [vs] ==>
				let v == head vs
				in
				    replace [L$find [v, a], LocList$top []]
				ni;
				vs := tail vs
			    od
			ni

		     # (category = CATTAR) ==>
			(* mem_var gets all of first and second as well as ..*)
			let mem_var_val == L$find [mem_var, a];
			    m == merge [mem_var_val, L$look [first, a]];
			    m1 == merge [m, L$look [second, a]]
			in
			    replace [mem_var_val, m1]
			ni

		     # (category = UNSAFE) ==>
			let mem_var_val == L$find [mem_var, a];
			in
			    replace [mem_var_val, LocList$bottom []]
			ni

		     # (category = ARGCAT) ==>
			(* cons a note onto notes if the var being passed could
				refer to any (arg) locs *)
			(* first = arg#; second = var being passed *)
			let l == copy [L$look [second, a]]
			in
OPEN
	put "\n var being passed is ";put second; put " entry is ";print l;
CLOSE
			    if not [is_top l] then
				let n == Note$Mk [callnum, first, l]
				in
				    notes := cons [n, notes]
				ni
			    fi
			ni
			
		     # else  ==> Null []
		     fi
		     fi (* C0...C4 *)
		   ni (* refx *)
(*
	;put[first];DEBUG(":");LocList$print [L$look [first, a]]
*)
	    }
	} (* with *)
	hide { Out; ^; In }
	ni (* let tablesize *)
}

let
    fork == func[var Void] val Short { extern "_fork" };
    sleep == func[val Short; var Void] val Void { extern "_sleep" };
    pid == fork[];
in
    if
	pid = 0 ==> sleep[5]; put["Child here\n"];
    #   pid <> 0 ==> sleep[10]; put["Parent here\n"];
    fi
ni

(*
Main routine.  Invoked with args:

flags input_code output_code [input_summary [output_summary]]

The flags argument is always present.  It is either - or -verbose.
The two code files use RIC (Russell Intermediate Code).  The input summary file
is the concatenation of summary information for all referenced compilation
units.
*)
# include "defs.h"
# include "../root_path.h"
# define ONLYINTRA Boolean$False
(* if ONLYINTRA then ----- this was never completed ------
		classify does not produce any MAYBEALCs or ARGCATs
		firstpass is left out completely
		lastpass doesn't bother trying to refine all ARGCATs
		and MAYBEALCs
		graph flow is not called
		(any amount of graph stuff can be left out)
*)
# define MAX(x, y) (if (x >= y) then x else y fi)
# define QuadList (List [Short])
# define BBList (List [Short])

let
	put_list == func [l : val List [Short]] val Void {
		if not is_nil [l] then 
		  put [head l]; put [" "]; put_list [tail l]
		fi
	    };

	(* assists reverse and concat by providing an accumulating reverse *)
	rev == func [l, accum : val List [t]; t : type {}] val List [t] {
			if is_nil l then accum
			else
			    rev [tail l, cons [head l, accum], t]
			fi
		};
	
	reverse == func [l : val List [t]; t : type {}] val List [t] {
			rev [l, (List [t])$'']
		};

	(* concatrev reverses the first list and concats onto second list *)
	concatrev == func [lst1, lst2 : val List [t]; t : type {}] 
							      val List [t] {
			rev [lst1, lst2]
		};

	(* assumes non-empty list argument *)
	last == func [lst : val List [Short]] val Short {
			if is_nil [tail lst] then [head lst]
			else last [tail lst]
			fi
		};

	remove == func [x : val Short; lst : val QuadList] val QuadList {
			if is_nil [lst] then lst
			elsif (head lst) = x then (tail lst)
			else cons [head lst, remove [x, tail lst]]
			fi
		};

  Arg1type == union A1 {
		arg : val Short;
		str : val ChStr;
		};

  (* one of these records is associated with every quad in the input *)
  Basics == prod B {
	    opc : val Short;
	    arg1 : val Arg1type;
	    arg2, arg3 : val Short;
	    dull : val Boolean;
	};

  MAX_QUAD == Short$20000;
  BA == Array [MAX_QUAD, Basics];
  basics == BA$New [];

  q == Short$New[0];

  exit == func[n: val Short; impure] val Void { extern "_exit" };
  popen == func [cmd, mode : val ChStr; impure] val File { extern "_popen"};
  pclose == func [val File; impure] val Void { extern "_pclose"};
  atoi == func [val ChStr;impure] val Short { extern "_atoi"};
  uninteresting == func [opc : val Short;impure] val Boolean {
	  (* things I don't ever need to see after reading in the quads	*)
	  (* NULLCAT is for things I don't need to see after all 
				the bbs have been set up *)
	    (opc = BSF) (* I think ?? *) cor
	    (opc = LBL) cor (opc = EXT) cor (opc = LBR) cor
	    (opc = DDT) cor (opc = FDT) cor
	    ((opc >= TFB) cand (opc <= ADT)) cor
	    ((opc >= ADI) cand (opc <= ABI)) cor (* integer ops *)
	    ((opc >= AND) cand (opc <= NOT)) cor (* boolean ops *)
	    (opc = ALS) cor (opc = LBA)

	};

  get_file == func [a : val Short; c : val ChStr; impure] val File {
		let file_name == ChStr$New [] in
			file_name := ChStr$"";
			if argc > a 
			then file_name := argv [a]
			fi;
			let file == File$open [file_name, c]
			in
			    if file = File$Null then
				write[File$stderr, "Can't open "];
				write[File$stderr, file_name];
				write[File$stderr, "\n"];
				write[File$stderr,
				      "Usage: src RIC_file out_RIC_file "
				       ^* "info_in info_out\n"];   
				exit[1];
			    fi;
			    file (* returned *)
			ni (* file *)
		 ni};

  in_file == let rawfile == get_file [2, "r"];
		 delab_cmd == ROOT_PATH ^* "/src/delab/delab " ^* argv [2]
	     in
		close [rawfile];
		let f == popen [delab_cmd, "r"]
		in if f = File$Null [] then write [File$stderr,
					"Problem opening 'delab' pipe\n"];
					exit [1]
		   fi;
		   f
		ni
	     ni;
	     
  Vflag == argv[1] = "-verbose";

  LBLS == extern {"labels"} [in_file, MAX_QUAD];
  labels == LBLS$Init [];

  precedingLBA == ChStr$New [];
  
  max_calls === 1000; (* ideally this will become a per function const *)
  Names === Array [max_calls, ChStr];
  fn_names == Names$New []; (* map for each function called in this file;
				for ARGs to find their function *)
  fn_callquads == (Array [max_calls, Short])$New [];
		    (* map of quadnums for calls corresponding to call nums *)
  next_call_num == Short$New [0];   (* for the maps of calls to fn names and
					to call quads *)

  FNprod == prod { name : val ChStr;
		   quad : val Short;
		   bsf : val Boolean;
		};
  fn_list == (List [FNprod])$New []; (* list of fns defined in the file;
		has to be made into textual order at a certain point for
		next_fst_qd arg to rsort to be correct *)
			(* this data is later incorporated into an array *)
  fn_count == Short$New [0]; (* essentially the length of the fn_list *)

  numcalls == Short$New [0] (* used only to choose SummaryIn table size -
				counts all CLCs and CLLs *)

(* all the above is needed on the first read of the quads *)

in

fn_list := (List [FNprod])$'';


do (not [ eof [in_file]]) cand (q < MAX_QUAD) ==>
	(* read the next quad, decide if dull, store 
	   also set up list of fns defined and array of fns called - these are
	   needed before classify can do it's work 
	  read.i also increments q if it successfully read and stored a quad *)

(*****************)
# include "read.i"
(*****************)

od;

pclose [in_file];

if q = MAX_QUAD then put ["\nInput file too big\n"]; exit [1] fi;

fn_list := reverse fn_list; (* to give textual order *)


(* now all the quads are in the array, and I know the dest of all branches
   and I have a list of the functions defined, in textual order *)

(* now I have to classify and sort out args *)
let (* declare stuff that covers all functions *)


    num_quads == V[q];	(* i.e. 0..(num_quads-1) array entries *)

    num_fns == V[fn_count];

  (* this record is used for info about "interesting" quads *)

    More == prod M {
	    cat : val Short;		(* category of the operation *)
	    x_var : val Short;		(* use depends on 'cat'. Usually it's
					   the var on the left of assignmt *)
	    other : val Ref Short;	(* depends on 'cat' *)

			(* other holds allocator size till DFsearch, after which
			   it holds alloc_num, and size goes in the component's
								    loctable *)

	    size : val Ref Short; (* only for allocators - shouldn't really
					use a whole field, but the previous 
					scheme, which used other for size, until
					the size went into the loctable, didn't
					work once I had interproc 
							(two big phases) *)
	    extra : val Short	(* last_var for hinted STIs !! *)
				(* call_index for ARGs and CLL and CLC *)
	};

    MA == Array [num_quads, More];
    more == MA$New [];

    extra == Short$New [];
    last_var == Short$New [FIRST_AVAIL_LOC - 1];
				(* records the highest var# seen so far *)

    hinted == Boolean$New [False]; (* true when hints apply to the next quad *)
    hint_type == Short$New [];
    hint_info == Short$New [];
    PTregister == Short$New [0] (* holds the special register number of 
					an arg which is hinted PT, so that
					it is seen when the call is to be
					classified *)

in   (* classify *)


(* process the summary files specified in the command line, entering in a 
   summary table
   any summary that refers to a function called in this file - look for it
   in the labels table.
	I think that these only need to be seen by classify *)
let ncalls == V [numcalls];
    SummaryIn == extern {"summary"} [ncalls / 10 + 5, Vflag];
    inputsummary == SummaryIn$Init [];
    SI == extern {"summaryio"}[];
in
    (* argv[4] is <dataflow input> arg *)
    if argc > 4 then
		SI$gather_summaries [argv 4, labels, inputsummary]
    fi;


    q := 0;
    next_call_num := 0;

    do q < num_quads ==>

    (* classify all non-dull quads - produce more entries for them *)
    (* use list of defined functions *)
    (* use inputsummary to help classify ARGs and CALLs to interfile fns *)
# include "classify.i"

	q += 1

    od;

ni; (* ncalls, SummaryIn *)

(* I now want to define an array for the functions (size = fn_count), with
   fields for name, DF_order of basic blocks, a map from basic blocks of this
   function to the quad number or however I want to represent bbs, and all 
   that other stuff.
	Then I need to gather all this information *)

let
    BB == prod B {
		quads : val QuadList;
		last : val Short;
		vlist : val List [Short]
	};

    max_bbs_per_fn == (num_quads / 6) + 100;
    BBArray == (Array [max_bbs_per_fn, BB]);
    bb == BBArray$New [];

    FNRec == prod {
		short : val Boolean; (* True for BSF functions *)
		quad : val Short; (* the quad that is the BFN/BSF *)
		name : val ChStr;
		numargs : val Short;
		basenode : val Short; (* Result node #; arg nodes follow *)
		bbs : val BBArray; (* in textual order with extra info *)
		bbsuccs : val (Array [max_bbs_per_fn, BBList]);
		bbpreds : val (Array [max_bbs_per_fn, BBList]);
		blist : val BBList; (* DF ordered list of the bbs *)
		rtn_bb : val Short; (* the bb that contains the RTN *)
		length : val Short; (* #bbs in the function *)
		};

    fn_array == (Array [num_fns, FNRec])$New [];

    Graph === extern {"graph"} [num_fns * 20, num_fns, Vflag];
    graph == Graph$Init [];

    next_interesting == func [q : val Short; impure] val Short {
	(* returns the number of the next interesting quad starting at q *)
		let r == Short$New [q]
		in
		    do  (r < num_quads) cand (dull [basics.r])
			==>
				r += 1
		    od;

		    (* now either r is interesting or r is num_quads *)
		    r
		ni
		};

    fn_index == Short$New [] (* for counting out the functions *)

in


OPEN (* debugging stuff *)
	let num_quads == V [q];
	    qq == Short$New [0]
	in
	    do qq < num_quads   ==>
		if (opc [basics.qq] = ARG)  ==>
			put ["ARG	"];
			if not dull [basics.qq] then
			   let m == more.qq in
				   if (cat [m] = ARGCAT) then
					put ["ARGCAT	"];
					put [x_var [m]];put "	";
					put [fn_names.(extra [m])];
					put [fn_callquads.(extra [m])]
				   else put [cat m];put " ????"
				   fi
			   ni
			else put ["NPed => dull"]
			fi;
			put "\n"

		#  (opc [basics.qq] = CLL) cor (opc [basics.qq] = CLC) cor
			(opc [basics.qq] = CLI) 		==>
		    let b == basics.qq;m == more.qq
		    in
			if (opc [b] = CLL) then put "CLL"
			elsif  (opc [b] = CLC) then put "CLC"
       			else   put "CLI"
			fi;
			if (cat [m] = MAYBEALC) then
				put "	MAYBEALC	";
				put [fn_names.(extra [m])]
			else put [cat [m]]
			fi;
			put "\n"
		    ni
		# else  ==> Null []
		fi;
		qq += 1
	    od
	ni; (* num_quads, qq *)

	let l == (List [FNprod])$New []
	in l := fn_list;
	   do not is_nil [l] ==>
		put [quad [head l]];
		put [name [head l]];
		put "first opc is ";put [opc [basics.(quad [head l])]];
		put " Short? ";put [bsf [head l]];
		put "\n";
		l := tail l
	   od
	ni;
CLOSE

(*****************************************************)


q := next_interesting [0];


fn_index := 0; (* fn_list is in textual 0,1,... order now *)
do fn_index < num_fns      ==>

    let fn_name == name [head fn_list];
	fst_qd == quad [head fn_list];
	short == bsf [head fn_list];

	next_fst_qd == if not is_nil [tail fn_list]
			then quad [head [tail fn_list]]
			else num_quads
		       fi;
	max_arg_num == Short$New [0];

	Rsort == (extern {"rsort"} [next_fst_qd]);
	leaders == Rsort$New [];
		(* uses an array of size next_fst_qd; next will return that
			value if it doesn't find another leader *)

	b == Short$New [];		(* indexes basic blocks *)

	BHash == (extern {"hash"}[(max_bbs_per_fn / 4) + 2, Short, Short, -1]);
	bbforldrs == BHash$Init [];
	(* used to find the bb# corresponding to the dest. of branches
	       when trying to link up the control flow;
	   computed when basic blocks are formed *)

    in
	(* find the leaders in this function *)
	(* since you are looking at all opcs, also find the highest # arg *)
	q := next_interesting [fst_qd (*+ 1*)];
	add [q, leaders];
	do (opc [basics.q]) <> RTN     ==>
	  let op == opc [basics.q]
	  in
	    if op = BR   ==> 
		    let dest ==	next_interesting[q_for_lbl_at [q, labels]]
		    in
			    add [dest, leaders]; (* dest of a branch *)
			    q := next_interesting [q + 1];

			    (* have to make following quad be a leader so it
				doesn't become part of this basic block;
				if it is dead code it will be discarded after
				the links have been made *)
			    add [q, leaders]
		    ni
	    #  (op = BRT) or
	       (op = BRF) ==>
		    let dest == next_interesting [q_for_lbl_at [q, labels]];
			follow == next_interesting [q + 1]
		    in
			add [follow, leaders]; (* follows a branch *)
			add [dest, leaders]; (* dest of branch *)
			q := follow
		    ni
	    #  (op = GAR) ==>
		    max_arg_num := MAX (max_arg_num, to_arg [arg1 [basics.q]]);
		    q := next_interesting [q + 1]
	    #  else     ==>	q := next_interesting [q + 1]
	    fi
	  ni
	
	od; (* loop through to end of function, finding leaders *)

(* end of finding leaders for this function *)
OPEN
	DEBUG("\nfinished finding leaders for fn #");put fn_index;
CLOSE

(****** Now build basic blocks *************)

(******* This is where I can build approx active vars lists - all vars active
	in each basic block. The resulting list becomes vlist for the bb *)
(*******  This is where I can work out consts within basic blocks - for each
	leader, set all live vars to not-const. Then for LDNs set value, and
	for MOVs copy values, and for ALH/ALA put the value, if const, into
	the other field *)

	let  (* declare things used only in the building process *)
	  last_in_fn == V[q]; (* RTN quad *)
	  l == Short$New [];
	  n == Short$New [];

	  qlist == QuadList $New [];
	  last_in_bb == Short$New [];

	  (* using max_var for all functions is a bit wasteful of space !! *)
	  max_var == last_var + 1;
	  VI == extern {"vars"} [max_var];
	      (* the following code does depend a little on the impl. of VI *)
	      (* e.g. for MOV if arg1 value is not a constant the operation
		makes arg2 not constant *)
	      (* because -1 represents NOTCONST, I CAN'T store -ve consts *)

	  (* VI$Init is not very expensive *)

	  vars == VI$Init [];

	in
	  l := next [fst_qd - 1, leaders]; (* ???????????????????????? *)
	  b := 0;		(* first basic block in this function *)

	  do l <= last_in_fn ==>

OPEN
	DEBUG("\nBEGIN bb whose leader is ");put [l];
	put "; opc is ";put [opc [basics.l]];
	put "; cat is ";put [cat [more.l]];
	DEBUG("\n");
CLOSE


	    insert [l, l, b, bbforldrs];	(* b is l's basic block *)

	    reset [vars];

	    qlist := QuadList $'';

	    (* for interesting quads l to before next leader (i.e. this bb) *)
	    n := next [l, leaders];
	    q := l;

	    (* last_in_bb doesn't need to be inited since this loop always 
							    iterates once ?? *)
	    do q < n ==>

		(* maintain active vars info and constants info *)

# include "varstuff.i"

		if cat [more.q] <> NULLCAT then 
				qlist := cons [q, qlist]
		fi; (* else no need to do all the apply stuff to them *)
		last_in_bb := q; 
		      (* the value remaining after this loop is the one used *)
		q := next_interesting [q+1]
	    od;

	    bb.b := BB$Mk [reverse qlist, last_in_bb, vs_out [vars]];
OPEN
	DEBUG("\nbb ");put [b];
	if is_nil [quads [bb.b]] then
		put " empty"
	else
		put " first quad :";put [head [quads [bb.b]]];
		put " first opcode : ";put [opc [basics.(head [quads [bb.b]])]];
	fi;
	put "\n"; 
	print [vars];
CLOSE

	    b += 1;
	    l := n	    
	  od; (* go to next leader/ basic block *)

	ni;(* last_in_fn, l, n, qlist, ... VI, vars *)

(* end of building basic blocks for this function -- bb is ready to store *)

OPEN
	DEBUG("\nFinished building basic blocks");
CLOSE

(* Now start linking preds and succs *)
(* bb 0 is the root for each function - bbs are numbered from 0 for each fn *)


      let  (* declare things needed when this function's info is stored *)
	    n_bbs == V[b];		(* 0 .. n_bbs - 1 *)
	    rtn_bb == Short$New [];
	    bbsuccs == (Array [max_bbs_per_fn, BBList])$New [];
	    bbpreds == (Array [max_bbs_per_fn, BBList])$New [];
	    blist == BBList $New [];

      in
	    (* initialise the bbsuccs and bbpreds *)
	    let nil == QuadList $''
	    in
		b := 0;
		do b < n_bbs ==>
		    bbsuccs.b := nil;
		    bbpreds.b := nil;
		    b += 1
		od
	    ni;

	    let link == func [p, r : val Short; impure] val Void {
		(* links p to r by adding p to r's predecessors and r to p's successors *)
		(* p and r are basic block numbers *)
			let ss == bbsuccs.p;
			    ps == bbpreds.r
			in
				ss := cons [r, ss];
				ps := cons [p, ps]
			ni
		}
	    in
		(* compute the ctrl edges by looking at opc's of 
					the last quad in each bb *)
		b := 0;
		do b < n_bbs ==>
		    let lq == last [bb.b];	(* last quad in bb *)
		  	op == opc [basics.lq];
		    in
		      if
			 op = BR   ==>
				let dest ==
				  next_interesting[q_for_lbl_at [lq, labels]];
				  b1 == lookup [dest, dest, bbforldrs]
				in
				    if b1 <> -1 then
					link [b, b1];
				    fi
				ni

		     #   (op = BRT) or
			 (op = BRF) ==>	
				(* both arms may end up at the same place since unint-
				   eresting quads are ignored. Only make one link. *)
				let b1 == b + 1; (* one branch *)
				    p2 == next_interesting[q_for_lbl_at 
								[lq, labels]];
				    b2 == lookup [p2, p2, bbforldrs] 
							(* other branch*)
				in
					if b1 <> b2  cand (b2 <> -1)
					then link [b, b2];
					fi;
					if b1 <> -1 then link [b, b1];
					fi
				ni

		     #	(op = RTN)    ==> rtn_bb := b    (* no successors *)

		     # 	else        ==>	(*for other quads preceding leaders*)
					if (b + 1) < n_bbs then
						link [b, b + 1]
					 fi

		      fi
		  ni; (* lq, op *)

	  b += 1
	od; (* go to next bb while b < n_bbs *)
	ni; (* link *)

	(* Remove dead basic blocks *)
	let nil == QuadList $''
	in
	    b := 1;(* bb 0 is not dead even though it has no preds *)
	    do b < n_bbs ==>
		if is_nil [bbpreds.b] then
		    let ss == QuadList $New []
		    in
			ss := bbsuccs.b;
			do not is_nil [ss] ==>
			    bbpreds.(head ss) := remove [b, bbpreds.(head ss)];
			    ss := tail ss
			od
		    ni
		fi;
		b += 1
	    od
	ni;

(* now all the flow info has been computed *)
OPEN
(***************** DEBUGGING OUTPUT ***************************)
		let b == Short$New [0];
		    block == BB$New []
		in
			do b < n_bbs ==>
				block := bb.b;
				put ["\nBasic Block "];put b;
(*				put ["\nvs "]; put_list [vlist [block]];
*)
				put [":\nquads "];put_list [quads [block]];
				put ["\npreds "];put_list [bbpreds.b];
				put [" succs "]; put_list [bbsuccs.b];

				b += 1
			od
		ni;
(*************************************************************)
CLOSE

(* end of computing control flow - info stored in bbsuccs, bbpreds *)
(* order them, record vars, locs ... *)

(* Now compute DF_order on the bbs, and compute other info at the same time *)

	let mark == (Array [n_bbs, Boolean])$New[];

	    (* recursive DFS *)
	    DFsearch == func [b : val Short; impure] val Void {

			let s == BBList $New[];
			in
			    mark.b := True;
			    s := bbsuccs.b;
		   	    do
		        	not is_nil [s] ==>
				    if not mark.(head s) then
						DFsearch [head s]
				    fi;
				    s := tail s
			    od
			ni;

			blist := cons [b, blist]

		} (* DFsearch func *)
	in
		(* initialise the mark array *)
		b := 0;
		do
		    b < n_bbs ==> mark.b := False;
		    b += 1
		od;
    
		blist := BBList $'';
		DFsearch [0]; (* computes blist *)
OPEN
DEBUG("\nOrdered bbs :");put_list blist;
CLOSE

	ni; (* mark, DFsearch *)

	if not short then max_arg_num := 1 fi; (* just the ar *)

(* This piece of code, and function_nodes were reworked to get around a bug
- base was a value returned by the fn, but it was getting ridiculous values *)
	let base == Short$New []
	in
	    base := if ONLYINTRA then 0 (* irrelevant *)
		    else

		function_nodes [fn_name, (*fn_index,*) max_arg_num, graph
	,base
									];
		(* creates nodes for the result and args, numbered from base *)
(*
put "The base (returned by function_nodes) is ";put base;put "\n";
*)
			base


		    fi;

	fn_array.fn_index := FNRec$Mk [short, fst_qd, fn_name, max_arg_num, 
					base, bb, bbsuccs, bbpreds,
						blist, rtn_bb, n_bbs]
	ni;

	(* end of doing stuff with this function *)
      ni; (* n_bbs, bbsuccs, bbpreds, blist *)


    ni; (* fn_name, fst_qd, leaders, b, bbforldrs *)

    fn_list := tail fn_list; (* the list of names and first quads *)
    fn_index += 1
od; (* go on to next function *)

(* all functions done - fn_array completely computed *)

OPEN
(* At this point I could check all the info for all the functions -
	name, firstqd, ordered bbs, other bb info, succs and preds .. *)
	fn_index := 0;
	put "************ CHECK all functions near end of prepass **********";
	do fn_index < num_fns ==>
	    let ff == fn_array.fn_index
	    in
		put "\n";
		put [name ff];put " length=";put [length ff];
		put " base=";put [basenode ff];
		put " blist is ";put_list [blist ff]
	    ni;
	    fn_index += 1
	od;
(*********************************************************************)
CLOSE

if not ONLYINTRA then

# include "firstpass.i" 
(* that processes all functions and builds the entire interprocedural graph *)

fi;

let
    SI == extern {"summaryio"} [];
    info_out_name == if argc > 5 then argv [5] else ChStr$"/dev/null" fi;
    summary_outfile == SI$Open [info_out_name, False];
    Summary === extern {"summary"} [num_fns, Vflag];
    (**********************************)
    file_summary == if ONLYINTRA then Summary$Init []
		    else Graph$flow [graph, summary_outfile]; (* returns an obj of type Summary *)
		    fi;
    (**********************************)

    UA == (extern {"out"} [num_quads, MAX_QUAD]);
    updates == UA$New []
in


    (****************************************************************)
    (**************   process each function *************************)
    (****************************************************************)
    OPEN
        DEBUG( "\nStart lastpass, function by function\n");
    CLOSE

    fn_index := 0;
    do fn_index < num_fns ==> 


(**********************)
# include "lastpass.i"

(* For this function, 
      quad by quad -
	use the file_summary to refine the classification of MAYBEALCs and ARGCATS
	record any real allocators and hinted STIs

      if there are any locs, do the RC and LOCS data flow,

      interpret the STI info

      interpret the DEA info

*)
(**********************)

      fn_index += 1

    od; (* loop through all functions *)

    (* output the program again, including any updates *)
    let out_file == get_file [3, "w"]
    in
	UA$write_file [Arg1type, Basics, BA, basics, updates, out_file]
;
Null []

    ni

ni (* Summary, file_summary, UA, updates *)
(* that was all the last pass stuff *)


ni (* B, ..., fn_array .. *)

ni (* let num_quads, num_fns *)

ni (* first let which declared everything down to uninteresting *)

(* This constitutes an initial attempt at implementing  *)
(* rational arithmetic in Russell.  Some of the         *)
(* algorithms are no doubt suboptimal.                  *)
(* Fractional representations are mormalized if length  *)
(* of den exceeds CUTOFF and denominators are positive. *)
(*							*)
(* functions defined for rat's				*)
(*	norm == func[val R] val R;			*)
(*      * == func[x,y: val R] val R;                    *)
(*      ** == func[x: val R; y: val Long] val R;        *)
(*	inv == func[val R] val R;			*)
(*	/ == func[x,y: val R] val R;			*)
(*	+ == func[x,y: val R] val R;			*)
(*	- == func[x,y: val R] val R;			*)
(*	put == func[val R] val R;			*)
(*	puts == func[val R] val ChStr			*)
(*	to_Float == func[val R] val Float;		*)
(*	In == func[val Long] val R;			*)
(*	compare == func[x,y: val R] val Boolean;	*)
(*	to_Long == func[val R] val Long;		*)

#define skip Null[]

func [] {
    let
	CUTOFF == Short$10;	(* max number of words allowed in
				   unnormalized rational *)

	xl == extern { "xlong" } [];

        (* modulus operation on nonnegative long integers *)
        % ==  func [x,y: val xl] val xl {
                  x - (x/y)*y
	      };

    in use xl in
        prod {n, d : val xl}
        with R {
            norm == func[x: val R] val R {
	     let
		nw == nwords[d[x]]
	     in
	      	if Long$Out[to_Long[nw]] > CUTOFF ==>
		    let
		    	divisor == gcd[n[x], d[x]]
		    in
		    	R$Mk[ n[x]/divisor, d[x]/divisor ]
		    ni;
		# else ==>
		    x
	        fi
	     ni
            };

            * == func[x,y: val R] {
                     norm[R$Mk[n[x]*n[y], d[x]*d[y]]]
		 };

	    ** == func[x: val R; y: val Long] {
		    let
			Y == xl$In[y]
		    in
			if Y >= 0 then
			    R$Mk[n[x]**Y, d[x]**Y]
			else
			    R$Mk[d[x]**(-Y), n[x]**(-Y)]
			fi
		    ni
		  };

	    inv == func[x: val R] {
		       if
			   n[x] >= 0 ==> R$Mk[d[x], n[x]]
		       #   else      ==> R$Mk[-d[x], -n[x]]
		       fi
		   };

	    / == func[x,y: val R] {
		     if n[y] >= 0 ==>
			norm[R$Mk[n[x]*d[y], d[x]*n[y]]]
		     # else ==>
			norm[R$Mk[-n[x]*d[y], -d[x]*n[y]]]
		     fi
		 };
		 
	    shift == func[x: val R; how_much: val Short] {
	    		if how_much >= Short$0 then
	    		  norm[R$Mk[shift[n[x],xl$In[how_much]], d[x]]]
	    		else
	    		  norm[R$Mk[n[x], shift[d[x],xl$In[-how_much]]]]
	    		fi
	             };

            + == func[x,y: val R] {
                     norm[R$Mk[n[x]*d[y] + n[y]*d[x],
                               d[x] * d[y]]]
		 };

	    - == func[x,y: val R] {
                     norm[R$Mk[n[x]*d[y] - n[y]*d[x],
                               d[x] * d[y]]]
		 };

            - == func[x: val R] {
		     R$Mk[-n[x], d[x]]
		 };

	    abs == func[x: val R] {
		       R$Mk[abs[n[x]],d[x]]
		   };

            put == func[x: val R] val R {
			put[R$puts[x]]; x
		   };

	    puts == func[x: val R] val ChStr {
			let
			    cd == gcd[n[x], d[x]];
			    den == d[x]/cd;
			    num == n[x]/cd;
			in
			    if den = xl$1 then
				puts[num];
			    else
				puts[num] ^* "/" ^* puts[den];
			    fi
			ni
		   };

            to_Float == func[x: val R] val Float {
                            to_Float[n[x]]/to_Float[d[x]]
			};

            In == func[x: val Long] val R {
                      R$Mk[from_Long[x], 1]
		  };

            compare == func[x,y : val R] {
                           let
                               diff == n[x]*d[y] - n[y]*d[x]
                           in
                               if
                                   diff > 0 ==> Short$1
                               #   diff < 0 ==> -Short$1
                               #   else     ==> Short$0
                               fi
                           ni
		       };

	    to_Long == func[x: val R] {
			   to_Long[n[x]/d[x]]
		       };

	    get_num == func[x: val R] {
			   to_Long[n[x] / gcd[n[x], d[x]]];
			};

	    get_den == func[x: val R] {
			   to_Long[d[x] / gcd[n[x], d[x]]];
			};

	    build == func[x,y: val Long] {
			norm[R$Mk[from_Long[x], from_Long[y]]]
		     };

	} hide { Mk; n; d; norm }
    ni ni
}

# include "defs.h"
(* Implements lists of objects, such as the list of objects that may be *)
(* referenced by a certain virtual register.				*)

(* NB July 14th : I am pretty sure that MEM_OBJ and NONE_OBJ are identical
   in effect, (making ANY and ALCNIL identical). Both represent non-heap
   objects.
   But the nodes MEMNODE and NONENODE are used differently : MEMNODE is
   a sink, while NONE is only a source.
   Perhaps MEM_OBJ and NONE_OBJ should be amalgamated (and ANY and ALCNIL)
   and the distinction between MEMNODE and NONENODE should be made clear *)

(* STACK_OBJ and STATIC_OBJ are effectively equivalent at the moment (July 14)
   because they both force DEAs to be with size 0, or if only they appear then
   there is no point in deallocing. But it might be useful to distinguish them
   later.  			*)

(* Things which point to nothing must have NONE_OBJ on their loclists
	(see "x := loci;if - then y := x else z := x fi;x := nil; y := nil"
	    It looks as though the y := nil kills the last ref to loci but
	y might not kill any references at all; thus oneloc must check for
	NONE on the list; init bb values are set to {NONE}, rather than {}.
*)

(* for objects that are not reference counted use negative nos.;
   keep MEM_OBJ as the lowest numbered  - easier to find 
	MEM_OBJ = -4 : if it appears on a list it means that nothing is
			really known about the objects that could be on the 
			list.
		There is no point having other objects on lists with 
		MEM_OBJ, but no harm either, except efficiency.
	NONE_OBJ = -3 : similar to MEM_OBJ; means variable might point to 
			a non-object (nil, uninit..). Can't deallocate if this
			appears.
	STACK_OBJ = -2 : similar to STATIC_OBJ, usedfor things taken off stack.
	STATIC_OBJ = -1 : if this appears on a list then any deallocation has
			to be with size = 0 because the object might not be a
			heap object. Or the fn which is returning, if it is an
			allocator, has to be flagged as being possibly not a
			heap object *)

(* the nil ref will indicate not_found, empty list --> top;
   bottom is made from num_locs (= list 1,2,3...)	*)

(* this file has full control over representation
	I think the lists are all ordered *)

(* note that because of the way locs.r uses these loclists, only LOCS$find and
   LOCS$look will see notfound values - they then fix it so that anyone else
   only sees top. Thus other functions need not cope with notfound, as things
   stand now *)

func [num_locs : val Short] {

    let
	exit == func [val Short; impure] val Void { extern "_exit" };

	LocTable === (Array [500, Short]);(* gives node # for representative
						of the size of alloc, or the
						result node for MAYBEALC fns *)
	LL == extend {(List [Short])} with S
	    {
		member == func [x : val Short; s : val S] val Boolean {
				if is_nil s then False
				elsif x = (head s) then True
				elsif x < (head s) then False
				else member [x, tail s]
				fi
			};

		any_member == func [s1, s2 : val S] val Boolean {
			if is_nil s1 then False
			else member [head s1, s2]
				cor any_member [tail s1, s2]
			fi
			};

		eq_lists == func [s1, s2 : val S] val Boolean {
				if is_nil s1 then
						is_nil s2
				elsif is_nil s2 then False (* <= s1 not nil *)
				else
					(head s1 = head s2) cand
				        eq_lists [tail s1, tail s2]
				fi
			};

		remove == func [s1, s2 : val S; neednone : var Boolean] val S {
			if is_nil s2  then s2
			elsif (head s2 > 0) (* real loc *) cand 
				member [head s2, s1] then
				(* remove head s2 from s2, and make sure that
					there is a none_obj on the final s2 *)
				neednone := True;
				remove [s1, tail s2, neednone]
			else cons [head s2, remove [s1, tail s2, neednone]]
			fi			
			};

		add_none == func [s : val S] val S {
			if (is_nil s) cor (head s) > NONE_OBJ then
					cons [NONE_OBJ, s]
			elsif (head s) = NONE_OBJ then s
			else cons [head s, add_none [tail s]]
			fi
			};

		mrg == func [s1, s2 : val S] val S {

			    if is_nil s1  ==> s2
			     # is_nil s2  ==> s1
			     # else   ==>
				 if  (head s1) < (head s2) ==>
					cons [head s1, mrg [tail s1, s2]]
				  #  (head s1) = (head s2) ==>
					cons [head s1, mrg [tail s1, tail s2]]
				  #  else   ==>
					cons [head s2, mrg [s1, tail s2]]
				fi
			    fi
			}
	     } (* with *)
    in
	(Ref [LL])
    with L {
	create == func [x : val List [Short]] val L {
		let v == LL$New []
		in 
		    v := LL$In [x];
		    L$In [v]
		ni
	    };

	(* creates a loclist from a single loc *)
	create == func [i : val Short] val L {
		  let c == LL$New []
		  in
		    (* if i > num_locs then exit [1] fi; *)
		    c := LL$cons [i, LL$''];
		    L$In [c]
		  ni
	    };

	(* to get a copy of the list, not just the ref cell - because 
		replace messes things up -- not used on june 29th !! *)
	copy == func [l : val L; impure] val L {
			let n == L$New [];
			    ll == LL$New[]
			in if l = L$notfound [] then n := L$notfound []
			   else
				ll := l^;
				n := L$In[ll]
			   fi;
			   n	(* returned *)
			ni
		    };

	(* this value is used for the hash table - if lookup produces notfound
		then find inserts a top value instead		*)
	notfound == func [] val L {L$Nil []};

	(* put this in-line *)
	isnotfound == func [l : val L; impure] val Boolean
			{ l = L$notfound };

	top == func [] val L (* ref to empty list *)
			{ L$create [(List [Short])$''] };

	is_top == func [l : val L;impure] val Boolean
			{LL$is_nil [l^]};

	(* this is used when putting things into memory to have a list of
		locs that mem_var could have - 
	     MEM_OBJ is used when taking things out of memory *)
	bottom == func [] val L { 
			let b == LL$New [];
			    i == Short$New []
			in
			    i := num_locs; (* to produce an ordered list *)
			    b := LL$'';
			    do i > 0 ==>
				b := cons [i, b];
				i -= 1
			    od;
			    L$In [b]
			ni
		 };

	(* used to make l1 refer to the list l2 refers to *)
	replace == func [l1, l2 : val L; impure] val Void
			{ l1^ := l2^ };

	member == func [x : val Short; l : val L;impure] val Boolean
			{ LL$member [x, l^] };

	any_member == func [l1, l2 : val L; impure] val Boolean
	(* is any element of l1 a member of l2 *)
			{ LL$any_member [l1^, l2^] };

	eq == func [l1, l2 : val L; impure ] val Boolean
			{ LL$eq_lists [l1^, l2^] };
	(* I depend on order - check that creates do it right *)

	removelocs == func [l1, l2 : val L;impure] val L {
		(* remove all real locs that are in l1 from l2, and if
			any are removed make sure to put in NONE_OBJ *)
		let need_none == Boolean$New [False];
		    removedlist == LL$remove [l1^, l2^, need_none];
		    finallist == if need_none then LL$add_none [removedlist]
				  else removedlist fi
		in
		    L$create [LL$Out [finallist]]
		ni
		};

	merge == func [l1, l2 : val L; impure] val L
			{ L$create [LL$Out [LL$mrg [l1^, l2^]]] };

	(* true if MEM or NONE appears *)
	unknown == func [l : val L; impure] val Boolean
			{ not is_nil [l^] cand ((head [l^]) = MEM_OBJ 
						cor (head [l^]) = NONE_OBJ)};

	(* it is feasible to look into deallocing a variable if its loclist
		l, represents some real locs (> 0) 
		but does not represent MEM_OBJ or NONE (i.e. not unknown) *)
	feasible == func [l : val L; impure] val Boolean
			{ not unknown [l]
			  cand 
			    (* there is an element > 0 *)
			    let t == LL$New []
			    in t := l^;
			       do not (is_nil [t]) cand [head t] <= 0 ==>
					t := tail t
				od;
				(* now if t is not nil, there is an elt > 0 *)
				not is_nil [t]
			    ni
			};

	(* if l is a one (real) location list return that  element,
					   		else return 0 *)
	oneloc == func [l : val L; impure] val Short {
		    (* if l is a one element list return that element *)
			let
			    lst == l^
			in
			    if (not is_nil [lst]) cand (is_nil [tail [lst]])
				cand (head [lst] > 0)
				(* i.e. neither MEM nor NON nor STATIC 
							    nor STACK there *)
			    then head [lst]
			    else 0
			    fi
			ni
		    };

	rc_map == func [l : val L; 
		     f : func [val Short;impure] val Void; 
 		    					impure] val Void {
	(* maps over all the real locs on the list - that is all the ones with 
		which there is an associated ref ct *)

			    let list == LL$New []
			    in
				list := l^;
				do not is_nil [list] ==>
				    if (head list) > 0 then f [head list] fi;
				    list := tail list
				od
			    ni
		};

	loc_map == func [l : val L; loctable : val LocTable;
		     f : func [val Short;impure] val Void; 
 		    					impure] val Void {
	(* maps over all locs for which there is a graph node,
	     mapping locs to graph nodes, and then applying
		the function f, -- for deciding about graph edges *)
			let list == LL$New []
			in
			    list := l^;
			    if not is_nil [list] then
				if (head list) = MEM_OBJ then
					f MEMNODE;
					list := tail list
				fi
			    fi;
			    if not is_nil [list] then
				if (head list) = NONE_OBJ then
					f NONENODE;
					list := tail list
				fi
			    fi;
			    if not is_nil [list] then
				if (head list) = STACK_OBJ then
					f STACKNODE;
					list := tail list
				fi
			    fi;
			    if not is_nil [list] then
				if (head list) = STATIC_OBJ then
					f STATICNODE;
					list := tail list
				fi
			    fi;
				(* now everything in list is something whose
					node can be found in loctable *)
			    do not is_nil [list] ==>
				    let node == loctable.(head list)
				    in
					f node
				    ni;
				    list := tail list
			    od
			ni
		};

	and_map == func [l : val L;
			 f : func [val Short; impure] val Boolean;
							 impure] val Boolean {
	(* this function is used to test if all locs on the list have rc = 1
		When it is called we already know that MEM or NONE are not on
		the list - these would preclude DEAllocation or functions from
		being ALLOCators (in is_alloc) *)

			    let list == LL$New [];
				value == Boolean$New [True]
			    in
				list := l^;
				do (value = True) cand (not is_nil [list]) ==>
				    if (head list) > 0
				    then value := f [head list]
				    fi;
				    list := tail list
				od;
				value
			    ni

		};

	print == func [l : val L; impure] val Void {
			if is_nil [l^] then put ["top"]
			else
			    let list == LL$New []
			    in
				list := l^;
				do not is_nil [list] ==>
					put [" "];
					put [head list];
					list := tail list
				od
			    ni
			fi;
			put ["\n"]
		};
 
	} (* with *)
      hide { In; Out; ^ (* which refer to LL *)}
    ni
   }

(* Compute      2**n the hard way.  Similar to tree_test.r, but *)
(* with a more conventional binary tree implementation.         *)
let
    SEXPR == union U { atom : val Short;
                       cn: val prod { hd: val U; tl : val U } }
	     with SE {
		car == func[x: val SE] val SE {
			  hd[to_cn[x]]
		       };
		cdr == func[x: val SE] val SE {
			  tl[to_cn[x]]
		       };
		cons == func[x,y: val SE] val SE {
			  SE$from_cn[
                            prod { hd: val SE; tl: val SE } $ Mk [x, y]
                          ]
		       };
		In == SE$from_atom;
		Out == SE$to_atom;
		atom == SE$is_atom  }
	        export { New; := ; V; car; cdr; cons; In; Out; atom };
	     
    x == Short$New[];
    t == SEXPR$New[]
in
    t := SEXPR$In[17];
    x := get[FS];
    do
	x > 0 ==>
	    t := cons[t, t];
	    x := x - 1;
    od;
    let
	Number_of_Leaves ==
	    func[ x: val SEXPR ]
		{
		    if  atom[x] ==>
			    1    
		    #   else ==>
			    Number_of_Leaves[car[x]] + Number_of_Leaves[cdr[x]]
                    fi
                }
    in
	put[ Number_of_Leaves[t] ]; put["\n"];
    ni
ni

let
    SIGINT == 2;
    i == Short$New[];
    intr_received == Signal[SIGINT];
in
    if
        intr_received ==> put "Caught one\n"; Unsignal[SIGINT]
    #   else ==> Null[];
    fi;
    do True ==>
        i := 0;
        do i < 1000 ==>
            Short$New[]; i += 1;
        od;
        put "x\n";
    od 
ni

# include "defs.h"
func [nodes : val Nodes;
	Nodes : type N { . : func [val N; val Short] val NodeInfo};
	NodeInfo : type NI {is_arg : func [val NI] val Boolean;
			    is_result : func [val NI] val Boolean} ] {

    let 
	ResultCode == extend {Short}

	    with S {

	top == func [] val S { S$In [TOP] };
	is_top == func [s : val S] val Boolean {S$Out [s] = TOP};

	none == func [] val S { S$In [NONENODE] };

	equal == func [s1, s2 : val S] val Boolean { s1 = s2 };

	meet == func [s1, s2 : val S] val S {
		if (s1 = S$In [MEMNODE]) cor (s2 = S$In [MEMNODE]) 
						then S$In [MEMNODE]
		elsif (s1 = S$In [TOP]) then s2
		elsif (s2 = S$In [TOP]) then s1
		elsif (s1 = s2) then s1
		(* neither is MEM nor TOP and they are not the same *)
		elsif (s1 = S$In [NONENODE]) cor (s2 = S$In [NONENODE])
					then S$In [MEMNODE] (* bottom *)
		elsif is_arg [nodes.(S$Out [s1])] cor is_arg [nodes.(S$Out [s2])]
					then S$In [MEMNODE] (* bottom *)
		(* for now STACK meet STATIC is STACK (i.e. don't distinguish)*)
		elsif (s1 = S$In [STACKNODE]) cand (s2 = S$In [STATICNODE]) 
							then s1
		elsif (s1 = S$In [STATICNODE]) cand (s2 = S$In [STACKNODE]) 
							then s2
		(* the meet of any pair of allocs, or an alloc with STATIC or
		   STACK is the generic alloc, which means something that can 
		   be freed with size unknown *)
		else S$In [GENERICNODE]
		fi
	    };

	apply == func [n : val Short (* a graph node *); s : val S] val S {

		(* meet the code for this node with s *)
		(* the code for fn result nodes is TOP - info just flows thro;
		   the code for argnodes and all other nodes is themselves *)

		let code == if is_result [nodes.n] then S$In [TOP]
			    else S$In [n]
			    fi
		in
			S$meet [code, s]
		ni
	    }
	} (* with *)
    in
	ResultCode 
	    export { New <<func [] var ResultCode>>; V; :=; Out;
				top; is_top; none; equal; meet; apply; put }
    ni
}

(* Integer modular arithmetic.  Returns a type that represents the  *)
(* ring of integers mod n.  We always represent an equivalence      *)
(* class by a number between 0 and n-1.                             *)
func[N: val Long] {
    let
	xl == extern {"xlong"} [];
	n == xl$from_Long[N];
    in use xl in
	extend { xl } hide {to_Long} with M {
	    times == func[x,y: val M] { M$In[Out[x * y] % n] };
	    plus == func[x,y: val M] { M$In[Out[x + y] % n] };
	    minus == func[x,y: val M] { M$In[n + Out[x - y] % n] };
	    neg == func[x: val M] { M$In[(n - Out[x]) % n] };
	    one == func[] {M$In[1]};
	    zero == func[] {M$In[0]};
	} with M {
	    * == M$times;
	    + == M$plus;
	    - == M$minus;
	    - == M$neg;
	    '1' == M$one;
	    '0' == M$zero;
	    from_Long == func[x: val Long] {
			      if x >= Long$0 then
				  M$In[from_Long[x]%n]
			      else
				  let
				      rem == (-from_Long[x])%n
				  in
				    M$In[
				      if rem = 0 then
					0
				      else
					n - rem
				      fi
				    ]
				  ni
			      fi
			 };
	    to_Long == func[x: val M] { to_Long[M$Out[x]] };
	} export M {+; *; put; puts; :=; V; from_Long; to_Long; =; <>;
		    New <<func[val M] var M>>; New <<func[]var M>>;
		    - <<func[x,y: val M]val M>>;
		    - <<func[val M]val M>>; '0'; '1';
		   }   
    ni ni
}

(* Compile with -p *)
#define L val Short
#define R val Short
#define L_to_R func[L]R

(*
 * Applicative Call-by-Value Least Fixed Point
 *)

let
    Y == 
            func[ h: func[ L_to_R ] L_to_R ] L_to_R {
               let
                  T == prod{ fn: func[ val T ] L_to_R } ;

                  f == func[ v: val T ] L_to_R {
                          h [
                             func[ x: L ] R {
                                ((fn[v])[v])[x]
                             }
                          ] 
                       }
               in
                  f[T$Mk[f]]
               ni
            } ;

         G == 
            func[ f: func[val Short] val Short ] {
               func[ n: val Short ] {
                   if
                     n > 0 ==>
                       n * f[n - 1]
                   # n = 0 ==>
                       1
                   fi
               }
            } ;

         ! == Y[G]

in

      put[6!]; put["\n"]

ni

(* Compile psexpr.r first.                                    *)
(* Test of binary tree data type.  Computes 2**m the hard way *)
let
    se == extern { "psexpr" };

    SEXPR == se[Short];
	     
    x == Short$New[];
    t == SEXPR$New[]
in
    t := SEXPR$nil;
    x := get[FS];
    do
	x > 0 ==>
	    t := cons[t, t];
	    x := x - 1;
    od;
    let
	Number_of_Leaves ==
	    func[ x: val SEXPR ]
		{
		    if  null[x] ==>
			    1    
		    #   else ==>
			    Number_of_Leaves[car[x]] + Number_of_Leaves[cdr[x]]
                    fi
                }
    in
	put[ Number_of_Leaves[t] ]; put["\n"]
    ni
ni

(* This should be compiled with -cpL *)
#define impure var Void

(*
 * Turn a function into one that remembers some previous arguments
 * and the corresponding results.
 * The function hash takes an argument of type T1 and produces
 * a Short integer >= 0 and < limit.
 *)
func[fn: func[val T1; impure]val T2; hash: func[val T1] val Short;
     limit: val Short; T1: type t {=; put: func[val t] val t};
     T2: type{}] func[val T1; impure] val T2 {
  let
    arg_res == prod {arg: val T1; result: val T2};
    table_entry == union {
                       present: val arg_res;
                       not_present: val Void;
		   }
                   with TE {
		       NNew == func[] {
				   let
				       x == TE$New[]
                                   in
                                       x := TE$from_not_present[Null[]];
				       x
				   ni
			       }
                   }
		   with TE {
		       New == TE$NNew;
		   };
    table_tp == Array[limit, table_entry];
    table == table_tp$New[];
  in
    func[x: val T1; impure] {
      let
	te == table.hash[x]
      in
        if
          is_present[te] cand arg[to_present[te]] = x  ==>
              result[to_present[te]]
        # else ==>
              let
		res == fn[x]
	      in
                te := table_entry$from_present[arg_res$Mk[x, res]];
		res
	      ni
	fi
      ni
    }
  ni
}
     

(* A faster version of factorial.  If you don't believe it, try 5000! *)

use Long in let
    (* Compute n * (n-m) * (n-2m) * ...  *)
    f == func[n, m: val Long] {
	    let
		k == 2 * m
	    in
		if n > m then
		    f[n, k] * f[n-m, k]
		else
		    n
		fi
	    ni
	 };
    
    ! == func[n: val Long] { f[n, 1] };
    x == Long$New[];
in
    do
	(put["Factorial of?"]; x := In[get[FS]]) >= 0  ==>  put[x!]; put "\n";
    od
ni ni

let
    size == 30000;
    A == (Array[size,Short])$New[];
    n == Short$New[];
    sum == Long$New[];
in
    n := 0;
    do
        n < size  ==>  A.n := n; n += 1
    od;
    n := 0;
    sum := Long$0;
    do
        n < size  ==>  sum := sum + Long$In[A.n]; n += 1
    od;
    put[sum]; put["\n"]
ni

let
    f == func[x: val T; T: type t{+ :  func[x,y:val t] val t;
				  New; New: func[val t]var t; V; := ;
				  put: func[val t] val t}] {
	    let
		y == New[x];
		z == T$New[];
	    in
		z := x;
		put[y (T$+) z]; put "\n"
	    ni
	 }
in
    f[13, Short];
    f[Long$13, Long];
    f[13.0, Float]
ni

(* Input/output of summary information for compilation units *)
func [] {
    let 
	TwoBits === prod { mem, thro : val Boolean };
	FnSumm === prod {
			code : val Short;
			size_or_argnum : val Short;
			numargs : val Short;
			args_summ : val (List [TwoBits])
		    };

	readw == func [val File; impure] val Short { extern "_getw" };
	writew == func [val Short; val File; impure] val Void {extern "_putw"};
	exit == func[n: val Short; impure] val Void { extern "_exit" };

	reverse == func [l : val (List [TwoBits])] val (List [TwoBits]) {
		    let l1 == (List [TwoBits])$New [];
			lres == (List [TwoBits])$New []
		    in
			l1 := l;
			lres := (List [TwoBits])$'';
			do not is_nil [l1] ==>
				lres := cons [head l1, lres];
				l1 := tail l1
			od;
			lres
		    ni
		}
    in
	extend {File}
	with SF {
	Open == func [name : val ChStr; read : val Boolean; impure] val SF {
		let f == File$open [name, (if read then "r" else "w" fi)]
		in
		    if f = File$Null [] then 
			write [File$stdout, "Failed to open "];
			write [File$stdout, name];write [File$stdout, "\n"];
			exit[1]
		    fi;
		    SF$In [f]
		ni
		};

	read_ct == func [sf : val SF; impure] val Short {
		readw [SF$Out [sf]]
		};

	read_name == func [sf : val SF; impure] val ChStr {
		let c == ChStr$New [];
		    res == ChStr$New [ChStr$'']
		in
		    c := readc [SF$Out [sf]];
		    do (c <> ChStr$In [0]) cand not [eof [SF$Out [sf]]] ==>
			res := res ^* c;
			c := readc [SF$Out [sf]]
		    od;
		    res
		ni
		};

	read_summ == func [sf : val SF; impure] val FnSumm {
		let f == SF$Out [sf];
		    code == readw [f];
		    soa == readw [f];
		    numargs == readw [f];
		    n == Short$New [numargs];
		    tb_list == (List [TwoBits])$New [];
		    readbool == func [f : val File; impure] val Boolean
				{readb [f] <> 0}
		in
		    tb_list := (List [TwoBits])$'';
		    do n > 0 ==>
			let m == readbool [f];
			    t == readbool [f]
			in
			    tb_list := cons [TwoBits$Mk [m,t], tb_list]
			ni;
			n -= 1
		    od;

		    FnSumm$Mk [code, soa, numargs, reverse [tb_list]]
		ni
		};

	discard_summ == func [sf : val SF; impure] val Void {
		let f == SF$Out [sf]
		in
		readw [f](*code*); readw [f](*size or argnum*);
		let n == Short$New [readw f]
		in
		    do n > 0 ==> (* read the boolean bytes *)
			readb [f]; readb [f];
			n -= 1
		    od
		ni
		ni
		};

	(* Read all summary information contained in the named file *)
	gather_summaries ==
		func [name : val ChStr;
		      labels : val LB; summary : val SU;
		      LB : type L {exists : func [val ChStr; val L; impure]
		      				 val Boolean};
		      SU : type S {append : func [val ChStr; val FnSumm; val S;
		         			  impure] val Void};
		      impure] val Void {
	    let sf == SF$Open [name, True]
	    in
		do not eof [sf] ==>
		    let fnname == SF$read_name [sf]
		    in
		      if not [eof [sf]] then
		      if exists [fnname, labels] then (* it's probably called
							in the current file, 
							and worth reading info*)
			append [fnname, SF$read_summ [sf], summary]
		      else SF$discard_summ [sf]
		      fi
		      fi
		    ni;
	        od;
	    SF$close [sf]
	    ni
	  };

	write_summ == func [name : val ChStr; fs : val FnSumm; sf : val SF;
							impure] {
		let f == SF$Out [sf]
		in
		write [f, name];
		writeb [f, 0]; (* terminating null *)
		writew [code fs, f];
		writew [size_or_argnum fs, f];
		writew [numargs fs, f];
		let tb_list == (List [TwoBits])$New [];
		    writebool == func [f : val File; b : val Boolean]
				{writeb [f, if b then 1 else 0 fi]}
		in  tb_list := args_summ fs;
		    do not is_nil [tb_list] ==>
			writebool [f, mem [head tb_list]];
			writebool [f, thro [head tb_list]];
			tb_list := tail tb_list
		    od
		ni
		ni
		}
   } (* with *)
  ni
}

(*
 * This implements a numeric type equivalent to the constructive reals.
 * Rational arithmetic is used whenever possible to save time.
 * Everything is rational unless one of several things happens - these things
 * are currently ill-defined.  Most functions act the way other languages
 * handle integers and floats for rationals and reals, respectively.  That
 * is, operations on rats use rat ops, but operations which have any real
 * operands use the reals operations and convert any rationals to real.
 *)

#define skip Null[]

func [] {
    let
	xlong == extern { "xlong" } [];
	cr == (extern { "cr/cr" } []) with r { '1' == func[] {r$In[Long$1]} };
	Rat == extern { "cr/rat" } [];

	to_cr ==
	    func[x: val Rat] val cr {
		cr$In[get_num[x]] / cr$In[get_den[x]];
	    };
		
	to_cr == func[x: val cr] val cr { x };

	fusion == union {
		    creal: val cr;
		    rat: val Rat
		  }
	with F {
	    conv_to_cr ==
		func [x: val F] val cr {
		    if is_rat[x] ==>
			to_cr[to_rat[x]];
		    # else ==>
			to_creal[x];
		    fi
		};

	    force_cr_rep ==
		(* Return x represented as a constructive real *)
		func [x: val F] val F {
		    if is_rat[x] ==>
			F$from_creal[to_cr[to_rat[x]]]
		    # else ==>
			x
		    fi
		};

	    new_bifunc ==
		func [f: func[x,y: val Rat] val Rat;
		      g: func[x,y: val cr] val cr]
		{
		    func[x,y: val F] val F {
			if (is_rat[x] cand is_rat[y]) ==>
			    F$from_rat[f[to_rat[x],to_rat[y]]];
			# else ==>
			    F$from_creal[g[conv_to_cr[x],conv_to_cr[y]]];
			fi
		    }
		};

	    new_unfunc ==
		func [f: func[val Rat] val Rat;
		      g: func[val cr] val cr]
	        {
		    func[x: val F] val F {
		        if (is_rat[x]) ==>	F$from_rat[f[to_rat[x]]];
		        # else ==>		F$from_creal[g[to_creal[x]]];
		        fi
		    }
		};

	    new_unfunc ==
		func [f: func[val Rat] val Rat;
		      g: func[val cr; impure] val cr]
	        {
		    func[x: val F; impure] val F {
		        if (is_rat[x]) ==>	F$from_rat[f[to_rat[x]]];
		        # else ==>		F$from_creal[g[to_creal[x]]];
		        fi
		    }
		};

	    (* Exponentiation.  Assumes positive base. *)
	    power == func[x,y: val F; impure] val F {
		      let
			den == Long$New[];  (* denominator of exponent *)
			num == Long$New[];
			dir_cutoff == Long$500;
			    (* For bigger exponents use logs *)
		      in use Long in
			if is_rat[y]
			   cand ((den := get_den[to_rat[y]]) = 1
				 cor (den = 2))
			   cand (((num := get_num[to_rat[y]]) <= dir_cutoff)
				 cand (num >= -dir_cutoff)
				 cor (is_rat[x]
				      cand get_den[to_rat[x]] = 1)) then
			   if is_rat[x] then
			      let
				int_power == to_rat[x] ** num;
			      in
				if den = 1 then
				    F$from_rat[int_power]
				else
				    sqrt[F$from_rat[int_power]]
				fi
			      ni
			   else (* irrational, nice exponent *)
			      let
				pos_num == if num >= 0 then num else -num fi;
				pos_power == extern{"cr/exp"}
						    [to_creal[x], pos_num];
				int_power == if num >= 0 then
						 pos_power
					     else
						 cr$inv[pos_power]
					     fi;
			      in
				if den = 1 then
				    F$from_creal[int_power]
				else
				    F$from_creal[sqrt[int_power]]
				fi
			      ni
			   fi
			else  (* Need to use logs *)
			   F$from_creal[cr$exp[conv_to_cr[y]
					       * ln[conv_to_cr[x]]]]
			fi
		      ni ni
		     };

	    conv_crfunc ==
		func[f: func[val cr; impure] val cr] {
		    func[x: val F; impure] {
			F$from_creal[f[conv_to_cr[x]]];
		    }
		};

	    conv_crfunc ==
		func[f: func[val cr] val cr] {
		    func[x: val F] {
			F$from_creal[f[conv_to_cr[x]]];
		    }
		};

	    + == F$new_bifunc[Rat$+, cr$+];
	    * == F$new_bifunc[Rat$*, cr$*];
	    - == F$new_bifunc[Rat$- <<func[x,y: val Rat]val Rat>>,
			      cr$- <<func[x,y: val cr]val cr>>];
	    / == F$new_bifunc[Rat$/, cr$/];
	    - == F$new_unfunc[Rat$- <<func[val Rat]val Rat>>,
			      cr$- <<func[val cr]val cr>>];
	    inv == F$new_unfunc[Rat$inv, cr$inv];
	    abs == F$new_unfunc[Rat$abs, cr$abs];

	    In ==
		func[x: val Long] val F {
		    F$from_rat[Rat$In[x]];
		};

	    (* if a rational's numerator or denominator is "too big" it's
		printed as a real *)
	    put ==
		func[x: val F; prec: val Long; impure] val Void {
		    if is_creal[x] ==>
			cr$put[to_creal[x],prec]; skip;
		    # is_rat[x] ==>
			let px == to_cr[to_rat[x]]
			in
			    cr$put[px,prec]; skip;
			ni;
		    # else ==>	(* should never happen *)
			Rat$put[to_rat[x]]; skip;	(* throw away prec *)
		    fi
		};

	    puts ==
		func[x: val F; prec: val Long; impure] val ChStr {
		    let s ==
		    	    if is_creal[x] then
				cr$puts[to_creal[x],prec];
		    	    else
				let px == to_cr[to_rat[x]]
				in
				    cr$puts[px,prec];
				ni;
			    fi;
		    in
			s
		    ni
		};
		
	    most_significant_bit_pos == 
	        func[x: val F; min: val Short; impure] {
	            if is_creal[x] then
	                cr$most_significant_bit_pos[to_creal[x], min]
	            else
	                let px == to_cr[to_rat[x]]
			in
			    cr$most_significant_bit_pos[px,min];
			ni
		    fi
	        };
	        
	    shift == 
	        func[x: val F; how_much: val Short; impure] {
	            if is_creal[x] then
	                F$from_creal[cr$shift[to_creal[x], how_much]]
	            else
	                F$from_rat[Rat$shift[to_rat[x], how_much]]
		    fi
	        };

	    hex_puts ==
		func[x: val F; prec: val Long; impure] val ChStr {
		    let s ==
		    	    if is_creal[x] ==>
				cr$hex_puts[to_creal[x],prec];
		    	    # is_rat[x] ==>
				let px == to_cr[to_rat[x]]
				in
				    cr$hex_puts[px,prec];
				ni;
			    # else ==>	(* should never happen *)
				"BLEAGH!";
			    fi;
		    in
			s
		    ni
		};

	    sqrt == F$conv_crfunc[cr$sqrt];
	    exp == F$conv_crfunc[cr$exp];
	    ln == F$conv_crfunc[cr$ln];
	    sin == F$conv_crfunc[cr$sin];
	    cos == F$conv_crfunc[cr$cos];
	    atan == F$conv_crfunc[cr$atan];

	    pi == func[impure] val F {
		F$from_creal[cr$pi[]];
	    };

	    . == func[w,f,l: val Long; impure] val F {
		let
		    scale_factor == to_Long[(xlong$10)**(xlong$from_Long[l])];
		in
		    F$from_rat[Rat$build[w * scale_factor + f, scale_factor]]
		ni
	    };

	    to_Long == func[x: val F; tol: val Long; impure] {
		if is_rat[x] ==>
		    Rat$to_Long[to_rat[x]];
		# else ==>
		    cr$to_Long[to_creal[x], tol];
		fi
	    };

	    compare == func[x,y: val F; r,a: val Long; impure] val Short {
		if is_rat[x] cand is_rat[y] ==>
		    Rat$compare[to_rat[x],to_rat[y]];
		# else ==>
		    cr$compare[conv_to_cr[x],conv_to_cr[y],r,a];
		fi
	    };
	    eager == func[x: val F] val F {
		if is_rat[x] ==>
		    x
		# else ==>
		    F$from_creal[eager[to_creal[x]]]
		fi
	    };
	}
    in
	fusion
	export { New; :=; V; +; *; /; .;
		 - <<func[x,y: val fusion]val fusion>>;
		 - <<func[val fusion]val fusion>>;
		inv; abs; In; put; puts; cos; sqrt; exp;
		sin; atan; 
		ln;
		pi;
		power; eager;
		to_Long; compare; is_rat;
		hex_puts; force_cr_rep;
		most_significant_bit_pos; shift;
	      }
    ni
}

(* Generic exponential with Long exponent.  Uses O(log n) multiplications *)

# define IMPURE
# undef IMPURE

# ifndef IMPURE
#   define impure
# endif

(* Compute y^x, x >= 0 *)
func[y: val T; x: val Long;
     T : type t {New; := ; V;
		 * : func[x,y: val t; impure] val t;
		 '1': func[] val t};
     impure] val T {
   let
     (* curr_exp == Long$New[]; *)
     curr_power == T$New[];
     curr_result == T$New[];
     rem_x == Long$New[];
   in use Long in
     (* curr_exp := 1; *)
     curr_power := y;
     curr_result := T$'1'[];
     rem_x := x;
     do rem_x > 0 ==>
       (* curr_result * y^(rem_x*curr_exp)  =  y^x *)
       (* curr_power = y^curr_exp *)
       if odd[rem_x] then
	   (* rem_x -= 1; *)
	   curr_result := curr_result * curr_power
       fi;
       (* curr_exp *= 2; *)
       rem_x := shift[rem_x, -1];
       curr_power := curr_power * curr_power;
     od;
     curr_result
   ni ni
}

let
    j == Long$17
in
  trace := True;
  put[
      Callcc[
        func[ cc: func[ val Short] val Void; var Void ] val Short {
            let
                i == Short$New[];
                j == Short$New[];
            in
                put "Got to the body\n";
                j := 13;
                put "Forcing garbage collection:\n";
                do i < 20000 ==>
                    Short$New[]; i += 1;
                od;
                put "Finished allocating ";
                put i;
                put " objects\n";
                cc[j];
                0
            ni
        }
      ]
  ];
  put "\n";
  put "The last line should have contained a 13\n";
  put j;
  put "\nThe last line should have contained a 17\n";
ni

rm *.o
rm datatypes/*.o
# rm delab/*.o
rm gc/*.o
rm lib/*.o
rm pass1/applinfer/*.o
rm pass1/parser/*.o
rm pass1/scanner/*.o
rm pass1/stt/*.o
rm pass2/*.o
rm pass3/*.o
rm pass4/*.o
rm pass5c/*.o
rm pass5d/*.o
# rm RIC_filter/*.o
# rm RIC_to_C/*.o
rm root/*.o
rm sigio/*.o
rm stree/*.o
# rm utilities/*.o

# Highly language dependent "optimizer"
# Assumptions -
#  - #COMP and #--- are used only as advertised in initenv.doc
#  - #ADD and #SUB are used as in initenv.r
#  - locations beyond the top of the stack are dead
#    except for between multiple instructions on #COMP line
#  - only #COMP lines may contain more than one instruction
#  - only instructions whose mnemonic starts with a 'j' rely on condition
#    codes
BEGIN           { push_suppressed = 0;
		  cc_not_set = 0;
		  suppressing = 0;
		  clobber_next = 0;
		}

suppressing > 2 { # in the middle of suppressing comparison
		  suppressing--;
		  suppressed[supp_size - suppressing] = $0;
		  next;
		}

/.*---/         { # runtime check - removed by optimizer
		    next;
		}

/.*/            { if (clobber_next) {
		      clobber_next = 0;
		      next;
		  }
                  if ($1 ~ /[0-9a-zA-Z_]*\:/) i = 2
		  else i = 1
		}

suppressing == 2  { if ($i == "movl" && $(i+1) == "(sp)+,r0") {
			suppressing--;
			suppressed[supp_size - 1] = $0;
			next;
		    } else {
			suppressing = 0;
			for (j = 0; j < supp_size - 1; j++) {
			    print suppressed[j];
			}
			print $0;
			next;
		    }
		  }
		    

suppressing == 1  { suppressing = 0;
                    if ($i == "jeql") {
			printf "\t%s\t%s\n", comp_op, $(i+1);
			next;
		    } else {
			for (j = 0; j < supp_size; j ++) {
			  print suppressed[j];
			}
			print $0;
			next;
		    }
		  }

/#COMP/           { # start of comparison
	            # suppress instructions following this one
		    if (push_suppressed) {
			printf "\tpushl\t%s\n", push_arg;
			push_suppressed = 0;
		    }
		    j = 1;
		    while ($j != "#COMP") { j++ };
		    suppressing = $(j+2) + 1;
		    comp_op = $(j+1);
		    supp_size = suppressing - 1; # of instructions stored
		  }

/#ADD/		  { if (push_suppressed) {
			printf "\taddw2\t%s,(sp)\n", push_arg;
			push_suppressed = 0;
			clobber_next = 1;
			next;
		    }
		  }

/#SUB/		  { if (push_suppressed) {
			printf "\tsubw3\t(sp),%s,(sp)\n", push_arg;
			push_suppressed = 0;
			clobber_next = 1;
			next;
		    }
		  }

$i == "pushl"   { # generate push only if next line is not a "pop"
		      if (push_suppressed) {
			  printf "\tpushl\t%s\n", push_arg;
		      }
		      push_arg = $(i+1);
		      push_suppressed = 1;
		      if (i == 2) { # emit label
			printf "%s\n", $1
		      }
		      next;
		}

($1 == "movl") && ($2 ~ /\(sp\)\+,.*/) {
		  # This is a "pop"
		    if (push_suppressed) {
			operands = $(i+1);
			dest = substr(operands,7,50);
			if (push_arg != dest) {
			    printf "\tmovl\t%s,%s\n", push_arg, dest;
			} else {
			    cc_not_set = 1;
			}
			push_suppressed = 0;
			next;
		    }
		}

($i ~ /j.*/)    { # Looks like a branch instruction
		  if (cc_not_set) {
		      printf "\ttstl\t%s\n", dest;
		  }
		}

		{ if (push_suppressed) {
		      push_suppressed = 0;
		      printf "\tpushl\t%s\n", push_arg;
		  }
		  print;
		  cc_not_set = 0;
		}
